      PROGRAM ALPS42
CCC
CCC                ************************
CCC                *    >>>  ALPS  <<<    *
CCC                ************************
CCC
CCC   << Automatic Local (L-dependent) Potential Search >>
CCC                                    programmed by Y.Iseri.
C     '83. 3. -- original sakusei              (Ver.1)
C     '84. 5. -- FORT77   kakikae              (Ver.2)
C     '85. 5. -- rel.corr., ten.pol.           (Ver.3)
C     '85.12.-'86. 1. -- WS-der.SO., grid      (Ver.3.2)
C     '96. 9. -- Work-Station (SUN) Version    (Ver.4)
C     '97. 3. -- Exp.data Normalization
C     '98. 7. -- Output final results to FILE
C                Potential Read "PREAD2"      (Ver.4.1)
C     '98. 9. -- bug correction               (Ver.4.1a)
C         10. -- rel.corr. (Newton type)      (Ver.4.1b)
C     '99. 9. -- rel.corr. (simplified)       (Ver.4.1c)
C    2001. 3. -- double Woods-Saxon           (Ver.4.2)
C    2001.11. -- minor bug correction         (Ver.4.2a)
C    2002.12. -- g77 warning correction 
C                PLMFUN  reviced              (Ver.4.2b)
C    2003. 8. -- minor bug correction         (Ver.4.2c)
C                    read exp. data
C    2004. 1. -- minor bug correction         (Ver.4.2d)
C                    derivative of imag. LS (Watson type)
C                CODATA recommended values are used for basic constants
C                add rel.corr. (Yahiro type)
C    2004. 6. -- modify sub ELEMNT           (Ver.4.2e)
C
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER CMREAD*40,ENDCOD*6
      DIMENSION PAGRID(3,2)
      DIMENSION KPASER(50),DELEX(5,2),START(20)
      DIMENSION KFOLD(4)
      DIMENSION XPARM(20),CXP(20,21)
      DIMENSION XILOC(20),DXLOC(20),PHYLOC(20),ZLOC(20),WLOC(20)
C
      COMMON /CONTRL/ KSERCH,KAISMX,DCHIMN,INTGWF,KRUTAB,KCHISQ,KTXNOR
     1               ,KTLOUT,KFLOUT
      COMMON /BASIC/ PMASS,TMASS,PZZ,TZZ,PSPIN,TSPIN
     1              ,ELAB,ECM,FKAY,ETA,ZZHCAL,FFMM,DDRR,NRMAX
     2              ,LMAX,NTHMAX,IDENT
      COMMON /PARA/ PARM,PARMNX,NSPMAX,NPARMX,KTPARA,KPREIM,KSPLJD
      COMMON /XSPL/ THETAD,AXTH,RXTH,XSEX,DXEX,POLTH,POLEX,DPEX,REACX
      COMMON /CHIXP/ XCHI,PCHI,XCHIT,PCHIT,CHISQT
      COMMON /POTPAR/ V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI
     1               ,V2R0A,VDR0A,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX
     2               ,V0R0A2,W0R0A2,KSOTYP,KNXTYP
      COMMON /POTEN/ UCE,USO,ULJ,VCL,FLJFAC
      COMMON /POTFLD/ VFOLD,WFOLD,VSFOLD,WSFOLD
      COMMON /SMATRX/ SMAT,DSMAT
      COMMON /SAMP/ FNC
      COMMON /STORE/ EXSIG2,FCL,VUCL,DUCL,PLM,RUTX,SIGMA0
      COMMON /TENSOR/TPOL,TANL
      COMMON /DIMNSN/ NPARDM,NRDIM,NTHDIM,NTHDMP
     1               ,LDIM,MDIM,NUEDM1,NUEDM2,NJDIM
C
      DIMENSION KTLOUT(18),KFLOUT(12)
      DIMENSION PARM(50),PARMNX(50,3)
     1         ,KTPARA(20,50),KPREIM(50),KSPLJD(20)
      DIMENSION THETAD(245),AXTH(245),RXTH(245),XSEX(241),DXEX(241)
     1         ,POLTH(245),POLEX(241),DPEX(241)
      DIMENSION XCHI(241),PCHI(241),CHISQT(2)
      DIMENSION V0R0A(3,2),W0R0A(3,2),WDR0A(3,2),R0COUL(2)
     1         ,VSR0A(3,2),WSR0A(3,2),FNRNI(2,2),V2R0A(3,2),VDR0A(3,2)
     2         ,FL0AL(2,2),VLDR0A(3,2),WLDR0A(3,2),FSNRNI(2,2),FNXSEX(2)
     3         ,V0R0A2(3,2),W0R0A2(3,2),KSOTYP(2)
      COMPLEX*16 UCE(504),USO(504),ULJ(504)
      DIMENSION VCL(504),FLJFAC(206)
      DIMENSION VFOLD(504),WFOLD(504),VSFOLD(504),WSFOLD(504)
      COMPLEX*16 SMAT(206,4),DSMAT(20,206,4)
      COMPLEX*16 FNC(245,4,2)
      COMPLEX*16 EXSIG2(206),FCL(245),VUCL(206,2),DUCL(206,2)
      DIMENSION PLM(245,206,4),RUTX(245),TEMP(245,3)
      DIMENSION TPOL(245, 4),TANL(245, 4)
C
      COMMON /ANGMOM/ FACLOG(650),NFLMAX,MEMOAM
CCC ====================================
C
      NSPDIM= 20
      NSPDM1= NSPDIM +1
      NPARDM= 50
      NRDIM= 504
      NTHDIM= 241
      NTHDMP= 245
      LDIM= 206
      MDIM= 4
      NUEDM1= 4
      NUEDM2= 2
      NJDIM= 4
C           NUEDM1=NJDIM= 2S+1, NUEDM2= INT(S)+1
C
      NFLMAX= 650
      MEMOAM= 0
C --- NUMPAR ---> NUMBER OF PARAMETERS ---
      NUMPAR= 41
C
C --- FILE OPEN --------------------------
C     CALL FOPEN
      CALL FOPEN2
C ----------------------------------------
C
C --- INITIAL VALUES -----
      CALL INIT(NUMPAR,PMASS,TMASS,PZZ,TZZ,PSPIN,TSPIN
     1      ,DDRR,MATCHR,LMAX,IDENT1
     2      ,KSERCH,KAISMX,DCHIMN,INTGWF,KCHISQ,CHI2MN,PAGRID
     3      ,PARM,PARMNX,KPASER,NTHMAX,KRUTAB,DELEX,KFOLD,KSOTYP,KNXTYP
     4      ,THETAD,XSEX,DXEX,POLEX,DPEX
     5      ,KTLOUT,KFLOUT,NTHDIM,NTHDMP,NPARDM)
C -----
C
 1111 CONTINUE
      CALL CLOCKM(KT1)
C --- READ INPUT PARAMETERS -----
      CALL INPUT(PMASS,TMASS,PZZ,TZZ,PSPIN,TSPIN
     1          ,ELAB,DDRR,MATCHR,LMAX,IDENT1,KNTLE
     2             ,KSERCH,KAISMX,DCHIMN,INTGWF,KCHISQ,CHI2MN,PAGRID
     3             ,PARM,PARMNX,KPASER,NTHMAX,KRUTAB,KFOLD,KSOTYP,KNXTYP
     4             ,THETAD,XSEX,DXEX,POLEX,DPEX,DELEX
     5             ,KTLOUT,KFLOUT,CMREAD
     6                       ,NUMPAR,NTHDIM,NTHDMP,NPARDM, KTLEND)
C -----
C
C --- READY -----
      CALL READY(PMASS,TMASS,PZZ,TZZ,PSPIN,TSPIN,ELAB,DDRR,IDENT1
     1                ,KSERCH,MATCHR,LMAX,NTHMAX,NUMPAR,KRUTAB,KCHISQ
     2                ,KNTLE,KPASER,PARM,PARMNX,THETAD,KFOLD,PAGRID
     3                ,DELEX,AXTH,RXTH,XSEX,POLTH,POLEX,DXEX,DPEX
     4          ,NRDIM,LDIM,MDIM,NUEDM1,NTHDIM,NTHDMP,NPARDM,NSPDIM
     5       ,FFMM,ECM,FKAY,ETA,RMASS,RMASC2,ZZHCAL,NRMAX
     6       ,RMASNR,ECMNR,FKAYNR
     7       ,NPARMX,NSPMAX,IDENT
     8       ,KTPARA,KPREIM,KSPLJD,START,XPARM,KTXNOR
     9       ,PLM,EXSIG2,FCL,RUTX,VUCL,DUCL,SIGMA0
     1       ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     2       ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2
     3       ,VFOLD,WFOLD,VSFOLD,WSFOLD)
C -----
C
C --- WRITE INPUT PARAMETERS -----
      CALL IWRITE(PMASS,TMASS,PZZ,TZZ,PSPIN,TSPIN,IDENT
     1           ,KNTLE,ELAB,ECM,FFMM,FKAY,ETA,RMASS,RMASC2,DELEX
     2           ,RMASNR,ECMNR,FKAYNR
     3           ,LMAX,NTHMAX,DDRR,MATCHR,NRMAX,NPARMX,NSPMAX
     4   ,KSERCH,KAISMX,DCHIMN,INTGWF,KRUTAB,KCHISQ,CHI2MN,KFOLD,KTXNOR
     5   ,KTPARA,KPREIM,KSPLJD,KTLOUT,KFLOUT,CMREAD
     6   ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     7   ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2,KSOTYP,KNXTYP
     8   ,PARMNX,KPASER,PAGRID        ,NSPDIM,NPARDM)
C -----
C
      GO TO (1000,1100,1100,1100,1200),KSERCH+1
C
C --- FOR NO SEARCH -----
 1000 KTLCXP= 0
      KAISUU= 0
      CALL FUNDER(XPARM,CHI2T,C2PERP,CXP,KTLCXP,KAISUU,KCHECK
     1                 ,NSPDIM,NSPDM1)
      CHISQT(1)= CHI2T
C
      GO TO 1900
C -----
C
C --- FOR SEARCH -----
 1100 IPRINT= KTLOUT(1) +1
C
      CALL LOCMIN(NSPMAX,KAISMX,DCHIMN,CHI2MN,IPRINT,KCHECK
     1                 ,START,XPARM,CXP,XILOC,DXLOC,PHYLOC,ZLOC,WLOC
     2                 ,NSPDIM,NSPDM1, ENDCOD)
C
      IF(KCHECK.GT.0) THEN
         WRITE(6,1001) KCHECK
 1001    FORMAT(/1H ,'***** LOCMIN --- KCHECK=',I3)
         STOP
      END IF
C
      GO TO 1900
C -----
C
C --- FOR GRID CALCULATION -----
 1200 CONTINUE
C
      CALL GRID(NSPMAX,PAGRID,NTHMAX
     1               ,XPARM,CXP, NSPDIM,NSPDM1)
C
      GO TO 5000
C -----
C
 1900 CONTINUE
C --- CALCULATE TENSOR POLARIZATION & ANALYZING POWER -----
      IF(KTLOUT(6).LE.0 .AND. KFLOUT(2).LE.0) GO TO 2000
      KAKTPA= 0
      KAKWOL=KTLOUT(6)
C
      CALL TENPOL(PSPIN,NTHMAX,KAKTPA,KAKWOL
     1       ,FNC,THETAD,AXTH,NTHDMP,NUEDM1,NUEDM2
     2       ,TPOL,TANL)
C
 2000 CONTINUE
C ---
C
C --- WRITE FINAL RESULTS -----
      KAKFIG= KTLOUT( 2)
      KAKTEN= KTLOUT( 6)
C
      CALL FWRITE(KSERCH,NTHMAX,NPARMX,XCHIT,PCHIT,CHISQT,REACX
     1        ,PARM,THETAD,CMREAD ,KRUTAB,KCHISQ,KAKFIG,KAKTEN ,ENDCOD
     2        ,TMASS  ,NUMPAR ,NTHDIM,NTHDMP,NPARDM
     3        ,AXTH,RXTH,RUTX,XSEX,XCHI,DXEX ,POLTH,POLEX,PCHI,DPEX
     4        ,PSPIN,TPOL,TANL
     5        ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     6        ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2
     7        ,KSOTYP,KNXTYP, TEMP)
C -----
C
C --- WRITE INITIAL & FINAL POTENTIAL -----
      KAKPIN= KTLOUT(3)
      KAKPFI= KTLOUT(4)
      IF(KAKPIN.LE.0 .AND. KAKPFI.LE.0) GO TO 3000
C
      CALL PWRITE(PMASS,TMASS,ZZHCAL,DDRR,NRMAX,LMAX,KAKPIN,KAKPFI
     1     ,NRDIM,NPARDM,LDIM
     2     ,PARM,VFOLD,WFOLD,VSFOLD,WSFOLD,UCE,USO,ULJ,VCL,FLJFAC
     3     ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     4     ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2 ,KSOTYP)
C -----
C
C --- WRITE S-MATRIX -----
 3000 KAKSMT= KTLOUT(5)
      IF(KAKSMT.LE.0) GO TO 4000
      KAKDSM= 0
      KAISUU= -1
      CALL SWRITE(PSPIN,KAISUU,LMAX,NSPMAX,IDENT,FKAY,SMAT,DSMAT
     1                 ,LDIM,NJDIM,NSPDIM    ,KAKSMT,KAKDSM)
C --- FILE OUTPUT -----
 4000 CONTINUE
      IF(KFLOUT(1).LE.0 .AND. KFLOUT(2).LE.0
     1      .AND. KFLOUT(3).LE.0 ) GOTO 5000
      CALL FILOUT(CMREAD)
C
C -----
C
C --- MEMORY FOR NEXT RUN -----
 5000 KNTLPV= 1
      IIFF= 2
      CALL PVCHNG(KNTLPV,IIFF,PARM,NPARDM
     1    ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     2    ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2)
C -----
C
      CALL CLOCKM(KT)
      FT1= (KT-KT1)*0.001
      WRITE(6,798) FT1
  798 FORMAT(/1H ,5X,
     1     '(',F8.3,' SEC FROM START OF THIS RUN )')

      IF(KTLEND.NE.0) GO TO 9999

      WRITE(6,799)
  799 FORMAT(1H1//)
      GO TO 1111
C
 9999 STOP
      END
CCC
CCC        ****** INIT ******
CCC
      SUBROUTINE INIT(NUMPAR,PMASS,TMASS,PZZ,TZZ,PSPIN,TSPIN
     1      ,DDRR,MATCHR,LMAX,IDENT1
     2      ,KSERCH,KAISMX,DCHIMN,INTGWF,KCHISQ,CHI2MN,PAGRID
     3      ,PARM,PARMNX,KPASER,NTHMAX,KRUTAB,DELEX,KFOLD,KSOTYP,KNXTYP
     4      ,THETAD,XSEX,DXEX,POLEX,DPEX
     5      ,KTLOUT,KFLOUT,NTHDIM,NTHDMP,NPARDM)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION PARM(NPARDM),PARMNX(NPARDM,3),DELEX(5,2)
      DIMENSION THETAD(NTHDMP),XSEX(NTHDIM),DXEX(NTHDIM),KFOLD(4)
      DIMENSION POLEX(NTHDIM),DPEX(NTHDIM) ,KSOTYP(2),PAGRID(3,2)
      DIMENSION KPASER(NPARDM),KTLOUT(18),KFLOUT(12)
CCC ===========================
C
      PMASS= 1.0
      TMASS= 40.0
      PZZ  = 1.0
      TZZ  = 20.0
      PSPIN= 0.0
      TSPIN= 0.0
      ELAB= 20.0
      DDRR= 0.1
      MATCHR= 181
      LMAX= 25
      IDENT1= 0
      KSERCH= 0
      KAISMX= 0
      DCHIMN= 1.0D-3
      INTGWF= 2
      KCHISQ= 0
      CHI2MN= 1.0D-10
      DO 1 I=1,2
      DO 1 J=1,3
      PAGRID(J,I)= 0.0D0
    1 CONTINUE
C
      DO 10 I=1,NUMPAR
      PARM( I)= 0.0D0
      KPASER( I)= 0
      PARMNX(I,1)= 1.0D-20
      PARMNX(I,2)= 20.0D0
   10 CONTINUE
C
      PARM( 3)= 1.0
      PARM( 6)= 1.0
      PARM( 9)= 1.0
      PARM(13)= 1.0
      PARM(16)= 1.0
      PARM(21)= 1.0
      PARM(24)= 1.0
      PARM(26)= 1.0
      PARM(29)= 1.0
      PARM(32)= 1.0
      PARM(35)= 1.0
      PARM(38)= 1.0
      PARM(41)= 1.0
C
      PARMNX( 1,1)= -1.0D3
      PARMNX( 1,2)=  1.0D3
      PARMNX( 4,1)= -1.0D3
      PARMNX( 4,2)=  1.0D3
      PARMNX( 7,1)= -1.0D3
      PARMNX( 7,2)=  1.0D3
      PARMNX(11,1)= -1.0D3
      PARMNX(11,2)=  1.0D3
      PARMNX(14,1)= -1.0D3
      PARMNX(14,2)=  1.0D3
      PARMNX(17,1)= -1.0D3
      PARMNX(17,2)=  1.0D3
      PARMNX(18,1)= -1.0D3
      PARMNX(18,2)=  1.0D3
      PARMNX(19,1)= -1.0D3
      PARMNX(19,2)=  1.0D3
      PARMNX(22,1)= -1.0D3
      PARMNX(22,2)=  1.0D3
      PARMNX(25,2)=  1.0D3
      PARMNX(26,2)=  1.0D3
      PARMNX(27,1)= -1.0D3
      PARMNX(27,2)=  1.0D3
      PARMNX(30,1)= -1.0D3
      PARMNX(30,2)=  1.0D3
      PARMNX(33,1)= -1.0D3
      PARMNX(33,2)=  1.0D3
      PARMNX(34,1)= -1.0D3
      PARMNX(34,2)=  1.0D3
      PARMNX(35,1)=  1.0D-10
      PARMNX(35,2)=  1.0D10
      PARMNX(36,1)= -1.0D3
      PARMNX(36,2)=  1.0D3
      PARMNX(39,1)= -1.0D3
      PARMNX(39,2)=  1.0D3
C
      DO 11 I=1,5
      DELEX( I, 1)= 0.0
      DELEX( I, 2)= 0.0
   11 CONTINUE
      DELEX( 5, 1)= 1.0D0
      DELEX( 5, 2)= 1.0D0
      KRUTAB= 1
      KSOTYP(1)= 0
      KSOTYP(2)= 0
      KNXTYP= 0
      KFOLD( 1)= 0
      KFOLD( 2)= 0
      KFOLD( 3)= 0
      KFOLD( 4)= 0
      THMIN= 0.0
      THMAX= 180.0
      THDEL= 5.0
      NTHMAX= (THMAX-THMIN)/THDEL +1
      DO 20 I=1,NTHMAX
      THETAD(I)= THDEL*(I-1) +THMIN
   20 CONTINUE
      DO 21 I=1,NTHDIM
      XSEX(I)= 0.0D0
      DXEX(I)= 0.0D0
      POLEX(I)= 0.0D0
      DPEX(I)= 0.0D0
   21 CONTINUE
C
      DO 31 I=1,18
      KTLOUT(I)= 0
   31 CONTINUE
      KTLOUT( 1)= 1
      DO 32 I=1,12
      KFLOUT(I)= 0
   32 CONTINUE
C
      RETURN
      END
CCC
CCC        ****** INPUT ******
CCC
      SUBROUTINE INPUT(PMASS,TMASS,PZZ,TZZ,PSPIN,TSPIN
     1           ,ELAB,DDRR,MATCHR,LMAX,IDENT1,KNTLE
     2           ,KSERCH,KAISMX,DCHIMN,INTGWF,KCHISQ,CHI2MN,PAGRID
     3           ,PARM,PARMNX,KPASER,NTHMAX,KRUTAB,KFOLD,KSOTYP,KNXTYP
     4           ,THETAD,XSEX,DXEX,POLEX,DPEX,DELEX
     5           ,KTLOUT,KFLOUT,CMREAD
     6                  ,NUMPAR,NTHDIM,NTHDMP,NPARDM, KTLEND)
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER*40 CMREAD
      DIMENSION PARM(NPARDM),PARMNX(NPARDM,3),KFOLD(4),KSOTYP(2)
      DIMENSION THETAD(NTHDMP),XSEX(NTHDIM),DXEX(NTHDIM)
      DIMENSION POLEX(NTHDIM),DPEX(NTHDIM)
      DIMENSION DELEX(5,2),KPASER(NPARDM)
      DIMENSION KTLOUT(18),KFLOUT(12),PAGRID(3,2)
C
      DIMENSION A(7)
      CHARACTER*80 DUMMY
      CHARACTER*21 FMTDAT/'(F10.5,2D15.7,2F10.5)'/
      DATA KRUN/0/
CCC ===========================
C
 5000 FORMAT(A)
 5100 FORMAT(7F10.5)
 5200 FORMAT(A80)
C
      KTDEL=0
      KIB= 5
C
 5001 READ(5,5000,END=9999) CMREAD
      IF(CMREAD(1:2).EQ.'/*') GOTO 5001
      IF(CMREAD(1:5).EQ.'/END/' .OR. CMREAD(1:5).EQ.'/end/')
     1            GOTO 9999
      IF(CMREAD.EQ.' ' .AND. KRUN.GT.0) GOTO 5001
      KRUN=0
C
 5555 READ(5,5200,END=8888) DUMMY
      IF(DUMMY(1:2).EQ.'/*') GOTO 5555
      IF(DUMMY(1:5).EQ.'/END/' .OR. DUMMY(1:5).EQ.'/end/')
     1            GOTO 8888
      IF(DUMMY(1:5).EQ.'/RUN/' .OR. DUMMY(1:5).EQ.'/run/') THEN
         KRUN=1
         GOTO 7777
      ENDIF
 
      READ(DUMMY,5100) (A(I),I=1,7)
      AA= DABS(A(1))
      IA0= AA +0.001
      IA1= AA*10 -IA0*10 +0.001
      IA2= AA*100 -IA0*100 -IA1*10 +0.001
      IA3= AA*1000 -IA0*1000 -IA1*100 -IA2*10 +0.01
      IF(IA0.EQ.9999) GOTO 8888
      GO TO (100,200,300,400,500,600,700,800,900),IA0
      IF(IA0.EQ.0) GO TO 7777
      GO TO 6666
C
  100 CONTINUE
      PMASS= A(2)
      TMASS= A(3)
      PZZ  = A(4)
      TZZ  = A(5)
      PSPIN= A(6)
      TSPIN= A(7)
      GO TO 5555
C
  200 CONTINUE
      ELAB= A(2)
      DDRR= A(3)
      MATCHR= A(4) +0.01
      LMAX= A(5) +0.01
      IDENT1= A(6) +0.01
      KNTLE= IA1
      GO TO 5555
C
  300 CONTINUE
      IF(IA1.EQ.1) GO TO 310
      KSERCH= A(2) +0.01
      KAISMX= A(3) +0.01
      DCHIMN= A(4)
      INTGWF= A(5) +0.01
      KCHISQ= A(6) +0.01
      CHI2MN= A(7)
      IF(DCHIMN.LE.1.0D-30) DCHIMN= 1.0D-3
      IF(INTGWF.LE.0) INTGWF= 2
      IF(KSERCH.LT.0 .OR. KSERCH.GT.3) KSERCH= 0
      IF(KCHISQ.LT.0 .OR. KCHISQ.GT.3) KCHISQ= 0
      IF(KSERCH.GT.0) THEN
         IF(KCHISQ.LE.0) KCHISQ= KSERCH
         IF(KCHISQ.NE.KSERCH) KCHISQ= 3
      END IF
      IF(CHI2MN.LE.0.0) CHI2MN= 1.0D-10
      GO TO 5555
C
  310 KSERCH= 4
      KCHISQ= A(2) +0.01
      PAGRID(1,1)= A(3)
      PAGRID(2,1)= A(4)
      PAGRID(1,2)= A(5)
      PAGRID(2,2)= A(6)
      GO TO 5555
C
  400 CONTINUE
      IF(IA1.EQ.9) GO TO 490
      IA12= 10*IA1 +IA2
      GO TO (401,402,403,404,405,406,407,408,409,410
     1      ,411,412,413,414,415,416), IA12
      GO TO 6666
  401 N= 0
      GO TO 444
  402 N= 3
      GO TO 444
  403 N= 6
      GO TO 444
  404 PARM(10)= A(2)
      KPASER(10)= A(3) +0.01
      GO TO 5555
  405 N= 10
      IF(IA3.NE.1) IA3= 0
      KSOTYP(1)= IA3
      GO TO 444
  406 N= 13
      IF(IA3.NE.1) IA3= 0
      KSOTYP(2)= IA3
      GO TO 444
  407 PARM(17)= A(2)
      PARM(18)= A(5)
      KFOLD( 1)= A(3) +0.01
      KFOLD( 2)= A(6) +0.01
      KPASER(17)= A(4) +0.01
      KPASER(18)= A(7) +0.01
      IF(KFOLD(1).LE.0) PARM(17)= 0.0D0
      IF(KFOLD(2).LE.0) PARM(18)= 0.0D0
      GO TO 5555
  408 N= 18
      GO TO 444
  409 N= 21
      GO TO 444
  410 PARM(25)= A(2)
      PARM(26)= A(3)
      KPASER(25)= A(4) +0.01
      KPASER(26)= A(5) +0.01
      GO TO 5555
  411 N= 26
      GO TO 444
  412 N= 29
      GO TO 444
  413 PARM(33)= A(2)
      PARM(34)= A(5)
      KFOLD( 3)= A(3) +0.01
      KFOLD( 4)= A(6) +0.01
      KPASER(33)= A(4) +0.01
      KPASER(34)= A(7) +0.01
      IF(KFOLD(3).LE.0) PARM(33)= 0.0D0
      IF(KFOLD(4).LE.0) PARM(34)= 0.0D0
      GO TO 5555
  414 PARM(35)= A(2)
      KPASER(35)= A(3) +0.01
      IA3= A(1)*1000 -IA0*1000 -IA1*100 -IA2*10 +0.01
      IF(IA3.NE.1) IA3= 0
      KNXTYP= IA3
      GO TO 5555
  415 N= 35
      GO TO 444
  416 N= 38
      GO TO 444
  444 PARM(N+1)= A(2)
      PARM(N+2)= A(3)
      PARM(N+3)= A(4)
      KPASER(N+1)= A(5) +0.01
      KPASER(N+2)= A(6) +0.01
      KPASER(N+3)= A(7) +0.01
      GO TO 5555
  490 IA23= A(1)*1000 -IA0*1000 -IA1*100 +0.01
      IF(IA23.GT.NUMPAR) GO TO 6666
      PARMNX(IA23, 1)= A(2)
      PARMNX(IA23, 2)= A(3)
      GO TO 5555
C
  500 CONTINUE
      IA11= IA1+1
      GO TO (501,510,520,530),IA11
      GO TO 6666
  501 KIB= A(2) +0.01
      WRITE(6,503) KIB
  503 FORMAT(/1H ,5X,'=== INPUT (DATA READ) --- KIBAN=',I3)
      IF(KIB.NE.5) REWIND KIB
  502 READ(KIB,5100) (A(I),I=1,7)
      IA0= DABS(A(1)) +0.01
      IA1= A(1)*10 -IA0*10 +0.01
      IA2= A(1)*100 -IA0*100 -IA1*10 +0.01
      IA3= A(1)*1000 -IA0*1000 -IA1*100 -IA2*10 +0.01
      IF(IA0.EQ.5) GO TO 500
      GO TO 5555
  510 NTHMAX= A(2) +0.01
      KRUTAB= IA2
      K1= A(3) +0.01
      K2= A(4) +0.01
      XFACT= A(5)
      PFACT= A(6)
      IF(DABS(XFACT).LE.1.0D-10) XFACT= 1.0D0
      IF(DABS(PFACT).LE.1.0D-10) PFACT= 1.0D0
      IF(NTHMAX.LE.NTHDIM) GO TO 511
      WRITE(6,512) NTHMAX,NTHDIM
  512 FORMAT(/1H ,5X,'***** DIMENSION OVER --- NTHMAX,NTHDIM=',2I5)
      STOP
  511 READ(KIB,5200) DUMMY
      WRITE(6,513) XFACT,PFACT,DUMMY
  513 FORMAT(/1H ,5X,'=== EXPERIMENTAL DATA :  XFACT, PFACT=',1P2D12.4
     1      /1H ,5X,'                      << ',A,' >>')
      DUMMY= FMTDAT
      IF(IA3.GT.0) READ(KIB,5200) DUMMY
      DO 514 I=1,NTHMAX
      READ (KIB,DUMMY) THETAD(I),XSEX(I),DXEX(I),POLEX(I),DPEX(I)
  514 CONTINUE
      DO 515 I=1,NTHMAX
      XSEX(I)= XSEX(I)*XFACT
      DXEX(I)= DXEX(I)*XFACT
      POLEX(I)= POLEX(I)*PFACT
      DPEX(I)= DPEX(I)*PFACT
  515 CONTINUE
      IF(DABS(DXEX(1)).GT.1.0D-20) DELEX( 1, 1)= 0.0
      IF(DABS(DPEX(1)).GT.1.0D-20) DELEX( 1, 2)= 0.0
      IF(K1.GT.0) DELEX(1,1)= 3.0
      IF(K2.GT.0) DELEX(1,2)= 3.0
      IF(KIB.NE.5) GO TO 502
      GO TO 5555
  520 IF(IA2.LE.0.OR.IA2.GT.2) GO TO 6666
      DELEX(1,IA2)= 1.0
      DELEX(2,IA2)= A(2)
      DELEX(3,IA2)= A(3)
      DELEX(4,IA2)= A(4)
      IF(KIB.NE.5) GO TO 502
      GO TO 5555
  530 KIB= 5
      GO TO 5555
C
  600 CONTINUE
      IA11= IA1 +1
      GO TO (601,610,620,630),IA11
      GO TO 6666
  601 THMIN= A(2)
      THMAX= A(3)
      THDEL= A(4)
      NTHMAX= (THMAX-THMIN)/THDEL +1
      IF(NTHMAX.LE.NTHDIM) GO TO 602
      WRITE(6,512) NTHMAX,NTHDIM
      STOP
  602 DO 603 I=1,NTHMAX
      THETAD(I)= THDEL*(I-1) +THMIN
  603 CONTINUE
      GO TO 5555
  610 IF(IA2.LE.0.OR.IA2.GT.2) GO TO 6666
      DELEX(1,IA2)= 2.0
      DELEX(2,IA2)= A(2)
      DELEX(3,IA2)= A(3)
      DELEX(4,IA2)= A(4)
      IF(IA2.GT.1) GO TO 5555
      IA3= A(1)*1000.0 -IA0*1000 -IA1*100 -IA2*10 +0.01
      KRUTAB= IA3
      GO TO 5555
  620 IF(IA1.LE.0.OR.IA1.GT.2) GO TO 6666
      DELEX(1,IA2)= 0.0
      GO TO 5555
  630 DELEX(5,1)= A(2)
      DELEX(5,2)= A(3)
      IF(DABS(DELEX(5,1)).LT.1.0D-10) DELEX(5,1)= 1.0D0
      IF(DABS(DELEX(5,2)).LT.1.0D-10) DELEX(5,2)= 1.0D0
      KTDEL= 0
      IF(ABS(DELEX(5,1)-1.0).GT.1.0D-10) KTDEL=1
      IF(ABS(DELEX(5,2)-1.0).GT.1.0D-10) KTDEL=KTDEL+2
      GO TO 5555
C
  700 CONTINUE
      GO TO 5555
C
  800 CONTINUE
      IF(IA1.LE.0.OR.IA1.GT.3) GO TO 6666
      KMN= 6*(IA1-1)
      KTLOUT(KMN +1)= A(2) *1.001
      KTLOUT(KMN +2)= A(3) *1.001
      KTLOUT(KMN +3)= A(4) *1.001
      KTLOUT(KMN +4)= A(5) *1.001
      KTLOUT(KMN +5)= A(6) *1.001
      KTLOUT(KMN +6)= A(7) *1.001
      GO TO 5555
C
  900 CONTINUE
      IF(IA1.LE.0.OR.IA1.GT.2) GO TO 6666
      KMN= 6*(IA1-1)
      KFLOUT(KMN +1)= A(2) +0.01
      KFLOUT(KMN +2)= A(3) +0.01
      KFLOUT(KMN +3)= A(4) +0.01
      KFLOUT(KMN +4)= A(5) +0.01
      KFLOUT(KMN +5)= A(6) +0.01
      KFLOUT(KMN +6)= A(7) +0.01
      GO TO 5555
CCC
 6666 CONTINUE
      WRITE(6,6660) (A(I),I=1,7)
 6660 FORMAT(/1H ,'****** NOT CLASSIFIABLE INPUT --- ',7F10.5)
      GO TO 5555
 7777 CONTINUE
      KTLEND= 0
      GO TO 9000
 8888 KTLEND= 1
 9000 CONTINUE
      IF(DABS(PAGRID(2,1)).LT.1.0D-20) PAGRID(2,1)= 1.0D0
      IF(DABS(PAGRID(2,2)).LT.1.0D-20) PAGRID(2,2)= 1.0D0
      IF(DABS(PARM( 3)).LT.1.0D-20) PARM( 3)= 1.0
      IF(DABS(PARM( 6)).LT.1.0D-20) PARM( 6)= 1.0
      IF(DABS(PARM( 9)).LT.1.0D-20) PARM( 9)= 1.0
      IF(DABS(PARM(10)).LT.1.0D-20) PARM(10)= 1.0
      IF(DABS(PARM(13)).LT.1.0D-20) PARM(13)= 1.0
      IF(DABS(PARM(16)).LT.1.0D-20) PARM(16)= 1.0
      IF(DABS(PARM(21)).LT.1.0D-20) PARM(21)= 1.0
      IF(DABS(PARM(24)).LT.1.0D-20) PARM(24)= 1.0
      IF(DABS(PARM(26)).LT.1.0D-20) PARM(26)= 1.0
      IF(DABS(PARM(29)).LT.1.0D-20) PARM(29)= 1.0
      IF(DABS(PARM(32)).LT.1.0D-20) PARM(32)= 1.0
      IF(DABS(PARM(35)).LT.1.0D-50) PARM(35)= 1.0
      IF(DABS(PARM(38)).LT.1.0D-20) PARM(38)= 1.0
      IF(DABS(PARM(41)).LT.1.0D-20) PARM(41)= 1.0
      IF(DABS(PZZ*TZZ) .LT. 1.0D-10) THEN
         KTLOUT(2)= -IABS(KTLOUT(2))
      END IF
C
      IF(KTDEL.EQ.1 .OR. KTDEL.EQ.3) THEN
       XFACT= DELEX(5,1)
       DO 9001 I=1,NTHMAX
       XSEX(I)= XSEX(I)*XFACT
       DXEX(I)= DXEX(I)*XFACT
 9001  CONTINUE
      END IF
      IF(KTDEL.EQ.2 .OR. KTDEL.EQ.3) THEN
       PFACT= DELEX(5,2)
       DO 9002 I=1,NTHMAX
       POLEX(I)= POLEX(I)*PFACT
       DPEX(I)= DPEX(I)*PFACT
 9002  CONTINUE
      END IF
      RETURN
 9999 WRITE(6,6900)
 6900 FORMAT(//1H ,10X,'****** INPUT DATA END ----> NORMAL STOP')
      STOP
      END
CCC
CCC        ****** READY ******
CCC
      SUBROUTINE READY(PMASS,TMASS,PZZ,TZZ,PSPIN,TSPIN,ELAB,DDRR,IDENT1
     1                ,KSERCH,MATCHR,LMAX,NTHMAX,NUMPAR,KRUTAB,KCHISQ
     2                ,KNTLE,KPASER,PARM,PARMNX,THETAD,KFOLD,PAGRID
     3                ,DELEX,AXTH,RXTH,XSEX,POLTH,POLEX,DXEX,DPEX
     4            ,NRDIM,LDIM,MDIM,NUEDM1,NTHDIM,NTHDMP,NPARDM,NSPDIM
     5       ,FFMM,ECM,FKAY,ETA,RMASS,RMASC2,ZZHCAL,NRMAX
     6       ,RMASNR,ECMNR,FKAYNR
     7       ,NPARMX,NSPMAX,IDENT
     8       ,KTPARA,KPREIM,KSPLJD,START,XPARM,KTXNOR
     9       ,PLM,EXSIG2,FCL,RUTX,VUCL,DUCL,SIGMA0
     1       ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     2       ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2
     3       ,VFOLD,WFOLD,VSFOLD,WSFOLD)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION KPASER(NPARDM),PARM(NPARDM),PARMNX(NPARDM,3)
      DIMENSION THETAD(NTHDMP),KFOLD(4),PAGRID(3,2)
C
      DIMENSION DELEX(5,2)
      DIMENSION AXTH(NTHDMP),RXTH(NTHDMP),XSEX(NTHDIM),DXEX(NTHDIM)
      DIMENSION POLTH(NTHDMP),POLEX(NTHDIM),DPEX(NTHDIM)
C
      DIMENSION KTPARA(NSPDIM,NPARDM),KPREIM(NPARDM),KSPLJD(NSPDIM)
      DIMENSION START(NSPDIM),XPARM(NSPDIM)
      DIMENSION V0R0A(3,2),W0R0A(3,2),WDR0A(3,2),R0COUL(2)
      DIMENSION VSR0A(3,2),WSR0A(3,2),FNRNI(2,2),V2R0A(3,2),VDR0A(3,2)
      DIMENSION FL0AL(2,2),VLDR0A(3,2),WLDR0A(3,2),FSNRNI(2,2),FNXSEX(2)
      DIMENSION V0R0A2(3,2),W0R0A2(3,2)
      COMPLEX*16 EXSIG2(LDIM),FCL(NTHDMP),VUCL(LDIM,2),DUCL(LDIM,2)
      DIMENSION PLM(NTHDMP,LDIM,MDIM),RUTX(NTHDMP)
      DIMENSION VFOLD(NRDIM),WFOLD(NRDIM),VSFOLD(NRDIM),WSFOLD(NRDIM)
c Reid (1968)
c      parameter (HC=197.231 D0, AC=938.903D0, EC=137.0388D0)
c Kyudai traditional values?
c      parameter (HC=197.3216D0, AC=938.29 D0, EC=137.0388D0)
c CODATA recommended values (1998)
      parameter (HC=197.3269601d0, AC=931.494013d0, EC=137.03599976d0)
CCC ================================
C
C --- CHECK OF DIMENSION -----
      NRMAX= MATCHR +3
      LMAX1= LMAX +1
      NUE21= PSPIN*2 +1.01
      MMAX= PSPIN*2 +0.01
      IF( NRMAX.LE.NRDIM .AND. LMAX1.LE.LDIM .AND. NUE21.LE.NUEDM1
     1                   .AND.  MMAX+1.LE.MDIM ) GO TO 1
      WRITE(6,601) NRMAX,LMAX1,NUE21,MMAX,NRDIM,LDIM,NUEDM1,MDIM
  601 FORMAT(/1H ,3X,'***** DIMENSION OVER ---'
     1      /1H ,5X,'NRMAX,LMAX1, NUE21,MMAX=',4I5
     2      /1H ,5X,'NRDIM, LDIM,NUEDM1,MDIM=',4I5)
      STOP
    1 CONTINUE
C
C --- CALCULATE BASIC VALUES -----
      CHKM= PMASS+TMASS
      IF( CHKM.GT.1.0D-10 .AND. ELAB.GT.1.0D-10 ) GO TO 2
      WRITE(6,602) PMASS,TMASS,ELAB
  602 FORMAT(/1H ,'***** ERROR --- PMASS,TMASS,ENERGY=',1P3D12.4)
      STOP
    2 CONTINUE
C
C --- ELAB, ECM, RELATIVISTIC CORRECTION ---
      IF(KNTLE.LE.1) THEN
C      -- nonrelativistic case ---
         RMASS= PMASS*TMASS/(PMASS+TMASS)
         IF(KNTLE.EQ.0) THEN
            ECM= ELAB *RMASS/PMASS
         ELSE IF(KNTLE.EQ.1) THEN
            ECM= ELAB
            ELAB= ECM *PMASS/RMASS
         END IF
         RMASC2= RMASS *AC
         FFMM= 2*RMASC2/HC**2
         FKAY= DSQRT(FFMM*ECM)
      ELSEIF(KNTLE.LE.5) THEN
C      -- relativistic case ---
         RMASNR= PMASS*TMASS/(PMASS+TMASS)
         ECMNR = ELAB *RMASNR/PMASS
         FKAYNR= DSQRT(2*RMASNR*AC*ECMNR)/HC
         PMC2= PMASS*AC
         TMC2= TMASS*AC
         EPL= ELAB +PMC2
         ETOTL= EPL +TMC2
         FKPL= DSQRT(EPL**2 -PMC2**2)/HC
         ETOTB= DSQRT(PMC2**2 +TMC2**2 +2*TMC2*EPL)
         FKAY= TMC2/ETOTB *FKPL
         EPB= (PMC2**2 +TMC2*EPL) /ETOTB
         ETB= (TMC2**2 +TMC2*EPL) /ETOTB
         IF(KNTLE.EQ.2) THEN
C         -- Type I --
            EPS= ETOTB -TMC2
            RMASC2= EPS*TMC2 /ETOTB
            ECM= (EPS**2-PMC2**2)/(2*EPS)
         ELSEIF(KNTLE.EQ.3) THEN
C         -- Type II --
            RMASC2= EPB
            ECM=(FKAY*HC)**2 /(2*RMASC2)
         ELSEIF(KNTLE.EQ.4) THEN
C         -- Type III --
            RMASC2=EPB*ETB/(EPB+ETB)
            ECM=(FKAY*HC)**2 /(2*RMASC2)
         ELSEIF(KNTLE.EQ.5) THEN
C         -- Type IV --
            RMASC2=(EPB+PMC2)*(ETB+TMC2)/(EPB+PMC2+ETB+TMC2) /2
            ECM=(FKAY*HC)**2 /(2*RMASC2)
         END IF
         FFMM= 2*RMASC2/HC**2
         RMASS= RMASC2/AC
      ELSE
C      -- error case ---
         WRITE(6,603) KNTLE
  603    FORMAT(1X,'***** ERROR ---  UNDEFINED VALUE OF KNTLE =',I3)
         STOP
      END IF
C
      ETA= PZZ*TZZ*RMASC2 /(EC*HC*FKAY)
      ZZHCAL= PZZ*TZZ *HC/EC
C
C --- IDENTICAL PARTICLE CHECK -----
      IDENT= 0
      MP= PMASS +0.01
      MT= TMASS +0.01
      IZP= PZZ +0.01
      IZT= TZZ +0.01
      IPS2= PSPIN*2 +0.01
      ITS2= TSPIN*2 +0.01
      II= IPS2 -IPS2/2 *2
      IF(MP.EQ.MT .AND. IZP.EQ.IZT .AND. IPS2.EQ.ITS2) IDENT= II +1
      IF(IDENT1.GT.0) IDENT= IDENT1 -1
      IF(IDENT.LT.2) GO TO 20
      WRITE(6,604) IDENT,MP,IZP,IPS2,MT,IZT,ITS2
  604 FORMAT(/1H ,'***** ERROR --- IDENT=',I3,
     1      /1H ,'          MP,IZP,IPS2=',3I5
     2      /1H ,'          MT,IZT,IPT2=',3I5
     3          ,'    --- NON-ZERO SPIN CASE WA MADA DAMEYO.')
      STOP
   20 CONTINUE
C
C --- SEARCH PARAMETER CONTROL -----
      IF(DABS(PZZ*TZZ).LE.1.0D-5 .AND. KSERCH.GT.0
     1                .AND. KPASER(10).GT.0) THEN
         WRITE(6,605) KPASER(10)
  605    FORMAT(/1H ,'*** ERROR -- KPASER(R0C)=',I3
     1          ,',  BUT ONE OR BOTH PARTICLES ARE CHARGELESS.'
     2         /1H ,'             KPASER(R0C) IS REPLACED BY 0.')
         KPASER(10)= 0
      END IF
      NN= 0
      NPMX= 0
      IF(KSERCH.LE.0) GO TO 100
      DO 101 NP=1,NUMPAR
      DO 101 NS=1,NSPDIM
      KTPARA(NS,NP)= 0
  101 CONTINUE
      IF(KSERCH.GE.4) GO TO 120
C - NORMAL SEARCH -
      DO 110 NP=1,NUMPAR
      KP= KPASER(NP)
      IF(KP.LE.0) GO TO 110
      NPMX= MAX0(NPMX, NP)
      NN= NN +1
      IF(NN.GT.NSPDIM) THEN
         WRITE(6,112) NN,NSPDIM
  112    FORMAT(/1H ,5X,'***** NUMBER OF SEARCH PARAMETER IS OVER.'
     1             ,'(',I3,')   NSPDIM=',I3)
         STOP
      END IF
      KTPARA(NN,NP)= 1
      PP= PARM(NP)
      START(NN)= PP
      XPARM(NN)= 1.0D0
      IF(KP.GT.0 .AND. PP.EQ.0.0) THEN
         WRITE(6,114) NP,KP,PP
  114    FORMAT(/1H ,5X,'***** SEARCH PARAMETER ERROR ****'
     1        /1H ,10X,'STARTING VALUE IS ZERO.'
     2        /1H ,10X,'PARAM.NO.=',I3,' KPASER=',I3,' PARM=',1PD12.4)
         STOP
      END IF
      IF(NP.GE.NUMPAR) GO TO 110
         DO 113 NP1=NP+1,NUMPAR
         IF(NP1.EQ.35) GO TO 113
         KP1= KPASER(NP1)
         IF(KP1.LE. 0 ) GO TO 113
         IF(KP .NE.KP1) GO TO 113
         PX= DABS( PP-PARM(NP1) )
         IF(PX.GT.0.0001D0) GO TO 113
         NPMX= MAX0(NPMX,NP1)
         KTPARA(NN,NP1)= 1
         KPASER(NP1)= 0
  113    CONTINUE
  110 CONTINUE
      IF(NN.GT.0) GO TO 100
      WRITE(6,102) KSERCH
  102 FORMAT(/1H ,'***** ERROR --- KSERCH=',I2,' BUT THERE IS NO'
     1          ,' SEARCH PARAMETER. KSERCH IS REPLACED BY 0.')
      KSERCH= 0
      GO TO 100
C - GRID CAL. -
  120 DO 121 NP= 1, NUMPAR
      KP= KPASER(NP)
      IF(KP.LE.0) GO TO 121
      NPMX= MAX0(NPMX, NP)
      NN= MAX0( NN, KP)
      IF(KP.GT. 2) THEN
         WRITE(6,122) KP
  122    FORMAT(/1H ,5X,'***** NUMBER OF GRID PARAMETER IS OVER.'
     1             ,'(',I3,')  > 2')
         STOP
      END IF
      KTPARA(KP,NP)= 1
      PP= PARM(NP)
      START(KP)= PP
      PAGRID(3,KP)= PP
      XPARM(KP)= 1.0D0
      IF(NP.GE.NUMPAR) GO TO 121
         DO 123 NP1=NP+1,NUMPAR
         KP1= KPASER(NP1)
         IF(KP1.LE. 0 ) GO TO 123
         IF(KP .NE.KP1) GO TO 123
         PX= DABS( PP-PARM(NP1) )
         IF(PX.GT.0.0001D0) THEN
            WRITE(6,124) KP,NP,PP,NP1,PARM(NP1)
  124       FORMAT(/1H ,'*** ERROR -- INITIAL VALUES ARE NOT IDENTICAL'
     1            ,' WHEN KTPARA ARE IDENTICAL FOR GRID CAL.'
     2          /1H ,'    KTPARA=',I3,'  NP=',I3,'  VALUE=',F13.7
     3          /1H ,'           ',3X,'  NP=',I3,'  VALUE=',F13.7)
            STOP
         END IF
         NPMX= MAX0(NPMX,NP1)
         KTPARA(KP,NP1)= 1
         KPASER(NP1)= 0
  123    CONTINUE
  121 CONTINUE
      IF(NN.GT.0) GO TO 100
      WRITE(6,102) KSERCH
      KSERCH= 0
      GO TO 100
C
  100 NSPMAX= NN
      NPARMX= NPMX
C
C --- X-SECTION RENORMALIZATION CHECK
      KTXNOR= 0
      DO 127 NN=1,NSPMAX
        IF(KTPARA(NN,35).GT.0) KTXNOR=NN
  127 CONTINUE
C
C --- POTENTIAL PARAMETER STORING
      KNTLPV= 2
      DO 130 I=1,2
      IIFF= I
C ------
      CALL PVCHNG(KNTLPV,IIFF,PARM,NPARDM
     1    ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     2    ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2)
C ------
  130 CONTINUE
C
C --- INPUT PARMNX(NP, 3) -----
      DO 131 NP=1,NPARMX
      PARMNX(NP, 3)= PARM(NP)
  131 CONTINUE
C
C --- PARAMETER TYPE ( REAL(1) OR IMAG.(2) ) -----
      DO 140 I=1,3
      KPREIM(I   )= 1
      KPREIM(I+ 3)= 2
      KPREIM(I+ 6)= 2
      KPREIM(I+10)= 1
      KPREIM(I+13)= 2
      KPREIM(I+18)= 1
      KPREIM(I+21)= 1
      KPREIM(I+26)= 1
      KPREIM(I+29)= 2
      KPREIM(I+35)= 1
      KPREIM(I+38)= 2
  140 CONTINUE
      KPREIM(10)= 1
      KPREIM(17)= 1
      KPREIM(18)= 2
      KPREIM(25)= 3
      KPREIM(26)= 3
      KPREIM(33)= 1
      KPREIM(34)= 2
      KPREIM(35)= 0
C
C --- PARAMETER TYPE ( L,J-DEPENDENCY ) -----
      IF(NSPMAX.LE.0) GO TO 159
      DO 150 NS=1,NSPMAX
      KSPLJD(NS)= 0
      DO 151 NP=1,NPARMX
      IF(KTPARA(NS,NP).LE.0) GO TO 151
      IF(NP.GE.11.AND.NP.LE.16) KSPLJD(NS)= 1
      IF(NP.GE.25.AND.NP.LE.26) KSPLJD(NS)= 2
      IF(NP.GE.27.AND.NP.LE.32) KSPLJD(NS)= 2
      IF(NP.GE.33.AND.NP.LE.34) KSPLJD(NS)= 1
  151 CONTINUE
  150 CONTINUE
  159 CONTINUE
C
C --- EXPERIMENTAL DATA -----
      KK= DELEX( 1, 1) +0.01
      THX= DELEX( 2, 1)
      DLO= DELEX( 3, 1)
      DHI= DELEX( 4, 1)
      GO TO (161,162,163),KK
      GO TO 160
  162 GO TO (166,167),KRUTAB
  166 DO 168 IT=1,NTHMAX
      XSEX(IT)= RXTH(IT)
  168 CONTINUE
      GO TO 161
  167 DO 169 IT=1,NTHMAX
      XSEX(IT)= AXTH(IT)
  169 CONTINUE
  161 DO 164 IT=1,NTHMAX
      DXEX(IT)= XSEX(IT)*DLO
      IF(THETAD(IT).LE.THX) GO TO 164
      DXEX(IT)= XSEX(IT)*DHI
  164 CONTINUE
      GO TO 160
  163 DO 165 IT=1,NTHMAX
      DXEX(IT)= XSEX(IT) *DXEX(IT) *0.01D0
  165 CONTINUE
  160 CONTINUE
C
      KK= DELEX( 1, 2) +0.01
      THX= DELEX( 2, 2)
      DLO= DELEX( 3, 2)
      DHI= DELEX( 4, 2)
      GO TO (171,172,173),KK
      GO TO 170
  172 DO 174 IT=1,NTHMAX
      POLEX(IT)= POLTH(IT)
  174 CONTINUE
  171 DO 175 IT=1,NTHMAX
      DPEX(IT)= ABS(POLEX(IT))*DLO
      IF(THETAD(IT).LE.THX) GO TO 176
      DPEX(IT)= ABS(POLEX(IT))*DHI
  176 IF(DABS(DPEX(IT)).LT.1.0D-20) DPEX(IT)= 1.0D0
  175 CONTINUE
      GO TO 170
  173 DO 177 IT=1,NTHMAX
      DPEX(IT)= ABS(POLEX(IT)) *DPEX(IT) *0.01D0
  177 CONTINUE
  170 CONTINUE
C
C --- CHECK OF KRUTAB -----
      GO TO (180,180,180),KRUTAB
      WRITE(6,181) KRUTAB
  181 FORMAT(/1H ,'***** ERROR --- KRUTAB=',I5)
      STOP
  180 CONTINUE
C
C --- READY FOR STORED VALUES -----
C
C - PLM FUNCTION ---
      CALL PLMFUN(LDIM-1,MDIM-1,NTHDMP,LMAX,MMAX,NTHMAX,THETAD, PLM)
C
      IF(DABS(ETA).LT.1.0D-40) GO TO 210
C
C - COULOMB PHASE-SHIFT ---
      CALL SIGMAL(ETA,LMAX,LDIM,  SIGMA0,EXSIG2)
C
      DO 221 L1=1,LMAX+1
      EXSIG2(L1)= EXSIG2(L1)**2
  221 CONTINUE
C
C - COULOMB SCATTERING AMPLITUDE ---
      CALL FCOUL(ETA,FKAY,SIGMA0,IDENT,NTHMAX,THETAD,NTHDMP,  FCL)
C
C - RUTHERFORD CROSS SECTION ---
      DO 222 IT=1,NTHMAX
      RUTX(IT)= FCL(IT) *DCONJG(FCL(IT)) *10.0D0
  222 CONTINUE
      GO TO 230
C
C - NO COULOMB CASE ---
  210 CONTINUE
      KRUTAB= 2
      DO 211 L1=1,LMAX+1
      EXSIG2(L1)= 1.0D0
  211 CONTINUE
      DO 212 IT=1,NTHMAX
      FCL(IT)= 0.0D0
      RUTX(IT)= 0.0D0
  212 CONTINUE
C
C - COULOMB FUNCTION ---
  230 RMAT= DDRR*(MATCHR-1)
      RHO1= RMAT*FKAY
      DRHO= 0.2D0
      RHO2= RHO1 +DRHO
      DO 231 L1=1,LMAX+1
      LL= L1 -1
C   -----
      CALL COULFG(LL,ETA,RHO1,RHO2,DRHO, F1,G1,F2,G2,FP1,GP1)
C   -----
      VUCL(L1, 1)= DCMPLX( G1,  F1)
      VUCL(L1, 2)= DCMPLX( G1, -F1)
      DUCL(L1, 1)= DCMPLX( GP1,  FP1)
      DUCL(L1, 2)= DCMPLX( GP1, -FP1)
  231 CONTINUE
C ---------------
C
C --- READ POTENTIAL -----
      KIB= KFOLD( 1)
      KSKIP=KIB/100
      IF(KSKIP.GT.0) THEN
         KIB=KIB-KSKIP*100
         CALL PREAD2(1,KSKIP,KIB,NRMAX,DDRR,NRDIM,   VFOLD)
      ELSE IF(KIB.GT.0) THEN
         CALL PREAD(KIB,NRMAX,DDRR,NRDIM,   VFOLD)
      ENDIF
C   -----
  310 KIB= KFOLD( 2)
      KSKIP=KIB/100
      IF(KSKIP.GT.0) THEN
         KIB=KIB-KSKIP*100
         CALL PREAD2(2,KSKIP,KIB,NRMAX,DDRR,NRDIM,   WFOLD)
      ELSE IF(KIB.GT.0) THEN
         CALL PREAD(KIB,NRMAX,DDRR,NRDIM,   WFOLD)
      ENDIF
C   -----
  320 KIB= KFOLD( 3)
      KSKIP=KIB/100
      IF(KSKIP.GT.0) THEN
         KIB=KIB-KSKIP*100
         CALL PREAD2(3,KSKIP,KIB,NRMAX,DDRR,NRDIM,   VSFOLD)
      ELSE IF(KIB.GT.0) THEN
         CALL PREAD(KIB,NRMAX,DDRR,NRDIM,   VSFOLD)
      ENDIF
C   -----
  330 KIB= KFOLD( 4)
      KSKIP=KIB/100
      IF(KSKIP.GT.0) THEN
         KIB=KIB-KSKIP*100
         CALL PREAD2(4,KSKIP,KIB,NRMAX,DDRR,NRDIM,   WSFOLD)
      ELSE IF(KIB.GT.0) THEN
         CALL PREAD(KIB,NRMAX,DDRR,NRDIM,   WSFOLD)
      ENDIF
C   -----
  340 CONTINUE
C
C --- ABSX --> RUTH.RATIO.X (KRUTAB = 3) -----
      IF(KRUTAB.NE.3) GO TO 400
      DO 410 IT=1,NTHMAX
      XSEX(IT)= XSEX(IT)/RUTX(IT)
      DXEX(IT)= DXEX(IT)/RUTX(IT)
  410 CONTINUE
      KRUTAB= 1
  400 CONTINUE
C
C --- KCHISQ, KSERCH CHECK ---
      KCOLD= KCHISQ
      KSOLD= KSERCH
      KCX= 0
      IF(KCHISQ.EQ.1 .OR. KCHISQ.GE.3) KCX= 1
      KSX= 0
      IF(KSERCH.EQ.1 .OR. KSERCH.EQ.3) KSX= 1
      KCP= 0
      IF(KCHISQ.GE.2) KCP= 1
      KSP= 0
      IF(KSERCH.EQ.2 .OR. KSERCH.EQ.3) KSP= 1
      IF(KCX+KSX+KCP+KSP.LE.0) GO TO 500
      KCHX= 0
      KCHP= 0
      DO 510 IT=1,NTHMAX
      IF(XSEX(IT).LE.0.0 .OR. DXEX(IT).LE.0.0) KCHX= KCHX +1
      IF(DABS(DPEX(IT)).LT.1.0D-30) KCHP= KCHP +1
  510 CONTINUE
      KCHECK= 0
      IF(KCHX.GT.0) THEN
         IF(KCX.GT.0) THEN
            KCHISQ= KCHISQ -1
            KCHECK= KCHECK +1
         END IF
         IF(KSX.GT.0) THEN
            KSERCH= KSERCH -1
            KCHECK= KCHECK +10
         END IF
      END IF
      IF(KCHP.GT.0) THEN
         IF(KCP.GT.0) THEN
            KCHISQ= KCHISQ -2
            KCHECK= KCHECK +100
         END IF
         IF(KSP.GT.0) THEN
            KSERCH= KSERCH -2
            KCHECK= KCHECK +1000
         END IF
      END IF
      IF(KCHECK.GT.0) WRITE(6,520) KCOLD,KSOLD,KCHX,KCHP
     1                            ,KCHECK,KCHISQ,KSERCH
  520 FORMAT(/1H ,5X,'***** ERROR ---'
     1       ,'  KCHISQ, KSERCH =',2I3,', BUT NO EXPERIMENTAL DATA.'
     2 /1H ,10X,'KCHX, KCHP, KCHECK=',3I5
     3 /1H ,10X,'KCHISQ, KSERCH ARE REPLACED BY ',2I3,', RESPECTIVELY.')
  500 CONTINUE
C
      RETURN
      END
CCC
CCC        ******** PREAD ********
CCC                         READ POTENTIAL
CCC
      SUBROUTINE PREAD(KIBAN,NRMAX,DR,NRDIM,   POT)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION POT(NRDIM)
      DIMENSION YY(505),XX(505)
      CHARACTER*80 FORM
C =======================
      NYYDIM= 505
      INTRPO= 0
C
      REWIND KIBAN
      READ(KIBAN,200) FORM
      READ(KIBAN,100) DRX,NRMAXX
  100 FORMAT(F10.6,I10)
C
      WRITE(6,600) KIBAN,DRX,NRMAXX,FORM
  600 FORMAT(/1H ,5X,'=== PREAD ===  KIBAN=',I3,'  DR =',F10.6
     1          ,'  NRMAX=',I6
     2      /1H ,5X,'          ---  ',A,' ---')
C
      READ(KIBAN,200) FORM
  200 FORMAT(A80)
C
      DRCHK=DR/DRX -1.0D0
      IF(DABS(DRCHK).GT.1.0D-5) INTRPO= 1
C
      IF(INTRPO.GT.0) GO TO 300
      IF(NRMAX.LE.NRMAXX) GO TO 2
      WRITE(6,610) NRMAX,NRMAXX
  610 FORMAT(/1H ,'****** IN "PREAD" --- '
     1       ,'NRMAX(ALPS)=',I5,'  >  NRMAX(READ)=',I5
     2 /1H ,22X,'POT(IR) IS ASSUMED TO BE ZERO AT IR > NRMAX(READ).')
    2 NMX= MIN0(NRMAX,NRMAXX)
      READ(KIBAN,FORM) (POT(IR),IR=1,NMX)
      IF(NRMAX.LE.NRMAXX) GO TO 210
      NMX= NRMAX -NRMAXX
      DO 220 IR= 1,NMX
      POT(IR+NRMAXX)= 0.0D0
  220 CONTINUE
  210 GO TO 400
C
  300 CONTINUE
      IF(NYYDIM.GE.NRMAXX) GO TO 3
      WRITE(6,620) NYYDIM,NRMAXX
  620 FORMAT(/1H ,'***** ERROR IN "PREAD" --- NYYDIM=,NRMAXX=',2I5)
      STOP
    3 RMXRED= DRX*(NRMAXX-1)
      RMXNAR= DR*(NRMAX-1)
      IF(RMXRED.GE.RMXNAR) GO TO 4
      WRITE(6,630) RMXRED,RMXNAR
  630 FORMAT(/1H ,'***** ERROR IN "PREAD" --- RMAX(READ)=',F9.4
     1          ,'  <  RMAX(ALPS)=',F9.4)
      STOP
C
    4 CONTINUE
      READ(KIBAN,FORM) (YY(IR),IR=1,NRMAXX)
      DO 310 IR=1,NRMAXX
      XX(IR)= DRX*(IR-1)
  310 CONTINUE
      DO 320 IR=1,NRMAX
      RX= DR*(IR-1)
      POT(IR)= SUPHOD(RX,XX,YY,NRMAXX,NYYDIM)
  320 CONTINUE
C
  400 RETURN
      END
CCC
CCC        ******** PREAD2 ********
CCC                         READ POTENTIAL
CCC
      SUBROUTINE PREAD2(KPOT,KSKIP,KIBAN,NRMAX,DR,NRDIM,   POT)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION POT(NRDIM)
      DIMENSION YY(505),XX(505)
      CHARACTER*80 COMM
C =======================
      NYYDIM= 505
C
      REWIND KIBAN
      
      WRITE(6,600) KIBAN
  600 FORMAT(/1H ,5X,'=== PREAD2 ===  KIBAN=',I3)

      DO 10 N=1,KSKIP-1
      READ(KIBAN,200) COMM
      WRITE(6,601) COMM
  601 FORMAT(1H ,10X,A)
   10 CONTINUE
C
  200 FORMAT(A80)
C
      K1=KPOT-1
      IR=1
      
  300 READ(KIBAN,*,END=310) XX(IR),(DUMM,K=1,K1),YY(IR)
      IF(XX(IR).LT.0.0) GOTO 310
      IR=IR+1
      IF(IR.GT.NYYDIM) THEN
        WRITE(6,620) IR,NYYDIM
  620   FORMAT(/1H ,'***** ERROR IN "PREAD2" --- IR, NYYDIM=',2I5)
        STOP
      ENDIF
      GOTO 300

  310 NRMAXX=IR-1
      DRX=XX(2)-XX(1)
      
      RMXRED= XX(NRMAXX)
      RMXNAR= DR*(NRMAX-1)
      IF(RMXRED.LT.RMXNAR) THEN
        WRITE(6,630) RMXRED,RMXNAR
  630   FORMAT(/1H ,'***** ERROR IN "PREAD2" --- RMAX(READ)=',F9.4
     1          ,'  <  RMAX(ALPS)=',F9.4)
        STOP
      ENDIF

      DRCHK=DR/DRX -1.0D0
      IF(DABS(DRCHK).LE.1.0D-5) THEN
        DO 410 IR=1,NRMAX
        POT(IR)=YY(IR)
  410   CONTINUE
      ELSE
        DO 420 IR=1,NRMAX
        RX= DR*(IR-1)
        POT(IR)= SUPHOD(RX,XX,YY,NRMAXX,NYYDIM)
  420   CONTINUE
      ENDIF
C
  500 RETURN
      END
CCC
CCC        ****** IWRITE ******
CCC
      SUBROUTINE IWRITE(PMASS,TMASS,PZZ,TZZ,PSPIN,TSPIN,IDENT
     1         ,KNTLE,ELAB,ECM,FFMM,FKAY,ETA,RMASS,RMASC2,DELEX
     2         ,RMASNR,ECMNR,FKAYNR
     3         ,LMAX,NTHMAX,DDRR,MATCHR,NRMAX,NPARMX,NSPMAX
     4   ,KSERCH,KAISMX,DCHIMN,INTGWF,KRUTAB,KCHISQ,CHI2MN,KFOLD,KTXNOR
     5   ,KTPARA,KPREIM,KSPLJD,KTLOUT,KFLOUT,CMREAD
     6   ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     7   ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2,KSOTYP,KNXTYP
     8   ,PARMNX,KPASER,PAGRID        ,NSPDIM,NPARDM)
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER*40 CMREAD
      DIMENSION KTPARA(NSPDIM,NPARDM),KPREIM(NPARDM),KSPLJD(NSPDIM)
      DIMENSION KTLOUT(18),KFLOUT(12),KFOLD(4)
      DIMENSION DELEX(5,2),PARMNX(NPARDM,3),KPASER(NPARDM)
      DIMENSION V0R0A(3,2),W0R0A(3,2),WDR0A(3,2),R0COUL(2)
      DIMENSION VSR0A(3,2),WSR0A(3,2),FNRNI(2,2),V2R0A(3,2),VDR0A(3,2)
      DIMENSION FL0AL(2,2),VLDR0A(3,2),WLDR0A(3,2),FSNRNI(2,2),FNXSEX(2)
      DIMENSION V0R0A2(3,2),W0R0A2(3,2)
      DIMENSION KSOTYP(2),PAGRID(3,2)
      CHARACTER JSN(2)*2,NAMEP*2,NAMET*2,SOTYP(2)*6,NXTYP(2)*16
      DATA JSN/'  ','/2'/, SOTYP/'THOMAS','WS-DER'/
      DATA NXTYP/'(XT-N*XE)/(N*XE)','(XT-N*XE)/XE'/
CCC ======================================
C
C --- WRITE TITLE -----
      CALL ELEMNT(PMASS,TMASS,PZZ,TZZ,  MP,MT,NAMEP,NAMET)
C
      ISP= PSPIN*2 +0.01
      IST= TSPIN*2 +0.01
      JSP= ISP -ISP/2*2 +1
      JST= IST -IST/2*2 +1
      IF(JSP.EQ.1) ISP= ISP/2
      IF(JST.EQ.1) IST= IST/2
C
      WRITE(6,600) NAMEP,MP,NAMET,MT,ELAB
     1            ,PMASS,PZZ,ISP,JSN(JSP),TMASS,TZZ,IST,JSN(JST)
     2            ,RMASS,RMASC2
     3            ,CMREAD
  600 FORMAT(1H ///1H ,33X,'))))))) ALPS ((((((('
     1 //1H ,10X,'****** < AUTOMATIC LOCAL (L-DEPENDENT) POTENTIAL'
     2         ,' SEARCH > ******'
     3 //1H ,11X,A2,'(',I3,')  +  ',A2,'(',I3,')    ELASTIC SCATTERING'
     4            ,' AT ELAB=',F10.5,' MEV'
     5 //1H ,20X,'PMASS=',F11.7,'   PZZ=',F7.3,'   PSPIN=',I2,A2
     5  /1H ,20X,'TMASS=',F11.7,'   TZZ=',F7.3,'   TSPIN=',I2,A2
     6  /1H ,35X,'REDUCED MASS=',F10.5,'  =',F10.4,' MEV'
     7 //1H ,10X,'************************************************'
     8         ,'****************'
     9 //1H ,19X,'<< ',A,' >>')
C
C --- WRITE BASIC VALUES -----
      DRHO= DDRR*FKAY
C
      WRITE(6,610) ELAB,ECM,FKAY,ETA,FFMM
  610 FORMAT(/1H ,15X,'ELAB=',F10.5,'  ECM=',F10.5
     1       /1H ,15X,'FKAY=',F10.6,'  ETA=',F10.6,'  FFMM=',1PD15.8)
      WRITE(6,611) LMAX,NTHMAX,DDRR,MATCHR,NRMAX
     1            ,DDRR*(MATCHR-1),DDRR*(NRMAX-1),DRHO
  611 FORMAT(/1H ,15X,'LMAX=',I4,'   NTHMAX=',I4
     1      //1H ,15X,'DDRR=',1PD12.5,'  MATCHR=',I4,'  NRMAX=',I4
     2          ,'  R(MATCH)=',0PF7.3,'  RMAX=',F7.3
     3      /1H ,15X,'DRHO=',1PD12.5)
C
      IF(IDENT.GT.0) THEN
         WRITE(6,612) IDENT
  612    FORMAT(/1H ,15X,',IDENT=',I3
     1            ,'   --- (( IDENTICAL PARTICLE CALCULATION )) ---')
      END IF
C
      IF(KNTLE.GT.1) THEN
        IF(KNTLE.EQ.2) THEN
          WRITE(6,622) KNTLE
  622   FORMAT(/1H ,10X,'===== RELATIVISTIC KINEMATICS CORRECTION ====='
     1     ,'  KNTLE=',I2,'  (( TYPE I ))')
        ELSEIF(KNTLE.EQ.3) THEN
          WRITE(6,623) KNTLE
  623   FORMAT(/1H ,10X,'===== RELATIVISTIC KINEMATICS CORRECTION ====='
     1     ,'  KNTLE=',I2,'  (( TYPE II ))')
        ELSEIF(KNTLE.EQ.4) THEN
          WRITE(6,624) KNTLE
  624   FORMAT(/1H ,10X,'===== RELATIVISTIC KINEMATICS CORRECTION ====='
     1     ,'  KNTLE=',I2,'  (( TYPE III ))')
        ELSEIF(KNTLE.EQ.5) THEN
          WRITE(6,625) KNTLE
  625   FORMAT(/1H ,10X,'===== RELATIVISTIC KINEMATICS CORRECTION ====='
     1     ,'  KNTLE=',I2,'  (( TYPE IV ))')
        ENDIF
        WRITE(6,629) RMASS,ECM,FKAY,RMASNR,ECMNR,FKAYNR
  629   FORMAT(/1H ,15X,7X,'    RMASS   ',5X,'ECM',5X,'    FKAY    '
     1        /1H ,15X,'REL. : ',F12.6,2X,F11.5,2X,F10.6
     2        /1H ,15X,'N.R. : ',F12.6,2X,F11.5,2X,F10.6)
      ENDIF
C
C --- WRITE POTENTIAL PARAMETER -----
      T3= TMASS**(1.0D0/3.0D0)
      RR = V0R0A(2,1)*T3
      RI = W0R0A(2,1)*T3
      RID= WDR0A(2,1)*T3
      RC = R0COUL( 1)*T3
      RSR= VSR0A(2,1)*T3
      RSI= WSR0A(2,1)*T3
      R2R= V2R0A(2,1)*T3
      RRD= VDR0A(2,1)*T3
      RRLD= VLDR0A(2,1)*T3
      RILD= WLDR0A(2,1)*T3
      RR2= V0R0A2(2,1)*T3
      RI2= W0R0A2(2,1)*T3
C
      WRITE(6,630) (V0R0A( I, 1),I=1,3),RR
     1            ,(W0R0A( I, 1),I=1,3),RI,(WDR0A( I, 1),I=1,3),RID
     2            ,R0COUL( 1),RC
  630 FORMAT(1H1
     1 /1H ,15X,'===== INITIAL VALUE OF POTENTIAL PARAMETERS ====='
     2 //1H ,18X,'< 1> V0 =',F11.6,'   < 2> R0R =',F8.5
     3                          ,'   < 3> AR =',F8.5,'   RR =',F9.5
     4 /1H ,18X,'< 4> W0 =',F11.6,'   < 5> R0I =',F8.5
     5                          ,'   < 6> AI =',F8.5,'   RI =',F9.5
     6 /1H ,18X,'< 7> WD =',F11.6,'   < 8> R0ID=',F8.5
     7                          ,'   < 9> AID=',F8.5,'   RID=',F9.5
     8 /1H ,38X,'   <10> R0C =',F8.5,20X,'   RCL=',F9.5)
      WRITE(6,631) (VSR0A( I, 1),I=1,3),RSR,SOTYP(KSOTYP(1)+1)
     1            ,(WSR0A( I, 1),I=1,3),RSI,SOTYP(KSOTYP(2)+1)
     2            ,FNRNI( 1, 1),FNRNI( 2, 1),KFOLD(1),KFOLD(2)
     3            ,(V2R0A( I, 1),I=1,3),R2R,(VDR0A( I, 1),I=1,3),RRD
  631 FORMAT(
     1  1H ,18X,'<11> VSO=',F11.6,'   <12> R0RS=',F8.5
     2                          ,'   <13> ARS=',F8.5,'   RRS=',F9.5
     3                          ,3X,'-- "',A6,' FORM"'
     4 /1H ,18X,'<14> WSO=',F11.6,'   <15> R0IS=',F8.5
     5                          ,'   <16> AIS=',F8.5,'   RIS=',F9.5
     6                          ,3X,'-- "',A6,' FORM"'
     7 //1H ,18X,'<17> NR =',F11.6,'   <18>  NI =',F11.6
     8                         ,'    KIBAN (R,I) =',2I5
     9 //1H ,18X,'<19> V2 =',F11.6,'   <20> R0R2=',F8.5
     1                          ,'   <21> AR2=',F8.5,'   RR2=',F9.5
     2 /1H ,18X,'<22> VD =',F11.6,'   <23> R0RD=',F8.5
     3                          ,'   <24> ARD=',F8.5,'   RRD=',F9.5)
      WRITE(6,632) (FL0AL( I, 1),I=1,2)
     2     ,(VLDR0A( I, 1),I=1,3),RRLD,(WLDR0A( I, 1),I=1,3),RILD
  632 FORMAT(
     1 /1H ,41X,'<25> FL0  =',F8.5,'   <26> AL  =',F8.5
     2 /1H ,18X,'<27> VLD=',F11.6,'   <28> R0RLD=',F8.5
     3                          ,'   <29> ARLD=',F8.5,'   RRLD=',F9.5
     4 /1H ,18X,'<30> WLD=',F11.6,'   <31> R0ILD=',F8.5
     5                          ,'   <32> AILD=',F8.5,'   RILD=',F9.5)
      WRITE(6,633) (FSNRNI( I, 1),I=1,2),KFOLD(3),KFOLD(4)
     1             ,FNXSEX(1),NXTYP(KNXTYP+1)
  633 FORMAT(
     1 /1H ,18X,'<33> NRS=',F11.6,'   <34>  NIS=',F11.6
     2                         ,'    KIBAN (R,I) =',2I5
     3 //1H ,18X,'<35> NXSEX=',F11.6,3X,'--"',A,' TYPE"')
      WRITE(6,634) (V0R0A2( I, 1),I=1,3),RR2,(W0R0A2( I, 1),I=1,3),RI2
  634 FORMAT(
     1 //1H ,18X,'<36> V02=',F11.6,'   <37> R0R2=',F8.5
     2                          ,'   <38> AR02=',F8.5,'   RR2=',F9.5
     3 /1H ,18X,'<39> W02=',F11.6,'   <40> R0I2=',F8.5
     4                          ,'   <41> AI02=',F8.5,'   RI2=',F9.5)
C
C --- WRITE CONTROL PARAMETER -----
      WRITE(6,640)
  640 FORMAT(//1H ,15X,'===== SEARCH CONTROL PARAMETERS =====')
      GO TO (641,642,643,644),KSERCH
      WRITE(6,650) KSERCH,KAISMX,DCHIMN,INTGWF,KCHISQ,CHI2MN
     1            ,KRUTAB,NSPMAX,NPARMX
  650 FORMAT(/1H ,20X,'KSERCH=',I3,'  KAISMX=',I4,'  DCHIMN=',1PD12.4
     1     ,'  INTGWF=',I3,'  KCHISQ=',I3,'  CHI2MN=',D12.4
     2      /1H ,20X,'KRUTAB=',I3,'  NSPMAX=',I3,'   NPARMX=',I3
     3      /1H ,25X,'*** (( NO SEARCH )) *****')
      GO TO 659
  641 WRITE(6,651) KSERCH,NSPMAX,NPARMX
  651 FORMAT(/1H ,20X,'KSERCH=',I3,'   NSPMAX=',I3,'   NPARMX=',I3
     1          ,' --- (( SEARCH BY X-SECTION ))')
      GO TO 658
  642 WRITE(6,652) KSERCH,NSPMAX,NPARMX
  652 FORMAT(/1H ,20X,'KSERCH=',I3,'   NSPMAX=',I3,'   NPARMX=',I3
     1          ,' --- (( SEARCH BY POLARIZATION ))')
      GO TO 658
  643 WRITE(6,653) KSERCH,NSPMAX,NPARMX
  653 FORMAT(/1H ,20X,'KSERCH=',I3,'   NSPMAX=',I3,'   NPARMX=',I3
     1  ,' --- (( SEARCH BY X-SECTION & POLARIZATION ))')
      GO TO 658
  644 WRITE(6,654) KSERCH,NSPMAX,NPARMX,PAGRID(1,1),INT(PAGRID(2,1)+0.1)
     1                                 ,PAGRID(1,2),INT(PAGRID(2,2)+0.1)
  654 FORMAT(/1H ,20X,'KSERCH=',I3,'   NSPMAX=',I3,'   NPARMX=',I3
     1  ,' --- (( GRID CALCULATION -- NO SEARCH ))'
     2      /1H ,20X,'1-ST PARAMETER : DEL-PAR=',F12.6,'  KAISUU=',I4
     3      /1H ,20X,'2-ND PARAMETER : DEL-PAR=',F12.6,'  KAISUU=',I4/)
C
  658 WRITE(6,657) KAISMX,DCHIMN,CHI2MN,INTGWF
     1            ,KRUTAB,KCHISQ,KTXNOR
  657 FORMAT(1H ,20X,'KAISMX=',I4,'  DCHIMN=',1PD12.4,'  CHI2MN=',D12.4
     1            ,'  INTGWF=',I3
     2      /1H ,20X,'KRUTAB=',I3,'   KCHISQ=',I3,'   KTXNOR=',I3)
C
      NN= 0
      DO 671 NS=1,NSPMAX
      DO 672 NP=1,NPARDM
      IF(KTPARA(NS,NP).LE.0) GO TO 672
      NN= NN +1
      KPASER(NN)= NP
  672 CONTINUE
  671 CONTINUE

      WRITE(6,660) (kpaser(I),I=1,NN)
  660 FORMAT(/1H ,30X,'   *** KTPARA(NS,NP) ***'
     1      //1H ,5X,' NS   ','  KSPLJD  NP ',50('-',I2))
      DO 661 NSP=1,NSPMAX
      WRITE(6,662) NSP,KSPLJD(NSP),(KTPARA(NSP,kpaser(I)),I=1,NN)
  662 FORMAT(1H ,5X,I3,' : ',3X,I3,7X,30(1X,I2))
  661 CONTINUE
      WRITE(6,663) (KPREIM(kpaser(I)),I=1,NN)
  663 FORMAT(/1H ,6X,'KPREIM(NP)  :',5X,30(1X,I2))
C
      WRITE(6,670)
  670 FORMAT(//1H ,10X,'*** MINIMUM & MAXIMUM LIMITATION VALUES ***')
      DO 673 N1=1,NN,8
      N2= MIN0(N1+7, NN)
      WRITE(6,674) (KPASER(N),N=N1,N2)
      WRITE(6,675) ( PARMNX( KPASER(N), 1),N=N1,N2)
      WRITE(6,676) ( PARMNX( KPASER(N), 2),N=N1,N2)
  674 FORMAT(/1H ,5X,'PARM. NUM. =',8(6X:'< ',I2,' >',2X))
  675 FORMAT(1H ,5X,'   MINIMUM :',1P8D14.5)
  676 FORMAT(1H ,5X,'   MAXIMUM :',1P8D14.5)
  673 CONTINUE
C
      DO 677 I=1,NPARDM
      KPASER(I)= 0
  677 CONTINUE
C
  659 CONTINUE
      WRITE(6,678) ((DELEX(I,J),I=1,5),J=1,2)
  678 FORMAT(//1H ,10X,'*** EXPERIMENTAL DATA CONTROL ***'
     1      /1H ,15X,'DELEX( XS)=',5F11.5
     2      /1H ,15X,'DELEX(POL)=',5F11.5)
C
C --- WRITE KTLOUT & KFLOUT ------
      WRITE(6,680) 
  680 FORMAT(//1H ,15X,'===== OUTPUT CONTROL =====')
      WRITE(6,681) (I,I=1,12),(KTLOUT(I),I=1,18),(KFLOUT(I),I=1,12)
  681 FORMAT(//1H ,17X,' K/ I',12(1X,'-',I2,'-',4X)
     1        /1H ,7X,'KTLOUT(I)',6X,12(1X,I3,5X)
     2        /1H ,7X,'KTLOUT(I+12)',3X,6(1X,I3,5X)
     3        /1H ,7X,'KFLOUT(I)',6X,12(1X,I3,5X))
C
      RETURN
      END
CCC
CCC        ***** FUNDER *****
CCC
      SUBROUTINE FUNDER(XPARM,CHI2T,C2PERP,CXP,KTLCXP,KAISUU,KCHECK
     1                 ,NSPDIM,NSPDM1)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION XPARM(NSPDIM),CXP(NSPDIM,NSPDM1)
C
      COMMON /CONTRL/ KSERCH,KAISMX,DCHIMN,INTGWF,KRUTAB,KCHISQ,KTXNOR
     1               ,KTLOUT,KFLOUT
      COMMON /BASIC/ PMASS,TMASS,PZZ,TZZ,PSPIN,TSPIN
     1              ,ELAB,ECM,FKAY,ETA,ZZHCAL,FFMM,DDRR,NRMAX
     2              ,LMAX,NTHMAX,IDENT
      COMMON /PARA/ PARM,PARMNX,NSPMAX,NPARMX,KTPARA,KPREIM,KSPLJD
      COMMON /XSPL/ THETAD,AXTH,RXTH,XSEX,DXEX,POLTH,POLEX,DPEX,REACX
      COMMON /CHIXP/ XCHI,PCHI,XCHIT,PCHIT,CHISQT
      COMMON /POTPAR/ V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI
     1               ,V2R0A,VDR0A,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX
     2               ,V0R0A2,W0R0A2,KSOTYP,KNXTYP
      COMMON /POTEN/ UCE,USO,ULJ,VCL,FLJFAC
      COMMON /POTFLD/ VFOLD,WFOLD,VSFOLD,WSFOLD
      COMMON /SMATRX/ SMAT,DSMAT
      COMMON /SAMP/ FNC
      COMMON /STORE/ EXSIG2,FCL,VUCL,DUCL,PLM,RUTX,SIGMA0
      COMMON /DIMNSN/ NPARDM,NRDIM,NTHDIM,NTHDMP
     1               ,LDIM,MDIM,NUEDM1,NUEDM2,NJDIM
C
      DIMENSION KTLOUT(18),KFLOUT(12)
      DIMENSION PARM(50),PARMNX(50,3)
     1         ,KTPARA(20,50),KPREIM(50),KSPLJD(20)
      DIMENSION THETAD(245),AXTH(245),RXTH(245),XSEX(241),DXEX(241)
     1         ,POLTH(245),POLEX(241),DPEX(241)
      DIMENSION XCHI(241),PCHI(241),CHISQT(2)
      DIMENSION V0R0A(3,2),W0R0A(3,2),WDR0A(3,2),R0COUL(2)
     1         ,VSR0A(3,2),WSR0A(3,2),FNRNI(2,2),V2R0A(3,2),VDR0A(3,2)
     2         ,FL0AL(2,2),VLDR0A(3,2),WLDR0A(3,2),FSNRNI(2,2),FNXSEX(2)
     3         ,V0R0A2(3,2),W0R0A2(3,2),KSOTYP(2)
      COMPLEX*16 UCE(504),USO(504),ULJ(504)
      DIMENSION VCL(504),FLJFAC(206)
      DIMENSION VFOLD(504),WFOLD(504),VSFOLD(504),WSFOLD(504)
      COMPLEX*16 SMAT(206,4),DSMAT(20,206,4)
      COMPLEX*16 FNC(245,4,2)
      COMPLEX*16 EXSIG2(206),FCL(245),VUCL(206,2),DUCL(206,2)
      DIMENSION PLM(245,206,4),RUTX(245)
C
      COMPLEX*16 UPDER(504,20)
      DIMENSION VPDER(504,50),PDFACT(50)
      COMPLEX*16 UWF(504),SMATN,UNORM,VDUCL(4)
      COMPLEX*16 DFNC(20,241,4,2),DTEMP(20)
      DIMENSION DXTH(20,241),DPTH(20,241) ,SABS(206,4)
CCC =================================
C
      KXPDER= KSERCH
      IF(KTLCXP.LE.0) KXPDER= 0
      FSS= PSPIN
      FSS1= FSS +1.0D0
      NUE21= 2*FSS +1.01
      LDEL= 1
      IF(IDENT.GT.0) LDEL= 2
C
      FM= FFMM
      DR= DDRR
      KCHECK= 0
C
      KAKPOT= KTLOUT( 7)
      KAKDPO= KTLOUT( 8)
      KAKUWF= KTLOUT( 9)
      KAKSMT= KTLOUT(10)
      KAKDSM= KTLOUT(11)
      KAKFNC= KTLOUT(12)
      KAKDFN= KTLOUT(13)
      KAKXPL= KTLOUT(14)
      KAKDXP= KTLOUT(15)
      KAKCXP= KTLOUT(16)
      KAKTPL= KTLOUT(17)
      IF(KXPDER.GT.0) GO TO 1
      KAKDPO= 0
      KAKDSM= 0
      KAKDFN= 0
      KAKDXP= 0
      KAKCXP= 0
      IF(KAISUU.GE.0) GO TO 1
      KAKPOT= 0
      KAKUWF= 0
      KAKSMT= 0
      KAKFNC= 0
      KAKXPL= 0
      KAKTPA= 0
    1 CONTINUE
C
      IF(KAISUU.LT.0) GO TO 400
C
C --- CHANGE POTENTIAL PARAMETERS -----
      CALL PCHANG(KSERCH,NSPMAX,NPARMX,KXPDER
     1       ,PARM,PARMNX,KTPARA,XPARM
     2       ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     3       ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2
     4       ,NSPDIM,NPARDM)
C
C -----
C
  100 CONTINUE
C --- GENERATE POTENTIAL -----
      CALL POTGEN(PMASS,TMASS,ZZHCAL,DR,NRMAX,LMAX,KAKPOT,KSOTYP
     1           ,PARM,VFOLD,WFOLD,VSFOLD,WSFOLD, NRDIM,NPARDM,LDIM
     2                                  ,UCE,USO,ULJ,VCL,FLJFAC)
C
C -----
C
      IF(KXPDER.LE.0) GO TO 200
C --- DERIVATIVE OF POTENTIAL -----
      CALL POTDER(TMASS,ZZHCAL,DR,NRMAX,NSPMAX,NPARMX,INTGWF
     1      ,PARM,KTPARA,KSPLJD,KPREIM,KAKDPO,KSOTYP
     2      ,VFOLD,WFOLD,VSFOLD,WSFOLD
     3      ,NRDIM,NSPDIM,NPARDM, VPDER,PDFACT,UPDER)
C
C -----
  200 CONTINUE
C
C =========  L - LOOP  ===========
      DO 1000 L1= 1 , LMAX+1 , LDEL
C
      LL= L1 -1
      FLL= LL
      LL1= L1
      FJMIN= DABS(FLL-FSS) -0.01
C
      VDUCL( 1)= VUCL(L1, 1)
      VDUCL( 2)= VUCL(L1, 2)
      VDUCL( 3)= DUCL(L1, 1)
      VDUCL( 4)= DUCL(L1, 2)
C
C =========  J - LOOP  ===========
      DO 1100 NJ=1,NUE21
C
      FJJ= FLL +NJ -FSS1
      SMAT(LL1,NJ)= 0.0D0
      SABS(LL1,NJ)= 0.0D0
      IF(FJJ.LE.FJMIN) GO TO 1100
      NNJJ= NJ
C
C --- L,J-DEPENDENT FACTOR -----
      CALL POTGLJ(KXPDER,FSS,FLL,FJJ,NSPMAX,NPARMX,NRMAX,INTGWF
     1             ,KTPARA,PARM,PDFACT,KSPLJD,KPREIM,VPDER,ULJ,FLJFAC
     2             ,NRDIM,NSPDIM,NPARDM,LDIM, FACTLS,FACTLJ,UPDER)
C
C -----
C
C --- SOLVE S-MATRIX & WAVE FUNCTION -----
      CALL NARCS4(FM,ECM,FKAY,LL,FACTLS,FACTLJ,VDUCL
     1            ,UCE,USO,ULJ,VCL,NRMAX,DR,NRDIM, KAKUWF
     2                              ,SMATN,SABSN,UNORM,UWF)
C
      SMAT(LL1,NNJJ)= SMATN
      SABS(LL1,NNJJ)= SABSN
C
C -----
C
      IF(KXPDER.LE.0) GO TO 300
C --- DERIVATIVE OF S-MATRIX -----
      CALL SLJDER(FFMM,FKAY,DDRR,NRMAX,NSPMAX,INTGWF
     1                 ,UWF,UPDER,UNORM, NRDIM,NSPDIM
     2                     ,DTEMP)
C
      DO 310 NS=1,NSPMAX
      DSMAT(NS,LL1,NNJJ)= DTEMP(NS)
  310 CONTINUE
C
C ------
  300 CONTINUE
C
 1100 CONTINUE
C
 1000 CONTINUE
C
C
C --- WRITE S-MATRIX -----
      IF(KAKSMT+KAKDSM.LE.0) GO TO 400
      CALL SWRITE(PSPIN,KAISUU,LMAX,NSPMAX,IDENT,FKAY,SMAT,DSMAT
     1                 ,LDIM,NJDIM,NSPDIM    ,KAKSMT,KAKDSM)
C
C -----
  400 CONTINUE
C
C --- CALCULATE SCATTERING AMPLITUDE -----
      CALL SCTAMP(FKAY,PSPIN,LMAX,NTHMAX,NSPMAX,IDENT,KAISUU
     1        ,KXPDER,KAKFNC,KAKDFN
     2           ,SMAT,DSMAT,SABS,EXSIG2,PLM,FCL,THETAD
     3           ,LDIM,NJDIM,MDIM,NTHDIM,NTHDMP,NUEDM1,NUEDM2,NSPDIM
     4                ,REACX,FNC,DFNC,DTEMP)
C
C -----
C
C --- CALCULATE X-SECTION & POLARIZATION -----
      FACNXS=PARM(35)
      CALL XSCPOL(PSPIN,NTHMAX,NSPMAX,REACX
     1     ,KXPDER,KCHISQ,KRUTAB,KTXNOR,KAISUU,KAKXPL,KAKDXP,KAKCXP
     2     ,FNC,DFNC,THETAD,NTHDIM,NTHDMP,NUEDM1,NUEDM2,NSPDIM,NSPDM1
     3     ,XSEX,DXEX,POLEX,DPEX,FACNXS,KNXTYP
     4               ,AXTH,RXTH,RUTX,POLTH,DXTH,DPTH
     5               ,XCHIT,PCHIT,XCHI,PCHI,CXP)
C
      CHI2T= XCHIT +PCHIT
      IF(KSERCH.EQ.1) CHI2T= XCHIT
      IF(KSERCH.EQ.2) CHI2T= PCHIT
      IF(KAISUU.EQ.0.AND.KXPDER.GT.0) CHISQT(1)= CHI2T
      CHISQT(2)= CHI2T
      C2PERP= CHI2T/NTHMAX
C
C -----
C
C
 9000 RETURN
      END
CCC
CCC        ****** LOCMIN ******
CCC
      SUBROUTINE LOCMIN(NOVAR,KM,AKOFF,CHI2MN,IPRINT,KCHECK
     1                 ,START,X,C,XI,DELX,PHY,Z,W
     2                 ,NSPDIM,NSPDM1 ,ENDCOD)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION START(NSPDIM),X(NSPDIM),C(NSPDIM,NSPDM1)
      DIMENSION XI(NSPDIM),DELX(NSPDIM),PHY(NSPDIM)
      DIMENSION Z(NSPDIM),W(NSPDIM)
      CHARACTER*6 ENDCOD
C     DATA CHI2Z/0./
CCC ==============================
      KOFF=0
      CHI2Z= 0.0
      NOVAR1=NOVAR+1
      NOVAR2=NOVAR-1
      LC=0
      NCUT=1
      FAC=1.0
      DO 20 I=1,NOVAR
      DELX(I)= 0.0
      PHY(I)= 0.0
      Z(I)= 0.0
   20 XI(I)=X(I)
C
      WRITE(6,'(1H1)')
      IF(IPRINT-1) 400,400,31
   31 WRITE(6,100) NOVAR
  100 FORMAT(//1H ,5X,'====== SEARCH PROCESS ======'
     1    //1H ,'   * SEARCH *        NSPMAX=',I4
     2     /1H ,'   * NUMBER *',9X,'CHI2T',15X,'C2PERP',15X,'CHANGE')
C
C ======== SEARCH ROUTINE ==========
  400 CONTINUE
C
C --- AT POINT X0 -----
      KW= 1
      CALL FUNDER(X,CHI2T,C2PERP,C,KW,KOFF,KCHECK ,NSPDIM,NSPDM1)
      IF(KCHECK) 449,449,7000
C -----
  449 DEL0=CHI2T
   30 GO TO (450,35),IPRINT
   35 CONTINUE
      DO 40 JJ=1,NOVAR
      W(JJ)=X(JJ)*START(JJ)
      DELX(JJ)= X(JJ) - XI(JJ)
   40 CONTINUE
      CHNG= 0.0
      IF(KOFF) 101,101,102
  102 CHNG= (PRCHI-CHI2T)/CHI2T
  101 WRITE(6,110) KOFF,CHI2T,C2PERP,CHNG
  110 FORMAT(/1H ,4X,I4,8X,1PD16.8,5X,D16.8,5X,D16.8)
      DO 111 I=1,NOVAR,3
      I1= MIN0(I+2,NOVAR)
      WRITE(6,112) (W(I2),DELX(I2),I2=I,I1)
  112 FORMAT(1H ,7X,3(2X,1PD16.8,' (',D16.8,' )'))
  111 CONTINUE
C
  450 CONTINUE
      DO 420 I=1,NOVAR
      Z(I)=0.0
      XI(I)= X(I)
      DELX(I)=0.0
  420 PHY(I)=0.0
      DO 50 JJ=1,NOVAR
   50 C(JJ,NOVAR1)=C(JJ,NOVAR1)*START(JJ)
      DO 60 JJ=1,NOVAR
      DO 60 JK=1,NOVAR
   60 C(JJ,JK)=C(JJ,JK)*START(JJ)*START(JK)
C
      IF(KOFF) 520,520,460
C
C --- CHECK OF CONVERGENCE -----
  460 LC=0
      IF(CHI2T-CHI2Z) 468,468,461
  461 CHI2T=CHI2Z
  468 IF(CHI2T-PRCHI) 470,470,550
  470 CHANGE=(PRCHI-CHI2T)/CHI2T
  500 IF(CHANGE-AKOFF) 540,540,510
  510 IF(CHI2T-CHI2MN) 570,570,520
  520 IF(KOFF-KM) 530,530,620
C -----
C
  530 PRCHI=CHI2T
      GO TO 630
C
C --- CHECK OF ENDING CONDITION -----
  540 LC=3
      GO TO 1320
  550 IF(NCUT-1) 560,560,610
  560 KOFF=0
      NCUT=2
      WRITE(6,590)
  590 FORMAT(/1H ,2X,'------ CUT DX ------')
      FAC=5.0
      GO TO 520
  570 LC=5
      GO TO 1320
  610 LC=4
      CHI2T=PRCHI
      GO TO 1320
  620 LC=1
      GO TO 1320
C -----
C
C --- SOLVE A LINEAR EQUATION -----
  630 IF(NOVAR-1) 742,742,750
C  --- FOR ONE VARIABLE -----
  742 Z(1)=C(1,2)/C(1,1)
      GO TO 880
C
C  --- FOR MANY VARIABLES -----
  750 CONTINUE
      DO 820 NL=1,NOVAR2
      AC= DABS(C(NL,NL))
      IC=NL
      I1=NL+1
C
      DO 770 I=I1,NOVAR
      BC= DABS(C(I,NL))
      IF(AC-BC) 760,770,770
  760 AC=BC
      IC=I
  770 CONTINUE
C
      DO 780 K=NL,NOVAR1
      DK=C(NL,K)
      C(NL,K)=C(IC,K)
  780 C(IC,K)=DK
C
      DO 790 J=I1,NOVAR1
      C(NL,J)=C(NL,J)/C(NL,NL)
      DO 790 I=I1,NOVAR
  790 C(I,J)=C(I,J)-C(I,NL)*C(NL,J)
C
  820 CONTINUE
C
      Z(NOVAR)=C(NOVAR,NOVAR1)/C(NOVAR,NOVAR)
C
  850 DO 870 I=2,NOVAR
      IS=NOVAR-I+2
      SUML=0.0
      DO 860 J=IS,NOVAR
  860 SUML=SUML+C(IS-1,J)*Z(J)
  870 Z(IS-1)=C(IS-1,NOVAR1)-SUML
C -----
C
C --- PHY PARAMETERS -----
  880 CONTINUE
      DO 910 I=1,NOVAR
      DELX(I)=Z(I)
      PHY(I)=100.0*Z(I)*FAC
  910 CONTINUE
C
      PHYM= DABS(PHY(1))
      DO 930 I=2,NOVAR
      AC= DABS(PHY(I))
      IF(PHYM-AC) 920,930,930
  920 PHYM=AC
  930 CONTINUE
C
      IF(PHYM-10.) 980,940,940
  940 IF(PHYM-30.) 990,950,950
  950 IF(PHYM-50.) 1000,960,960
  960 IF(PHYM-100.) 1010,970,970
  970 ZA=5.0/PHYM
      GO TO 1020
  980 ZA=1.0
      GO TO 1020
  990 ZA=0.5
      GO TO 1020
 1000 ZA=0.2
      GO TO 1020
 1010 ZA=0.1
C
 1020 CONTINUE
      DO 1030 I=1,NOVAR
 1030 X(I)=XI(I)+ZA*DELX(I)
C
C --- CHI-SQUARE AT X = X0 + Z*DELX -----
      KW= 0
      CALL FUNDER(X,CHI2T,C2PERP,C,KW,KOFF,KCHECK ,NSPDIM,NSPDM1)
      IF(KCHECK) 1031,1031,7000
C -----
 1031 KRAZY=0
      DEL1=CHI2T
 1032 CHI2Z=CHI2T
 1036 IF(KRAZY-1) 1037,1080,1080
 1037 IF(DEL0-DEL1) 1060,1040,1040
C
C --- CHI-SQUARE AT POINT XB -----
 1040 ZB=2.0*ZA
      DO 1050 I=1,NOVAR
 1050 X(I)=XI(I)+ZB*DELX(I)
      KW= 0
      CALL FUNDER(X,CHI2T,C2PERP,C,KW,KOFF,KCHECK ,NSPDIM,NSPDM1)
      IF(KCHECK) 1055,1055,7000
 1055 DEL2=CHI2T
      GO TO 1072
C
C --- CHI-SQUARE AT POINT XA -----
 1060 DEL2=DEL1
      ZB=ZA
      ZA=0.5*ZA
      DO 1070 I=1,NOVAR
 1070 X(I)=XI(I)+ZA*DELX(I)
      KW= 0
      CALL FUNDER(X,CHI2T,C2PERP,C,KW,KOFF,KCHECK ,NSPDIM,NSPDM1)
      IF(KCHECK) 1071,1071,7000
 1071 DEL1=CHI2T
C
 1072 IF(CHI2Z-CHI2T) 1080,1080,1073
 1073 KRAZY=1
      GO TO 1032
C
C --- PARABOLIC APPROXIMATION -----
 1080 AC=DEL0-2.0*DEL1+DEL2
      IF(AC) 1150,1090,1110
C
 1090 WRITE(6,1100) DEL0,DEL1,DEL2
 1100 FORMAT(/1H ,'***** DEL0 DEL1 AND DEL2 ARE ON A STRAIGHT LINE'
     1      /1H ,10X,'DEL0,DEL1,DEL2=',1P3D13.5)
      LC=2
      GO TO 1320
C
 1110 ZM=ZB*((DEL0-DEL2)/(4.0*AC)+0.5)
      IF(ZM+ZB) 1120,1130,1130
 1120 ZM=-ZB
      GO TO 1180
 1130 IF(ZM-ZB) 1180,1140,1140
 1140 ZM=2.0*ZB
      GO TO 1180
C
 1150 IF(DEL2-DEL0) 1160,1170,1170
 1160 ZM=3.0*ZA
      GO TO 1180
 1170 ZM=-ZA
C
C --- NEW STARING POINT X0 -----
 1180 CONTINUE
      DO 1190 I=1,NOVAR
      X(I)= XI(I) +ZM*DELX(I)
 1190 CONTINUE
      KOFF=KOFF+1
      GO TO 400
C ==========================================
C
C --- WRITE ENDING CONDITION -----
 1320 NCUT=1
      GO TO (1450,1600,1510,1490,1530),LC
 1450 WRITE(6,1460) KM,KOFF
 1460 FORMAT(/1H ,'*** SEARCH LIMITED BY KAISMX=',I5,'   KAISUU=',I5)
      ENDCOD= 'KAISMX'
      GO TO 7000
 1490 WRITE(6,1500) NCUT,KOFF
 1500 FORMAT(/1H ,'*** SEARCH LIMITED BY NCUT=',I5,'   KAISUU=',I5)
      ENDCOD= 'NCUT  '
      GO TO 7000
 1510 WRITE(6,1520) CHANGE,AKOFF,KOFF
 1520 FORMAT(/1H ,'*** SEARCH LIMITED BY CHANGE=',1PD13.5,'  <  '
     1          ,'DCHIMN=',D13.5,'    KAISUU=',I5)
      ENDCOD= 'CHANGE'
      GO TO 7000
 1530 WRITE(6,1540) CHI2T,CHI2MN,KOFF
 1540 FORMAT(/1H ,'*** SEARCH LIMITED BY CHI2T=',1PD13.5,'  <  '
     1          ,'CHI2MN=',D13.5,'    KAISUU=',I5)
      ENDCOD= 'CHI2T '
      GO TO 7000
 1600 KCHECK=5
 7000 RETURN
      END
CCC
CCC        ***** GRID *****
CCC
      SUBROUTINE GRID(NSPMAX,PAGRID,NTHMAX
     1               ,XPARM,CXP, NSPDIM,NSPDM1)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION PAGRID(3,2)
      DIMENSION XPARM(NSPDIM),CXP(NSPDIM,NSPDM1)
C
      COMMON /CHIXP/ XCHI,PCHI,XCHIT,PCHIT,CHISQT
      DIMENSION XCHI(241),PCHI(241),CHISQT(2)
CCC ===============================================
      IF(NSPMAX.GT.2 .OR. NSPMAX.LE.0) THEN
         WRITE(6,100) NSPMAX
  100    FORMAT(///1H ,'*** ERROR --- GRID CALCULATION,'
     1         ,' BUT NSPMAX=',I3,'  > 2  OR  < 1.')
         STOP
      END IF
C
      NMAX1= PAGRID(2,1) +0.1
      NMAX2= PAGRID(2,2) +0.1
      IF(NSPMAX.LE.1) NMAX2= 0
      NMAX1= MAX0( NMAX1, 1)
      NMAX2= MAX0( NMAX2, 1)
      P01= PAGRID(3,1)
      P02= PAGRID(3,2)
      IF(DABS(P01).GT.1.0D-10) XD1= PAGRID(1,1)/P01
      IF(DABS(P02).GT.1.0D-10) XD2= PAGRID(1,2)/P02
C
      KTLCXP= 0
      KAISUU= 0
      WRITE(6,6000)
 6000 FORMAT(1H1//1H ,5X,'===== GRID CALCULATION ====='
     1      /1H ,55X,'  --- PER POINT ---'
     2      /1H ,2X,' N1  N2   ','   PARM.-1  ',2X,'   PARM.-2  ',2X
     3     ,5X,'CHI2T',6X,5X,'XCHIT',6X,5X,'PCHIT',6X,7X,'CHI2T',6X
     4     ,5X,'XCHIT',6X,5X,'PCHIT')
C
      DO 1000 N2= 1, NMAX2
      XX= 1.0D0 +XD2*(N2-1)
      XPARM( 2)= XX
      P2= P02*XX
C
      DO 1100 N1= 1, NMAX1
      XX= 1.0D0 +XD1*(N1-1)
      XPARM( 1)= XX
      P1= P01*XX
C
      CALL FUNDER(XPARM,CHI2T,C2PERP,CXP,KTLCXP,KAISUU,KCHECK
     1                 ,NSPDIM,NSPDM1)
C
      WRITE(6,6100) N1,N2,P1,P2
     1             ,CHI2T/NTHMAX,XCHIT/NTHMAX,PCHIT/NTHMAX
     2             ,CHI2T,XCHIT,PCHIT
 6100 FORMAT(1H ,2X,I3,I4,':',2X,F12.6,2X,F12.6,2X,1P3D15.6,2X,3D15.6)
C
 1100 CONTINUE
C
      WRITE(6,'(1H )')
 1000 CONTINUE
C
      RETURN
      END
CCC
CCC        ******** TENPOL *******
CCC
      SUBROUTINE TENPOL(PSPIN,NTHMAX,KAKTPA,KAKWOL
     1                 ,FNC,THETAD,AXTH,NTHDMP,NUEDM1,NUEDM2
     2                      ,TPOL,TANL)
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 FNC(NTHDMP,NUEDM1,NUEDM2)
      DIMENSION THETAD(NTHDMP),AXTH(NTHDMP)
C
      DIMENSION TPOL(NTHDMP,4),TANL(NTHDMP,4)
C
      COMPLEX*16 FTEMP1,FTEMP2,GG,HH
      COMPLEX*16 WI/(0.0D0,1.0D0)/
      DATA PAI/3.1415926589793D0/
CCC ===========
      FSS=PSPIN
      NUEMX2= FSS*2 +0.01
      NUE21= NUEMX2 +1
      NUENUM= NUEMX2/2 +1
      XFACT=10.0D0/NUE21
      FSS1= FSS +1.0D0
C
      DO 1 K = 1, 4
      DO 1 IT= 1, NTHMAX
      TPOL(IT, K)= 0.0D0
      TANL(IT, K)= 0.0D0
    1 CONTINUE
C
C --- POLARIZATION (IT11P, T20P, T21P, T22P) ---
C
      DO 1000 KK= 1, 2
      FK= KK
      IF(NUEMX2 .LT. KK) GO TO 1000
      FAC= XFACT *DSQRT(2*FK+1.0D0) *(-1)**KK
      KQMN= 0
      IF(KK.EQ.1) KQMN= 1
      DO 1100 KQ= KQMN, KK
      FQ= KQ
      DO 1200 NUEFX=1,NUE21-KQ
      DO 1200 NUEIX=1,NUE21
      NIX= NUEIX
      NFX= NUEFX
      NFX1= NFX +KQ
      FN= NFX -FSS1
      FACSN= CLEBSH(FSS, FN, FK, FQ, FSS, FN+FQ) *FAC
      IF(NIX.GT.NUENUM) THEN
         NIX= NUE21-NIX+1
         NFX= NUE21-NFX+1
         NFX1= NUE21-NFX1+1
         FACSN= FACSN *(-1)**KQ
      END IF
C
      IF(KK.EQ.1) THEN
         K= 1
         DO 1300 IT=1,NTHMAX
         FTEMP1= FNC(IT, NFX , NIX)
         FTEMP2= DCONJG( FNC(IT, NFX1, NIX) )
         TPOL(IT, K)= TPOL(IT, K) +DIMAG( FTEMP1*FTEMP2 )*FACSN
 1300    CONTINUE
      ELSE
         K= KQ +2
         DO 1310 IT=1,NTHMAX
         FTEMP1= FNC(IT, NFX , NIX)
         FTEMP2= DCONJG( FNC(IT, NFX1, NIX) )
         TPOL(IT, K)= TPOL(IT, K) +DREAL( FTEMP1*FTEMP2 )*FACSN
 1310    CONTINUE
      END IF
 1200 CONTINUE
 1100 CONTINUE
 1000 CONTINUE
C
      DO 1400 K=1,4
      DO 1400 IT=1,NTHMAX
      TPOL(IT, K)= TPOL(IT, K) /AXTH(IT)
 1400 CONTINUE
C
C --- ANALYZING POWER (IT11A, T20A, T21A, T22A) ---
C
      DO 2000 KK= 1, 2
      FK= KK
      IF(NUEMX2 .LT. KK) GO TO 2000
      FAC= XFACT *DSQRT(2*FK+1.0D0) *(-1)**KK
      KQMN= 0
      IF(KK.EQ.1) KQMN= 1
      DO 2100 KQ= KQMN, KK
      FQ= KQ
      DO 2200 NUEFX=1,NUE21
      DO 2200 NUEIX=1,NUE21-KQ
      NIX= NUEIX
      NFX= NUEFX
      NIX1= NIX +KQ
      NFX1= NFX
      FN= NIX -FSS1
      FACSN= CLEBSH(FSS, FN, FK, FQ, FSS, FN+FQ) *FAC
      IF(NIX.GT.NUENUM) THEN
         NIX= NUE21-NIX+1
         NFX= NUE21-NFX+1
         FACSN= FACSN *(-1)**(NIX-NFX)
      END IF
      IF(NIX1.GT.NUENUM) THEN
         NIX1= NUE21-NIX1+1
         NFX1= NUE21-NFX1+1
         FACSN= FACSN *(-1)**(NIX1-NFX1)
      END IF
C
      IF(KK.EQ.1) THEN
         K= 1
         DO 2300 IT=1,NTHMAX
         FTEMP1= FNC(IT, NFX1, NIX1)
         FTEMP2= DCONJG( FNC(IT, NFX, NIX) )
         TANL(IT, K)= TANL(IT, K) +DIMAG( FTEMP1*FTEMP2 )*FACSN
 2300    CONTINUE
      ELSE
         K= KQ +2
         DO 2310 IT=1,NTHMAX
         FTEMP1= FNC(IT, NFX1, NIX1)
         FTEMP2= DCONJG( FNC(IT, NFX, NIX) )
         TANL(IT, K)= TANL(IT, K) +DREAL( FTEMP1*FTEMP2 )*FACSN
 2310    CONTINUE
      END IF
 2200 CONTINUE
 2100 CONTINUE
 2000 CONTINUE
C
      DO 2400 K=1,4
      DO 2400 IT=1,NTHMAX
      TANL(IT, K)= TANL(IT, K) /AXTH(IT)
 2400 CONTINUE
C
C
C --- WRITE POLARIZATION & ANALYZING POWER ---
C
      IF(KAKTPA.LE.0) GO TO 600
      WRITE(6,610)
  610 FORMAT(1H1
     1     ///1H ,8X,'=====  POLARIZATION (IN TENPOL) ====='
     2     //1H ,3X,'  THETA   ',3X,'  IT11P   ',3X,'   T20P   '
     3         ,3X,'   T21P   ',3X,'   T22P   ')
      DO 611 IT=1,NTHMAX,KAKTPA
      WRITE(6,612) THETAD(IT),(TPOL(IT,K),K=1,4)
  612 FORMAT(1H ,3X,F10.5,3X,4(F10.7,2X))
  611 CONTINUE
C
      WRITE(6,620)
  620 FORMAT(1H1
     1     ///1H ,8X,'=====  ANALYZING POWER (IN TENPOL) ====='
     2     //1H ,3X,'  THETA   ',3X,'  IT11A   ',3X,'   T20A   '
     3         ,3X,'   T21A   ',3X,'   T22A   ')
      DO 621 IT=1,NTHMAX,KAKTPA
      WRITE(6,622) THETAD(IT),(TANL(IT,K),K=1,4)
  622 FORMAT(1H ,3X,F10.5,3X,4(F10.7,2X))
  621 CONTINUE
C
  600 CONTINUE
C
CCC --- R, B, R', B', S, D ---
      IF(KAKWOL.LE.0 .OR. NUEMX2.NE.1) GO TO 3900
      DR= PAI/180.0D0
      WRITE(6,3001)
 3001 FORMAT(1H1//1H ,10X,'=== WOLFENSTEIN PARAMETERS FOR A SPIN 1/2'
     1                   ,' PARTICLE ==='
     2 //1H ,3X,'  THETA   ',2X,'   X-SEC    '
     3     ,'   P      ','   Q      ','   R      ','   B      '
     4     ,'   RP     ','   BP     ','   S      ','   D      ')
      DO 3000 IT=1,NTHMAX,KAKWOL
      GG= FNC(IT, 1, 1)
      HH= FNC(IT, 2, 1)*WI
      SINE= DSIN( THETAD(IT)*DR)
      COSI= DCOS( THETAD(IT)*DR)
      G2= CDABS(GG)**2
      H2= CDABS(HH)**2
      GHR= DREAL( GG*DCONJG(HH) )
      GHI= DIMAG( GG*DCONJG(HH) )
      WA= G2 +H2
      SA= G2 -H2
      X = WA*10
      P = 2 *GHR /WA
      Q = 2 *GHI /WA
      R = ( SA*COSI +2*GHI*SINE ) / WA
      B = (-SA*SINE +2*GHI*COSI ) / WA
      RP= ( SA*SINE -2*GHI*COSI ) / WA
      BP= ( SA*COSI +2*GHI*SINE ) / WA
      S = H2 / WA
      D = 1.0D0 -2*S
C
      WRITE(6,3100) THETAD(IT),X,P,Q,R,B,RP,BP,S,D
 3100 FORMAT(1H ,F10.5,2X,1PD12.4,0P8F10.5)
 3000 CONTINUE
C
 3900 CONTINUE
CCC
      RETURN
      END
CCC
CCC        ****** FWRITE ******
CCC
      SUBROUTINE FWRITE(KSERCH,NTHMAX,NPARMX,XCHIT,PCHIT,CHISQT,REACX
     1     ,PARM,THETAD,CMREAD ,KRUTAB,KCHISQ,KAKFIG,KAKTEN ,ENDCOD
     2     ,TMASS  ,NUMPAR ,NTHDIM,NTHDMP,NPARDM
     3     ,AXTH,RXTH,RUTX,XSEX,XCHI,DXEX ,POLTH,POLEX,PCHI,DPEX
     4     ,PSPIN,TPOL,TANL
     5     ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     6     ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2
     7     ,KSOTYP,KNXTYP, TEMP)
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER CMREAD*40,ENDCOD*6
      DIMENSION PARM(NPARDM),THETAD(NTHDMP),CHISQT(2)
      DIMENSION V0R0A(3,2),W0R0A(3,2),WDR0A(3,2),R0COUL(2)
      DIMENSION VSR0A(3,2),WSR0A(3,2),FNRNI(2,2),V2R0A(3,2),VDR0A(3,2)
      DIMENSION FL0AL(2,2),VLDR0A(3,2),WLDR0A(3,2),FSNRNI(2,2),FNXSEX(2)
      DIMENSION V0R0A2(3,2),W0R0A2(3,2)
      DIMENSION AXTH(NTHDMP),RXTH(NTHDMP),RUTX(NTHDMP)
      DIMENSION XSEX(NTHDIM),XCHI(NTHDIM),DXEX(NTHDIM)
      DIMENSION POLTH(NTHDMP),POLEX(NTHDIM),PCHI(NTHDIM),DPEX(NTHDIM)
      DIMENSION TPOL(NTHDMP,4),TANL(NTHDMP,4)
      DIMENSION TEMP(NTHDMP, 3),KSOTYP(2)
C
      CHARACTER*6 SOTYP(2)/'THOMAS','WS-DER'/
      CHARACTER*16 NXTYP(2)/'(XT-N*XE)/(N*XE)','(XT-N*XE)/XE'/
CCC ============================
C
      IF(KSERCH.LE.0) GO TO 1000
      TM3= TMASS**(1.0D0/3.0D0)
C
C --- CHANGING RATIO ---
      KNTLPV= 1
      IIFF= 1
C -------
      CALL PVCHNG(KNTLPV,IIFF,PARM,NPARDM
     1    ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     2    ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2)
C ------
      DO 10 NP=1,NUMPAR
      IF(DABS(PARM(NP)).LT.1.0D-40) PARM(NP)= 1.0D0
   10 CONTINUE
C
      PARM( 1)= (V0R0A( 1, 2)-V0R0A( 1, 1)) /PARM( 1)
      PARM( 2)= (V0R0A( 2, 2)-V0R0A( 2, 1)) /PARM( 2)
      PARM( 3)= (V0R0A( 3, 2)-V0R0A( 3, 1)) /PARM( 3)
      PARM( 4)= (W0R0A( 1, 2)-W0R0A( 1, 1)) /PARM( 4)
      PARM( 5)= (W0R0A( 2, 2)-W0R0A( 2, 1)) /PARM( 5)
      PARM( 6)= (W0R0A( 3, 2)-W0R0A( 3, 1)) /PARM( 6)
      PARM( 7)= (WDR0A( 1, 2)-WDR0A( 1, 1)) /PARM( 7)
      PARM( 8)= (WDR0A( 2, 2)-WDR0A( 2, 1)) /PARM( 8)
      PARM( 9)= (WDR0A( 3, 2)-WDR0A( 3, 1)) /PARM( 9)
      PARM(10)= (R0COUL(   2)-R0COUL(   1)) /PARM(10)
      PARM(11)= (VSR0A( 1, 2)-VSR0A( 1, 1)) /PARM(11)
      PARM(12)= (VSR0A( 2, 2)-VSR0A( 2, 1)) /PARM(12)
      PARM(13)= (VSR0A( 3, 2)-VSR0A( 3, 1)) /PARM(13)
      PARM(14)= (WSR0A( 1, 2)-WSR0A( 1, 1)) /PARM(14)
      PARM(15)= (WSR0A( 2, 2)-WSR0A( 2, 1)) /PARM(15)
      PARM(16)= (WSR0A( 3, 2)-WSR0A( 3, 1)) /PARM(16)
      IF(NPARMX.LE.16) GO TO 11
      PARM(17)= (FNRNI( 1, 2)-FNRNI( 1, 1)) /PARM(17)
      PARM(18)= (FNRNI( 2, 2)-FNRNI( 2, 1)) /PARM(18)
      PARM(19)= (V2R0A( 1, 2)-V2R0A( 1, 1)) /PARM(19)
      PARM(20)= (V2R0A( 2, 2)-V2R0A( 2, 1)) /PARM(20)
      PARM(21)= (V2R0A( 3, 2)-V2R0A( 3, 1)) /PARM(21)
      PARM(22)= (VDR0A( 1, 2)-VDR0A( 1, 1)) /PARM(22)
      PARM(23)= (VDR0A( 2, 2)-VDR0A( 2, 1)) /PARM(23)
      PARM(24)= (VDR0A( 3, 2)-VDR0A( 3, 1)) /PARM(24)
      IF(NPARMX.LE.24) GO TO 11
      PARM(25)= (FL0AL( 1, 2)-FL0AL( 1, 1)) /PARM(25)
      PARM(26)= (FL0AL( 2, 2)-FL0AL( 2, 1)) /PARM(26)
      PARM(27)= (VLDR0A( 1, 2)-VLDR0A( 1, 1)) /PARM(27)
      PARM(28)= (VLDR0A( 2, 2)-VLDR0A( 2, 1)) /PARM(28)
      PARM(29)= (VLDR0A( 3, 2)-VLDR0A( 3, 1)) /PARM(29)
      PARM(30)= (WLDR0A( 1, 2)-WLDR0A( 1, 1)) /PARM(30)
      PARM(31)= (WLDR0A( 2, 2)-WLDR0A( 2, 1)) /PARM(31)
      PARM(32)= (WLDR0A( 3, 2)-WLDR0A( 3, 1)) /PARM(32)
      IF(NPARMX.LE.32) GO TO 11
      PARM(33)= (FSNRNI( 1, 2)-FSNRNI( 1, 1)) /PARM(33)
      PARM(34)= (FSNRNI( 2, 2)-FSNRNI( 2, 1)) /PARM(34)
      IF(NPARMX.LE.34) GO TO 11
      PARM(35)= (FNXSEX(    2)-FNXSEX(    1)) /PARM(35)
      IF(NPARMX.LE.35) GO TO 11
      PARM(36)= (V0R0A2( 1, 2)-V0R0A2( 1, 1)) /PARM(36)
      PARM(37)= (V0R0A2( 2, 2)-V0R0A2( 2, 1)) /PARM(37)
      PARM(38)= (V0R0A2( 3, 2)-V0R0A2( 3, 1)) /PARM(38)
      PARM(39)= (W0R0A2( 1, 2)-W0R0A2( 1, 1)) /PARM(39)
      PARM(40)= (W0R0A2( 2, 2)-W0R0A2( 2, 1)) /PARM(40)
      PARM(41)= (W0R0A2( 3, 2)-W0R0A2( 3, 1)) /PARM(41)
C
   11 RR = V0R0A(2,2)*TM3
      RI = W0R0A(2,2)*TM3
      RID= WDR0A(2,2)*TM3
      RSR= VSR0A(2,2)*TM3
      RSI= WSR0A(2,2)*TM3
      RCL= R0COUL( 2)*TM3
      R2R= V2R0A(2,2)*TM3
      RDR= VDR0A(2,2)*TM3
      RRLD= VLDR0A(2,2)*TM3
      RILD= WLDR0A(2,2)*TM3
      RR2= V0R0A2(2,2)*TM3
      RI2= W0R0A2(2,2)*TM3
C
C --- WRITE POTENTIAL PARAMETER -----
      WRITE(6,100)
  100 FORMAT(1H1//1H ,5X,'=====  SEARCHED POTENTIAL PARAMETERS ====='
     1 //1H ,10X,' TYPE',10X,'INITIAL',11X,'FINAL',11X,'REL.CHNG.'
     2     ,3X,' R0 *TMASS**(1/3)')
      VWCHK= V0R0A(1,1)**2 +W0R0A(1,1)**2 +WDR0A(1,1)**2
      IF(VWCHK.LE.1.0D-20) GO TO 111
      WRITE(6,101) V0R0A(1,1),V0R0A(1,2),PARM( 1)
     1            ,V0R0A(2,1),V0R0A(2,2),PARM( 2),RR
     2            ,V0R0A(3,1),V0R0A(3,2),PARM( 3)
     3            ,W0R0A(1,1),W0R0A(1,2),PARM( 4)
     4            ,W0R0A(2,1),W0R0A(2,2),PARM( 5),RI
     5            ,W0R0A(3,1),W0R0A(3,2),PARM( 6)
     6            ,WDR0A(1,1),WDR0A(1,2),PARM( 7)
     7            ,WDR0A(2,1),WDR0A(2,2),PARM( 8),RID
     8            ,WDR0A(3,1),WDR0A(3,2),PARM( 9)
  101 FORMAT(
     1  /1H ,10X,'< V0  >  : ',0PF14.8,' -->',F14.9,1PD15.5
     2  /1H ,10X,'< R0R >  : ',0PF14.8,' -->',F14.9,1PD15.5,3X,0PF14.9
     3  /1H ,10X,'< AR  >  : ',  F14.8,' -->',F14.9,1PD15.5
     4 //1H ,10X,'< W0  >  : ',0PF14.8,' -->',F14.9,1PD15.5
     5  /1H ,10X,'< R0I >  : ',0PF14.8,' -->',F14.9,1PD15.5,3X,0PF14.9
     6  /1H ,10X,'< AI  >  : ',  F14.8,' -->',F14.9,1PD15.5
     7 //1H ,10X,'< WD  >  : ',0PF14.8,' -->',F14.9,1PD15.5
     8  /1H ,10X,'< R0ID>  : ',0PF14.8,' -->',F14.9,1PD15.5,3X,0PF14.9
     9  /1H ,10X,'< AID >  : ',  F14.8,' -->',F14.9,1PD15.5)
  111 WRITE(6,102) R0COUL( 1),R0COUL( 2),PARM(10),RCL
  102 FORMAT(
     1 /1H ,10X,'< R0C >  : ',0PF14.8,' -->',F14.9,1PD15.5,3X,0PF14.9)
      VWCHK= VSR0A(1,1)**2 +WSR0A(1,1)**2
      IF(VWCHK.LE.1.0D-20) GO TO 113
      WRITE(6,103) VSR0A(1,1),VSR0A(1,2),PARM(11),SOTYP(KSOTYP(1)+1)
     1            ,VSR0A(2,1),VSR0A(2,2),PARM(12),RSR
     2            ,VSR0A(3,1),VSR0A(3,2),PARM(13)
     3            ,WSR0A(1,1),WSR0A(1,2),PARM(14),SOTYP(KSOTYP(2)+1)
     4            ,WSR0A(2,1),WSR0A(2,2),PARM(15),RSI
     5            ,WSR0A(3,1),WSR0A(3,2),PARM(16)
  103 FORMAT(/1H ,10X,'< VSO >  : ',0PF14.8,' -->',F14.9,1PD15.5
     1              ,3X,'-- "',A6,' FORM"'
     2  /1H ,10X,'< R0RS>  : ',0PF14.8,' -->',F14.9,1PD15.5,3X,0PF14.9
     3  /1H ,10X,'< ARS >  : ',  F14.8,' -->',F14.9,1PD15.5
     4 //1H ,10X,'< WSO >  : ',0PF14.8,' -->',F14.9,1PD15.5
     5              ,3X,'-- "',A6,' FORM"'
     6  /1H ,10X,'< R0IS>  : ',0PF14.8,' -->',F14.9,1PD15.5,3X,0PF14.9
     7  /1H ,10X,'< AIS >  : ',  F14.8,' -->',F14.9,1PD15.5 )
  113 VWCHK= FNRNI(1,1)**2 +FNRNI(1,2)**2
      IF(VWCHK.LE.1.0D-20) GO TO 114
      WRITE(6,104) (FNRNI(I,1),FNRNI( I, 2),PARM(I+16),I=1,2)
  104 FORMAT(/1H ,10X,'< NR  >  : ',0PF14.8,' -->',F14.9,1PD15.5
     1 /1H ,10X,'< NI  >  : ',0PF14.8,' -->',F14.9,1PD15.5)
  114 VWCHK= V2R0A(1,1)**2
      IF(VWCHK.LE.1.0D-20) GO TO 115
      WRITE(6,105) V2R0A(1,1),V2R0A(1,2),PARM(19)
     1            ,V2R0A(2,1),V2R0A(2,2),PARM(20),R2R
     2            ,V2R0A(3,1),V2R0A(3,2),PARM(21)
  105 FORMAT(/1H ,10X,'< V2  >  : ',0PF14.8,' -->',F14.9,1PD15.5
     1 /1H ,10X,'< R0R2>  : ',0PF14.8,' -->',F14.9,1PD15.5,3X,0PF14.9
     2 /1H ,10X,'< AR2 >  : ',  F14.8,' -->',F14.9,1PD15.5 )
  115 VWCHK= VDR0A(1,1)**2
      IF(VWCHK.LE.1.0D-20) GO TO 116
      WRITE(6,106) VDR0A(1,1),VDR0A(1,2),PARM(22)
     1            ,VDR0A(2,1),VDR0A(2,2),PARM(23),RDR
     2            ,VDR0A(3,1),VDR0A(3,2),PARM(24)
  106 FORMAT(/1H ,10X,'< VD  >  : ',0PF14.8,' -->',F14.9,1PD15.5
     1 /1H ,10X,'< R0RD>  : ',0PF14.8,' -->',F14.9,1PD15.5,3X,0PF14.9
     2 /1H ,10X,'< ARD >  : ',  F14.8,' -->',F14.9,1PD15.5 )
  116 VWCHK= VLDR0A(1,1)**2 +WLDR0A(1,1)**2
      IF(VWCHK.LE.1.0D-20) GO TO 117
      WRITE(6,107) FL0AL(1,1),FL0AL(1,2),PARM(25)
     1            ,FL0AL(2,1),FL0AL(2,2),PARM(26)
     2            ,VLDR0A(1,1),VLDR0A(1,2),PARM(27)
     3            ,VLDR0A(2,1),VLDR0A(2,2),PARM(28),RRLD
     4            ,VLDR0A(3,1),VLDR0A(3,2),PARM(29)
     5            ,WLDR0A(1,1),WLDR0A(1,2),PARM(30)
     6            ,WLDR0A(2,1),WLDR0A(2,2),PARM(31),RILD
     7            ,WLDR0A(3,1),WLDR0A(3,2),PARM(32)
  107 FORMAT(/1H ,10X,'< FL0 >  : ',0PF14.8,' -->',F14.9,1PD15.5
     1  /1H ,10X,'< AL  >  : ',0PF14.8,' -->',F14.9,1PD15.5
     2 //1H ,10X,'< VLD >  : ',0PF14.8,' -->',F14.9,1PD15.5
     3  /1H ,10X,'<R0RLD>  : ',0PF14.8,' -->',F14.9,1PD15.5,3X,0PF14.9
     4  /1H ,10X,'< ARLD>  : ',  F14.8,' -->',F14.9,1PD15.5
     5 //1H ,10X,'< WLD >  : ',0PF14.8,' -->',F14.9,1PD15.5
     6  /1H ,10X,'<R0ILD>  : ',0PF14.8,' -->',F14.9,1PD15.5,3X,0PF14.9
     7  /1H ,10X,'< AILD>  : ',  F14.8,' -->',F14.9,1PD15.5 )
  117 VWCHK= FSNRNI(1,1)**2 +FSNRNI(1,2)**2
      IF(VWCHK.LE.1.0D-20) GO TO 118
      WRITE(6,108) (FSNRNI(I,1),FSNRNI( I, 2),PARM(I+32),I=1,2)
  108 FORMAT(/1H ,10X,'< NRS >  : ',0PF14.8,' -->',F14.9,1PD15.5
     1 /1H ,10X,'< NIS >  : ',0PF14.8,' -->',F14.9,1PD15.5)
  118 WRITE(6,109) FNXSEX(1),FNXSEX(2),PARM(35),NXTYP(KNXTYP+1)
  109 FORMAT(/1H ,10X,'<NXSEX>  : ',0PF14.8,' -->',F14.9,1PD15.5
     1              ,3X,'-- "',A,' TYPE"')
  119 VWCHK= V0R0A2(1,1)**2 +W0R0A2(1,1)**2
      IF(VWCHK.LE.1.0D-20) GO TO 120
      WRITE(6,110) V0R0A2(1,1),V0R0A2(1,2),PARM(36)
     1            ,V0R0A2(2,1),V0R0A2(2,2),PARM(37),RR2
     2            ,V0R0A2(3,1),V0R0A2(3,2),PARM(38)
     3            ,W0R0A2(1,1),W0R0A2(1,2),PARM(39)
     4            ,W0R0A2(2,1),W0R0A2(2,2),PARM(40),RI2
     5            ,W0R0A2(3,1),W0R0A2(3,2),PARM(41)
  110 FORMAT(/1H ,10X,'< V02 >  : ',0PF14.8,' -->',F14.9,1PD15.5
     1  /1H ,10X,'<R0R02>  : ',0PF14.8,' -->',F14.9,1PD15.5,3X,0PF14.9
     2  /1H ,10X,'< AR02>  : ',  F14.8,' -->',F14.9,1PD15.5
     3 //1H ,10X,'< W02 >  : ',0PF14.8,' -->',F14.9,1PD15.5
     4  /1H ,10X,'<R0I02>  : ',0PF14.8,' -->',F14.9,1PD15.5,3X,0PF14.9
     5  /1H ,10X,'< AI02>  : ',  F14.8,' -->',F14.9,1PD15.5)
  120 CONTINUE
C
      CH1= CHISQT(1) /NTHMAX
      CH2= CHISQT(2) /NTHMAX
      WRITE(6,129) CHISQT(1),CHISQT(2),CH1,CH2,ENDCOD
  129 FORMAT(//1H ,10X,'CHISQT   : ',1PD14.7,' --> ',D14.7
     1       /1H ,5X,'CHISQT/NPOINT : ',D14.7,' --> ',D14.7
     2       //1H ,10X,'*** ENDING CONDITION = ''',A6,''' ***')
C
C --- WRITE X-SECTION & POLARIZATION -----
 1000 IF(KCHISQ.LE.0) GO TO 2000
      CHI2T= XCHIT+PCHIT
      CH1= XCHIT/NTHMAX
      CH2= PCHIT/NTHMAX
      CH3= CH1 +CH2
      WRITE(6,200)
  200 FORMAT(1H1///1H ,8X,'===== X-SECTION (MB/SR) & POLARIZATION (%)'
     1         ,' ====='
     2     //1H ,'  THETA',2X,'   XSEC (TH)  ','   XS/RX (TH) '
     3       ,'   XSEC (EX)  ','    X-CHI2  ','  DEL-X (EX)'
     4       ,'     RUTX   ','   POL (TH) ','   POL (EX) '
     5       ,'    P-CHI2  ','  DEL-P (EX)')
      WRITE(6,210) (THETAD(IT),AXTH(IT),RXTH(IT),XSEX(IT)
     1     ,XCHI(IT),DXEX(IT),RUTX(IT)
     2     ,POLTH(IT),POLEX(IT),PCHI(IT),DPEX(IT),IT=1,NTHMAX)
  210 FORMAT(1H ,F8.3,1X,1P3D14.6,3D12.3,0P2F12.6,1PD12.3,0PF11.6)
      WRITE(6,220) XCHIT,PCHIT,CH1,CH2,REACX,CHI2T,CH3
  220 FORMAT(/1H ,' TOTAL : ',42X,1PD14.6,46X,D14.5
     1      /1H ,' PER POINT :',39X,1PD14.6,46X,D14.5
     2      //1H ,' REACX = ',1PD14.6,'  <MB>'
     3 ,'      ***  TOTAL CHISQ = ',D14.6,',    PER POINT =',D14.6)
      GO TO 2100
C
 2000 CONTINUE
      WRITE(6,230)
  230 FORMAT(1H1///1H ,18X,'===== X-SECTION (MB/SR) & POLARIZATION (%)'
     1         ,' ====='
     2     //1H ,10X,'  THETA',2X,'   XSEC (TH)  ','   XS/RX (TH) '
     3       ,'     RUTX     ','    POL (TH)')
      WRITE(6,240) (THETAD(IT),AXTH(IT),RXTH(IT),RUTX(IT)
     1     ,POLTH(IT),IT=1,NTHMAX)
  240 FORMAT(1H ,10X,F8.3,1X,1P3D14.6,0PF12.6)
      WRITE(6,250) REACX
  250 FORMAT(/1H ,10X,' REACX = ',1PD14.6,'  <MB>')
C
 2100 CONTINUE
C
C --- WRITE TENSOR POLARIZATION & ANALYZING POWER ---
      IF(KAKTEN.LE.0) GO TO 3000
      IF(DABS(PSPIN).LE.0.1) GO TO 3000
C
      FACT= DSQRT( 2*(PSPIN+1.0D0) /(3*PSPIN) )
      D2= DSQRT(2.0D0)
      D3= DSQRT(3.0D0)
      WRITE(6,310)
  310 FORMAT(1H1
     1     ///1H ,8X,'=====  TENSOR POLARIZATION ====='
     2     //1H ,1X,'  THETA ' ,2X,'  IT11P  ',1X,'   T20P  '
     3         ,1X,'   T21P  ',1X,'   T22P  ')
      DO 311 IT=1,NTHMAX,KAKTEN
      WRITE(6,312) THETAD(IT),(TPOL(IT,K),K=1,4)
  312 FORMAT(1H ,1X,F8.3,2X,4(F9.6,1X),1X,F8.3,2X,5(F9.6,1X),1X,F8.3)
  311 CONTINUE
C
      WRITE(6,320)
  320 FORMAT(1H1
     1     ///1H ,8X,'=====  TENSOR ANALYZING POWER  ====='
     2     //1H ,1X,'  THETA ' ,2X,'  IT11A  ',1X,'   T20A  '
     3         ,1X,'   T21A  ',1X,'   T22A  '
     4         ,2X,'  THETA ' ,2X,'   AY    ',1X,'   AYY   '
     5         ,1X,'   AXX   ',1X,'   AXZ   ',1X,'   X2    '
     6         ,2X,'  THETA ')
      DO 321 IT=1,NTHMAX,KAKTEN
      AY= TANL(IT,1)*FACT
      AYY= -TANL(IT,4)*D3 -TANL(IT,2)/D2
      AXX=  TANL(IT,4)*D3 -TANL(IT,2)/D2
      AXZ= -TANL(IT,3)*D3
      AX2= (2*AXX+AYY)/D3
      WRITE(6,312) THETAD(IT),(TANL(IT,K),K=1,4)
     1            ,THETAD(IT),AY,AYY,AXX,AXZ,AX2,THETAD(IT)
  321 CONTINUE
C
 3000 CONTINUE
C
C --- FIGURE -----
      IF(KAKFIG.EQ.0) GO TO 9000
      KAKABS= IABS(KAKFIG)
      IF(KAKABS.EQ.2) GO TO 8300
C
      WRITE(6,8010) CMREAD
 8010 FORMAT(1H1///1H ,10X,'<< ',A,' >>')
      NDIM= NTHDIM
      LCOND1= -999
      LCOND2= -999
      LL= 0
      IF(KCHISQ.LE.0 .OR. KCHISQ.EQ.2) LL= 1
      KFIGRA= 1
      IF(KAKFIG.LE.0) KFIGRA= 2
      LL= LL*2 +KFIGRA
C
      IF(KFIGRA.NE.KRUTAB) THEN
         IF(KFIGRA.EQ.1) THEN
            DO 8011 IT=1,NTHMAX
            TEMP(IT, 1)= XSEX(IT)
            XSEX(IT)= XSEX(IT)/RUTX(IT)
 8011       CONTINUE
         ELSE
            DO 8012 IT=1,NTHMAX
            TEMP(IT, 1)= XSEX(IT)
            XSEX(IT)= XSEX(IT)*RUTX(IT)
 8012       CONTINUE
         END IF
      END IF
C
      GO TO (8100,8200,8110,8210),LL
 8100 CALL FIGLG2(THETAD,NTHMAX,NDIM, 1,RXTH, 1, 0, LCOND1
     1                                 ,XSEX, 1, 0, LCOND2)
      GO TO 8300
 8110 CALL FIGLOG(THETAD,NTHMAX,NDIM, 1,RXTH, 1, 0, LCOND1)
      GO TO 8302
 8200 CALL FIGLG2(THETAD,NTHMAX,NDIM, 1,AXTH,-1, 0, LCOND1
     1                                 ,XSEX,-1, 0, LCOND2)
      GO TO 8300
 8210 CALL FIGLOG(THETAD,NTHMAX,NDIM, 1,AXTH,-1, 0, LCOND1)
      GO TO 8302
C
 8300 IF(KFIGRA.NE.KRUTAB) THEN
         DO 8301 IT=1,NTHMAX
         XSEX(IT)= TEMP(IT, 1)
 8301    CONTINUE
      END IF
C
 8302 IF(KAKABS.EQ.1) GO TO 9000
      WRITE(6,8010) CMREAD
      IF(KCHISQ.LE.1) GO TO 8310
      CALL FIGLN2(THETAD,NTHMAX,NTHDIM, 1,POLTH, 100.0D0, 0.0D0, 1
     1                                   ,POLEX, 100.0D0, 0.0D0, 1)
      GO TO 9000
 8310 CALL FIGLIN(THETAD,NTHMAX,NTHDIM, 1,POLTH, 100.0D0, 0.0D0, 1)
C
 9000 CONTINUE
      RETURN
      END
CCC
CCC        ***** PCHANG *****
CCC
      SUBROUTINE PCHANG(KSERCH,NSPMAX,NPARMX,KXPDER
     1   ,PARM,PARMNX,KTPARA,XPARM
     2   ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     3   ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2
     4                       ,NSPDIM,NPARDM)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION V0R0A(3,2),W0R0A(3,2),WDR0A(3,2),R0COUL(2)
      DIMENSION VSR0A(3,2),WSR0A(3,2),FNRNI(2,2),V2R0A(3,2),VDR0A(3,2)
      DIMENSION FL0AL(2,2),VLDR0A(3,2),WLDR0A(3,2),FSNRNI(2,2),FNXSEX(2)
      DIMENSION V0R0A2(3,2),W0R0A2(3,2)
      DIMENSION KTPARA(NSPDIM,NPARDM),PARM(NPARDM),XPARM(NSPDIM)
      DIMENSION PARMNX(NPARDM, 3)
CCC =======================
C
      KNTLPV= 1
      IIFF= 1
C ------
      CALL PVCHNG(KNTLPV,IIFF,PARM,NPARDM
     1    ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     2    ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2)
C -------
C
      IF(KSERCH.LE.0) GO TO 30
      DO 10 NS=1,NSPMAX
      XX= XPARM(NS)
      DO 20 NP=1,NPARMX
      IF(KTPARA(NS,NP).LE.0) GO TO 20
      PPP= PARM(NP)*XX
C --- PARM  MIN,MAX CHECK ---
      PCHK= ( PPP - PARMNX(NP,1) ) * ( PPP - PARMNX(NP,2) )
      IF(PCHK.LE.0.0D0) GO TO 21
      WRITE(6,600) NP,PPP,(PARMNX(NP,I),I=1,3)
  600 FORMAT(/1H ,'*** MIN,MAX CHECK --- NP=',I3,'  PPP=',1PD12.4
     1          ,'  PARMNX=',2D12.4,',  REPLACED BY PREVIOUS VALUE ('
     2          ,D12.4,' )')
      PPP= PARMNX(NP, 3)
      XPARM(NS)= PPP/PARM(NP)
C ------------
   21 PARM(NP)= PPP
      IF(KXPDER.GT.0) PARMNX(NP, 3)= PPP
   20 CONTINUE
   10 CONTINUE
C
   30 CONTINUE
C
      KNTLPV= 2
      IIFF= 2
C ------
      CALL PVCHNG(KNTLPV,IIFF,PARM,NPARDM
     1    ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     2    ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2)
C ------
C
      RETURN
      END
CCC
CCC        ***** POTGEN *****
CCC
      SUBROUTINE POTGEN(PMASS,TMASS,ZZHCAL,DR,NRMAX,LMAX,KAKPOT,KSOTYP
     1            ,PARM,VFOLD,WFOLD,VSFOLD,WSFOLD, NRDIM,NPARDM,LDIM
     2                                  ,UCE,USO,ULJ,VCL,FLJFAC)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION PARM(NPARDM),KSOTYP(2)
      DIMENSION VFOLD(NRDIM),WFOLD(NRDIM),VSFOLD(NRDIM),WSFOLD(NRDIM)
C
      COMPLEX*16 UCE(NRDIM),USO(NRDIM),ULJ(NRDIM)
      DIMENSION VCL(NRDIM),FLJFAC(LDIM)
      COMPLEX*16 CJRJI,CRMSR,CJRJIS,CRMSRS,CTEMP,CTEMPS
      DATA PILAM2/ 2.0D0/, PAI/3.141592653589793D0/, XMAX/170.0D0/
CCC =======================
C
      TMASS3= TMASS**(1.0D0/3.0D0)
C
      V0  = PARM( 1)
      R0R = PARM( 2)
      AR  = PARM( 3)
      W0  = PARM( 4)
      R0I = PARM( 5)
      AI  = PARM( 6)
      WD  = PARM( 7)
      R0ID= PARM( 8)
      AID = PARM( 9)
      R0CL= PARM(10)
      VSO = PARM(11)
      R0RS= PARM(12)
      ARS = PARM(13)
      WSO = PARM(14)
      R0IS= PARM(15)
      AIS = PARM(16)
      FNR = PARM(17)
      FNI = PARM(18)
      V2  = PARM(19)
      R0R2= PARM(20)
      AR2 = PARM(21)
      VD  = PARM(22)
      R0RD= PARM(23)
      ARD = PARM(24)
      FL0 = PARM(25)
      AL  = PARM(26)
      VLD  = PARM(27)
      R0RLD= PARM(28)
      ARLD = PARM(29)
      WLD  = PARM(30)
      R0ILD= PARM(31)
      AILD = PARM(32)
      FNRS = PARM(33)
      FNIS = PARM(34)
      V02  = PARM(36)
      R0R02= PARM(37)
      AR02 = PARM(38)
      W02  = PARM(39)
      R0I02= PARM(40)
      AI02 = PARM(41)
C
      RR = R0R*TMASS3
      RI = R0I*TMASS3
      RID= R0ID*TMASS3
      RRS= R0RS*TMASS3
      RIS= R0IS*TMASS3
      RCL= R0CL*TMASS3
      RR2= R0R2*TMASS3
      RRD= R0RD*TMASS3
      RRLD= R0RLD*TMASS3
      RILD= R0ILD*TMASS3
      RR02= R0R02*TMASS3
      RI02= R0I02*TMASS3
C
      VFACT = -V0
      WFACT = -W0
      WDFACT= -4*WD
      VCFACT= ZZHCAL/(2*RCL)
      VSFACT= -PILAM2*VSO/ARS
      WSFACT= -PILAM2*WSO/AIS
      V2FACT= -V2
      VDFACT= -4*VD
      VLDFAC= -4*VLD
      WLDFAC= -4*WLD
      VFACT2= -V02
      WFACT2= -W02
C
C --- NUCLEAR POTENTIAL -----
      DO 1 IR=1,NRMAX
      UCE(IR)= 0.0D0
      USO(IR)= 0.0D0
      ULJ(IR)= 0.0D0
    1 CONTINUE
      DO 2 L1= 1,LMAX+1
      FLJFAC(L1)= 0.0D0
    2 CONTINUE
C --- CENTRAL (STANDARD) ---
      CHK= V0**2 +W0*2 +WD**2
      IF(CHK.LE.1.0D-20) GO TO 19
      DO 10 IR=1,NRMAX
      RRR= DR*(IR-1)
      XR = (RRR-RR ) /AR
      XI = (RRR-RI ) /AI
      XID= (RRR-RID) /AID
      IF(XR .GT.XMAX) XR =XMAX
      IF(XI .GT.XMAX) XI =XMAX
      IF(XID.GT.XMAX) XID=XMAX
      ER = DEXP(XR )
      EI = DEXP(XI )
      EID= DEXP(XID)
      EID1= 1.0D0/(1.0D0+EID)
      UR = VFACT /(1.0D0+ER )
      UI = WFACT /(1.0D0+EI )
      UID= WDFACT *(EID*EID1) *EID1
      UCE(IR)= DCMPLX( UR  , UI+UID )
   10 CONTINUE
   19 CONTINUE
C --- L*S -----
      CHK= VSO**2 +WSO**2
      IF(CHK.LE.1.0D-20) GO TO 29
      K1= KSOTYP(1)
      K2= KSOTYP(2)
      DO 20 IR=1,NRMAX
      RRR= DR*(IR-1) +1.0D-40
      XRS= (RRR-RRS) /ARS
      XIS= (RRR-RIS) /AIS
      IF(XRS.GT.XMAX) XRS= XMAX
      IF(XIS.GT.XMAX) XIS= XMAX
      ERS= DEXP(XRS)
      EIS= DEXP(XIS)
      ERS1= 1.0D0/(1.0D0+ERS)
      EIS1= 1.0D0/(1.0D0+EIS)
      RRX= RRR
      RIX= RRR
      IF(K1.NE.0) RRX= RRS
      IF(K2.NE.0) RIX= RIS
      URS= VSFACT *(ERS*ERS1) *ERS1 /RRX
      UIS= WSFACT *(EIS*EIS1) *EIS1 /RIX
      USO(IR)= DCMPLX( URS , UIS    )
   20 CONTINUE
   29 CONTINUE
C --- FOLDING POTENTIAL (CENTRAL) -----
      CHK= FNR**2 +FNI**2
      IF(CHK.LE.1.0D-20) GO TO 39
      DO 30 IR=1,NRMAX
      UCE(IR)= UCE(IR) +DCMPLX( FNR*VFOLD(IR) , FNI*WFOLD(IR) )
   30 CONTINUE
   39 CONTINUE
C --- CENTRAL ( WS**2 REAL ) ---
      CHK= V2**2
      IF(CHK.LE.1.0D-20) GO TO 49
      DO 40 IR=1,NRMAX
      RRR= DR*(IR-1)
      XR = (RRR-RR2) /AR2
      IF(XR.GT.XMAX) XR=XMAX
      ER = DEXP(XR )
      ER1= 1.0D0/(1.0D0+ER)
      UR = V2FACT*ER1 *ER1
      UCE(IR)= UCE(IR) +DCMPLX( UR  , 0.0D0 )
   40 CONTINUE
   49 CONTINUE
C --- CENTRAL ( WSD REAL) ---
      CHK= VD**2
      IF(CHK.LE.1.0D-20) GO TO 59
      DO 50 IR=1,NRMAX
      RRR= DR*(IR-1)
      XRD= (RRR-RRD) /ARD
      IF(XRD.GT.XMAX) XRD=XMAX
      ERD= DEXP(XRD)
      ERD1= 1.0D0/(1.0D0+ERD)
      URD= VDFACT *(ERD*ERD1) *ERD1
      UCE(IR)= UCE(IR) +DCMPLX( URD , 0.0D0 )
   50 CONTINUE
   59 CONTINUE
C --- L-DEPENDENT ( WS(L)*WSD(R) ) ---
      CHK= VLD**2 +WLD**2
      IF(CHK.LE.1.0D-20) GO TO 69
      FL02= FL0**2
      AL2 = AL **2
      DO 60 L1=1,LMAX+1
      FL= L1-1
      FL2= FL**2
      XRD= (FL2-FL02) /AL2
      IF(XRD.GT.XMAX) XRD=XMAX
      ERD= DEXP(XRD)
      ERD1= 1.0D0/(1.0D0+ERD)
      FLJFAC(L1)= ERD1
   60 CONTINUE
C
      DO 61 IR=1,NRMAX
      RRR= DR*(IR-1)
      XRD= (RRR-RRLD) /ARLD
      XID= (RRR-RILD) /AILD
      IF(XRD.GT.XMAX) XRD=XMAX
      IF(XID.GT.XMAX) XID=XMAX
      ERD= DEXP(XRD)
      EID= DEXP(XID)
      ERD1= 1.0D0/(1.0D0+ERD)
      EID1= 1.0D0/(1.0D0+EID)
      URD= VLDFAC *(ERD*ERD1) *ERD1
      UID= WLDFAC *(EID*EID1) *EID1
      ULJ(IR)= DCMPLX( URD , UID )
   61 CONTINUE
   69 CONTINUE
C --- FOLDING POTENTIAL (CENTRAL) -----
      CHK= FNRS**2 +FNIS**2
      IF(CHK.LE.1.0D-20) GO TO 79
      DO 70 IR=1,NRMAX
      USO(IR)= USO(IR) +DCMPLX( FNRS*VSFOLD(IR) , FNIS*WSFOLD(IR) )
   70 CONTINUE
   79 CONTINUE

C --- CENTRAL (second Woods-Saxon) ---
      CHK= V02**2 +W02*2
      IF(CHK.LE.1.0D-20) GO TO 89
      DO 80 IR=1,NRMAX
      RRR= DR*(IR-1)
      XR = (RRR-RR02) /AR02
      XI = (RRR-RI02) /AI02
      IF(XR .GT.XMAX) XR =XMAX
      IF(XI .GT.XMAX) XI =XMAX
      ER = DEXP(XR )
      EI = DEXP(XI )
      UR = VFACT2/(1.0D0+ER )
      UI = WFACT2/(1.0D0+EI )
      UCE(IR)= UCE(IR) +DCMPLX( UR  , UI )
   80 CONTINUE
   89 CONTINUE
C
C --- COULOMB POTENTIAL -----
      IF(DABS(ZZHCAL).GT.1.0D-40) THEN
         DO 90 IR=1,NRMAX
         RRR= DR*(IR-1)
         IF(RRR-RCL) 91,91,92
   91    VCL(IR)= VCFACT *( 3.0D0 - (RRR/RCL)**2 )
         GO TO 90
   92    VCL(IR)= ZZHCAL /(RRR +1.0D-40)
   90    CONTINUE
      ELSE
         DO 96 IR=1,NRMAX
         VCL(IR)= 0.0D0
   96    CONTINUE
      END IF
C
C ----- WRITE POTENTIAL -----
      IF(KAKPOT.LE.0) GO TO 9000
      CJRJI = 0.0D0
      CJRJIS= 0.0D0
      CRMSR = 0.0D0
      CRMSRS= 0.0D0
      DO 6001 IR=1,NRMAX
      RRR= DR*(IR-1)
      RRR2= RRR**2
      CTEMP = UCE(IR)*RRR2
      CTEMPS= USO(IR)*RRR2
      CJRJI = CJRJI +CTEMP
      CRMSR = CRMSR +CTEMP*RRR2
      CJRJIS= CJRJIS+CTEMPS
      CRMSRS= CRMSRS+CTEMPS*RRR2
 6001 CONTINUE
      PAI4DR= PAI*4 *DR
      CJRJI = CJRJI *PAI4DR
      CJRJIS= CJRJIS*PAI4DR
      CRMSR = CRMSR *PAI4DR
      CRMSRS= CRMSRS*PAI4DR
      R1= DABS( DREAL(CJRJI))
      R2= DABS( DIMAG(CJRJI))
      R3= DABS( DREAL(CJRJIS))
      R4= DABS( DIMAG(CJRJIS))
      IF(R1.LE.1.0D-40) R1= 1.0D0
      IF(R2.LE.1.0D-40) R2= 1.0D0
      IF(R3.LE.1.0D-40) R3= 1.0D0
      IF(R4.LE.1.0D-40) R4= 1.0D0
      RMSRR = DSQRT( DABS(DREAL(CRMSR))/R1 )
      RMSRI = DSQRT( DABS(DIMAG(CRMSR))/R2 )
      RMSRRS= DSQRT( DABS(DREAL(CRMSRS))/R3 )
      RMSRIS= DSQRT( DABS(DIMAG(CRMSRS))/R4 )
      CTEMP =CJRJI /(PMASS*TMASS)
      CTEMPS=CJRJIS/(PMASS*TMASS)
      WRITE(6,6000)
 6000 FORMAT(//1H ,10X,'--- POTENTIAL ( NUCLEAR & COULOMB ) ---'
     1       //1H ,7X,'RR',9X,'CENTRAL (L-INDEP.)',15X
     2        ,'L * 2S',12X,'COULOMB',8X,'CENTRAL (L-DEP.)'
     3        ,8X,' LL',6X,',FLJFAC',3X)
      FN1= (NRMAX-1)/KAKPOT +1
      NL= (LMAX+1)/FN1 -0.0001
      NL= NL +1
      L1= -NL +1
      DO 6010 IR=1,NRMAX,KAKPOT
      L1= L1 +NL
      LL= L1 -1
      RRR= DR*(IR-1)
      IF(LL.GT.LMAX) GO TO 6020
      WRITE(6,6030) RRR,UCE(IR),USO(IR),VCL(IR),ULJ(IR),LL,FLJFAC(L1)
 6030 FORMAT(1H ,5X,F7.3,2X,1P7D13.5,3X,I3,2X,D13.5)
      GO TO 6010
 6020 WRITE(6,6030) RRR,UCE(IR),USO(IR),VCL(IR),ULJ(IR)
 6010 CONTINUE
      WRITE(6,6040) CJRJI,CJRJIS,RMSRR,RMSRI,RMSRRS,RMSRIS
 6040 FORMAT(/1H ,3X,'VOL.INT. :',1X,1P4D13.5,'      <MEV*FM**3>'
     1      /1H ,3X,'R.M.S.R. :',1X,0P4F13.6,'      <FM>')
      WRITE(6,6050) CTEMP,CTEMPS
 6050 FORMAT(/1H ,3X,'VOL.INT. :',1X,1P4D13.5
     1             ,'  -- PER NUCLEON')
C
 9000 RETURN
      END
CCC
CCC        ***** POTDER *****
CCC
      SUBROUTINE POTDER(TMASS,ZZHCAL,DR,NRMAX,NSPMAX,NPARMX,INTGWF
     1    ,PARM ,KTPARA,KSPLJD,KPREIM,KAKDPO,KSOTYP
     2    ,VFOLD,WFOLD,VSFOLD,WSFOLD
     3    ,NRDIM,NSPDIM,NPARDM, VPDER,PDFACT,UPDER)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION PARM(NPARDM),KSOTYP(2)
      DIMENSION KTPARA(NSPDIM,NPARDM),KSPLJD(NSPDIM),KPREIM(NPARDM)
      DIMENSION VFOLD(NRDIM),WFOLD(NRDIM),VSFOLD(NRDIM),WSFOLD(NRDIM)
C
      DIMENSION VPDER(NRDIM,NPARDM),PDFACT(NPARDM)
      COMPLEX*16 UPDER(NRDIM,NSPDIM)
      DIMENSION KKPOT( 3)
      DATA PILAM2/ 2.0D0/, XMAX/170.0D0/
CCC =======================

      TMASS3= TMASS**(1.0D0/3.0D0)
C
      V0  = PARM( 1)
      R0R = PARM( 2)
      AR  = PARM( 3)
      W0  = PARM( 4)
      R0I = PARM( 5)
      AI  = PARM( 6)
      WD  = PARM( 7)
      R0ID= PARM( 8)
      AID = PARM( 9)
      R0CL= PARM(10)
      VSO = PARM(11)
      R0RS= PARM(12)
      ARS = PARM(13)
      WSO = PARM(14)
      R0IS= PARM(15)
      AIS = PARM(16)
      V2  = PARM(19)
      R0R2= PARM(20)
      AR2 = PARM(21)
      VD  = PARM(22)
      R0RD= PARM(23)
      ARD = PARM(24)
      FL0 = PARM(25)
      AL  = PARM(26)
      VLD = PARM(27)
      R0RLD= PARM(28)
      ARLD = PARM(29)
      WLD  = PARM(30)
      R0ILD= PARM(31)
      AILD = PARM(32)
      V02  = PARM(36)
      R0R02= PARM(37)
      AR02 = PARM(38)
      W02  = PARM(39)
      R0I02= PARM(40)
      AI02 = PARM(41)
C
      RR = R0R*TMASS3
      RI = R0I*TMASS3
      RID= R0ID*TMASS3
      RRS= R0RS*TMASS3
      RIS= R0IS*TMASS3
      RCL= R0CL*TMASS3
      RR2= R0R2*TMASS3
      RRD= R0RD*TMASS3
      RRLD= R0RLD*TMASS3
      RILD= R0ILD*TMASS3
      RR02= R0R02*TMASS3
      RI02= R0I02*TMASS3
C
      PDFACT( 1)= -1.0D0
      PDFACT( 4)= -1.0D0
      PDFACT( 7)= -4.0D0
      PDFACT(11)= -PILAM2 /ARS
      IF(KSOTYP(1).NE.0) PDFACT(11)= PDFACT(11)/RRS
      PDFACT(14)= -PILAM2 /AIS
      IF(KSOTYP(2).NE.0) PDFACT(14)= PDFACT(14)/RIS
      PDFACT(19)= -1.0D0
      PDFACT(22)= -4.0D0
      PDFACT(27)= -4.0D0
      PDFACT(30)= -4.0D0
      PDFACT( 3)=  PDFACT( 1)*V0 /AR
      PDFACT( 6)=  PDFACT( 4)*W0 /AI
      PDFACT( 9)= -PDFACT( 7)*WD /AID
      PDFACT(13)= -PDFACT(11)*VSO/ARS
      PDFACT(16)= -PDFACT(14)*WSO/AIS
      PDFACT(21)=  PDFACT(19)*V2 /AR2 *2
      PDFACT(24)= -PDFACT(22)*VD /ARD
      PDFACT(29)= -PDFACT(27)*VLD /ARLD
      PDFACT(32)= -PDFACT(30)*WLD /AILD
      PDFACT( 2)=  PDFACT( 3)*TMASS3
      PDFACT( 5)=  PDFACT( 6)*TMASS3
      PDFACT( 8)=  PDFACT( 9)*TMASS3
      PDFACT(12)=  PDFACT(13)*TMASS3
      IF(KSOTYP(1).NE.0) PDFACT(12)= PDFACT(12)*ARS
      PDFACT(15)=  PDFACT(16)*TMASS3
      IF(KSOTYP(2).NE.0) PDFACT(15)= PDFACT(15)*AIS
      PDFACT(20)=  PDFACT(21)*TMASS3
      PDFACT(23)=  PDFACT(24)*TMASS3
      PDFACT(28)=  PDFACT(29)*TMASS3
      PDFACT(31)=  PDFACT(32)*TMASS3
      PDFACT(10)=  ZZHCAL*3 /(2*RCL**2)
      PDFACT(36)= -1.0D0
      PDFACT(39)= -1.0D0
      PDFACT(38)=  PDFACT(36)*V02 /AR02
      PDFACT(41)=  PDFACT(39)*W02 /AI02
      PDFACT(37)=  PDFACT(38)*TMASS3
      PDFACT(40)=  PDFACT(41)*TMASS3
C --- REAL-CENTRAL (WS) -----
      NN= 0
      DO 10 NSP=1,NSPMAX
      DO 11 NPR= 1,3
      IF(KTPARA(NSP,NPR).LE.0) GO TO 11
      NN= NN +1
      KKPOT(NN)= NPR
   11 CONTINUE
   10 CONTINUE
C
      IF(NN.LE.0) GO TO 200
      DO 110 IR=1,NRMAX,INTGWF
      RRR= DR*(IR-1)
      XX = (RRR-RR )/AR
      IF(XX.GT.XMAX) XX=XMAX
      EE = DEXP(XX )
      EE1 = 1.0D0/(1.0D0 + EE)
C
      DO 120 N=1,NN
      K=KKPOT(N)
      GO TO (101,102,103),K
  101 VPDER(IR, 1)= PDFACT( 1) *EE1
      GO TO 120
  102 VPDER(IR, 2)= PDFACT( 2) *(EE*EE1) *EE1
      GO TO 120
  103 VPDER(IR, 3)= PDFACT( 3) *(EE*EE1) *EE1 *XX
  120 CONTINUE
  110 CONTINUE
      IF(NPARMX.LE.3) GO TO 8900
C --- IMAGINARY-CENTRAL (WS) -----
  200 NN= 0
      DO 20 NSP=1,NSPMAX
      DO 21 NPR= 4,6
      IF(KTPARA(NSP,NPR).LE.0) GO TO 21
      NN= NN +1
      KKPOT(NN)= NPR -3
   21 CONTINUE
   20 CONTINUE
C
      IF(NN.LE.0) GO TO 300
      DO 210 IR=1,NRMAX,INTGWF
      RRR= DR*(IR-1)
      XX = (RRR-RI )/AI
      IF(XX.GT.XMAX) XX=XMAX
      EE = DEXP(XX )
      EE1 = 1.0D0/(1.0D0 + EE)
C
      DO 220 N=1,NN
      K=KKPOT(N)
      GO TO (201,202,203),K
  201 VPDER(IR, 4)= PDFACT( 4) *EE1
      GO TO 220
  202 VPDER(IR, 5)= PDFACT( 5) *(EE*EE1) *EE1
      GO TO 220
  203 VPDER(IR, 6)= PDFACT( 6) *(EE*EE1) *EE1 *XX
  220 CONTINUE
  210 CONTINUE
      IF(NPARMX.LE.6) GO TO 8900
C --- IMAGINARY-CENTRAL (WSD) -----
  300 NN= 0
      DO 30 NSP=1,NSPMAX
      DO 31 NPR= 7,9
      IF(KTPARA(NSP,NPR).LE.0) GO TO 31
      NN= NN +1
      KKPOT(NN)= NPR -6
   31 CONTINUE
   30 CONTINUE
C
      IF(NN.LE.0) GO TO 400
      DO 310 IR=1,NRMAX,INTGWF
      RRR= DR*(IR-1)
      XX = (RRR-RID)/AID
      IF(XX.GT.XMAX) XX=XMAX
      EE = DEXP(XX )
      EE1 = 1.0D0/(1.0D0 + EE)
      EE2 = (EE*EE1) *EE1
C
      DO 320 N=1,NN
      K=KKPOT(N)
      GO TO (301,302,303),K
  301 VPDER(IR, 7)= PDFACT( 7) *EE2
      GO TO 320
  302 VPDER(IR, 8)= PDFACT( 8) *EE2 *((1.0D0-EE)*EE1)
      GO TO 320
  303 VPDER(IR, 9)= PDFACT( 9) *EE2 *((1.0D0-EE)*EE1) *XX
  320 CONTINUE
  310 CONTINUE
      IF(NPARMX.LE.9) GO TO 8900
C --- COULOMB -----
  400 NN= 0
      DO 40 NSP=1,NSPMAX
      DO 41 NPR= 10,10
      IF(KTPARA(NSP,NPR).LE.0) GO TO 41
      NN= NN +1
   41 CONTINUE
   40 CONTINUE
C
      IF(NN.LE.0) GO TO 500
      DO 410 IR=1,NRMAX,INTGWF
      RRR= DR*(IR-1)
      VPDER(IR,10)= 0.0D0
      IF(RRR.GT.RCL) GO TO 420
      XX= (RRR/RCL)**2
      VPDER(IR,10)= PDFACT(10) *(XX-1.0D0)
  420 CONTINUE
  410 CONTINUE
      IF(NPARMX.LE.10) GO TO 8900
C --- REAL-L*S -----
  500 NN= 0
      DO 50 NSP=1,NSPMAX
      DO 51 NPR= 11,13
      IF(KTPARA(NSP,NPR).LE.0) GO TO 51
      NN= NN +1
      KKPOT(NN)= NPR -10
   51 CONTINUE
   50 CONTINUE
C
      IF(NN.LE.0) GO TO 600
      K1=KSOTYP(1)
      DO 510 IR=1,NRMAX,INTGWF
      RRR= DR*(IR-1) +1.0D-40
      XX = (RRR-RRS)/ARS
      IF(XX.GT.XMAX) XX=XMAX
      EE = DEXP(XX )
      EE1 = 1.0D0/(1.0D0 + EE)
      EE2 = (EE*EE1) *EE1
      IF(K1.EQ.0) EE2 = EE2 /RRR
C
      DO 520 N=1,NN
      K=KKPOT(N)
      GO TO (501,502,503),K
  501 VPDER(IR,11)= PDFACT(11) *EE2
      GO TO 520
  502 EE3= (1.0D0-EE)*EE1
      IF(K1.NE.0) EE3= EE3/ARS +1.0D0/RRS
      VPDER(IR,12)= PDFACT(12) *EE2 *EE3
      GO TO 520
  503 VPDER(IR,13)= PDFACT(13) *EE2*(1.0D0 +XX*((1.0D0-EE)*EE1))
  520 CONTINUE
  510 CONTINUE
      IF(NPARMX.LE.13) GO TO 8900
C
C --- IMAGINARY-L*S -----
  600 NN= 0
      DO 60 NSP=1,NSPMAX
      DO 61 NPR= 14,16
      IF(KTPARA(NSP,NPR).LE.0) GO TO 61
      NN= NN +1
      KKPOT(NN)= NPR -13
   61 CONTINUE
   60 CONTINUE
C
      IF(NN.LE.0) GO TO 700
      K2= KSOTYP(2)
      DO 610 IR=1,NRMAX,INTGWF
      RRR= DR*(IR-1) +1.0D-40
      XX = (RRR-RIS)/AIS
      IF(XX.GT.XMAX) XX=XMAX
      EE = DEXP(XX )
      EE1 = 1.0D0/(1.0D0 + EE)
      EE2 = (EE*EE1) *EE1
      IF(K2.EQ.0) EE2= EE2 /RRR
C
      DO 620 N=1,NN
      K=KKPOT(N)
      GO TO (601,602,603),K
  601 VPDER(IR,14)= PDFACT(14) *EE2
      GO TO 620
  602 EE3= (1.0D0-EE)*EE1
      IF(K2.NE.0) EE3= EE3/AIS +1.0D0/RIS
      VPDER(IR,15)= PDFACT(15) *EE2 *EE3
      GO TO 620
  603 VPDER(IR,16)= PDFACT(16) *EE2*(1.0D0 +XX*((1.0D0-EE)*EE1))
  620 CONTINUE
  610 CONTINUE
      IF(NPARMX.LE.16) GO TO 8900
C
C --- FOLDING POT. (CENT) -----
  700 NN= 0
      DO 70 NSP=1,NSPMAX
      DO 71 NPR= 17,18
      IF(KTPARA(NSP,NPR).LE.0) GO TO 71
      NN= NN +1
   71 CONTINUE
   70 CONTINUE
C
      IF(NN.LE.0) GO TO 800
      DO 710 IR=1,NRMAX,INTGWF
      VPDER(IR,17)= VFOLD(IR)
      VPDER(IR,18)= WFOLD(IR)
  710 CONTINUE
      IF(NPARMX.LE.18) GO TO 8900
C
C --- REAL-CENTRAL (WS**2) -----
  800 NN= 0
      DO 80 NSP=1,NSPMAX
      DO 81 NPR= 19,21
      IF(KTPARA(NSP,NPR).LE.0) GO TO 81
      NN= NN +1
      KKPOT(NN)= NPR -18
   81 CONTINUE
   80 CONTINUE
C
      IF(NN.LE.0) GO TO 900
      DO 810 IR=1,NRMAX,INTGWF
      RRR= DR*(IR-1)
      XX = (RRR-RR2)/AR2
      IF(XX.GT.XMAX) XX=XMAX
      EE = DEXP(XX )
      EE1 = 1.0D0/(1.0D0 + EE)
      EE2 = EE1*EE1
C
      DO 820 N=1,NN
      K=KKPOT(N)
      GO TO (801,802,803),K
  801 VPDER(IR,19)= PDFACT(19) *EE2
      GO TO 820
  802 VPDER(IR,20)= PDFACT(20) *(EE*EE2) *EE1
      GO TO 820
  803 VPDER(IR,21)= PDFACT(21) *(EE*EE2) *EE1 *XX
  820 CONTINUE
  810 CONTINUE
      IF(NPARMX.LE.21) GO TO 8900
C --- REAL-CENTRAL (WSD) -----
  900 NN= 0
      DO 90 NSP=1,NSPMAX
      DO 91 NPR= 22,24
      IF(KTPARA(NSP,NPR).LE.0) GO TO 91
      NN= NN +1
      KKPOT(NN)= NPR -21
   91 CONTINUE
   90 CONTINUE
C
      IF(NN.LE.0) GO TO 1000
      DO 910 IR=1,NRMAX,INTGWF
      RRR= DR*(IR-1)
      XX = (RRR-RRD)/ARD
      IF(XX.GT.XMAX) XX=XMAX
      EE = DEXP(XX )
      EE1 = 1.0D0/(1.0D0 + EE)
      EE2 = (EE*EE1) *EE1
C
      DO 920 N=1,NN
      K=KKPOT(N)
      GO TO (901,902,903),K
  901 VPDER(IR,22)= PDFACT(22) *EE2
      GO TO 920
  902 VPDER(IR,23)= PDFACT(23) *EE2 *((1.0D0-EE)*EE1)
      GO TO 920
  903 VPDER(IR,24)= PDFACT(24) *EE2 *((1.0D0-EE)*EE1) *XX
  920 CONTINUE
  910 CONTINUE
      IF(NPARMX.LE.24) GO TO 8900
C --- REAL - L-DEP. (WSD) -----
 1000 NN= 0
      DO 1010 NSP=1,NSPMAX
      DO 1011 NPR= 27,29
      IF(KTPARA(NSP,NPR).LE.0) GO TO 1011
      NN= NN +1
      KKPOT(NN)= NPR -26
 1011 CONTINUE
 1010 CONTINUE
C
      IF(NN.LE.0) GO TO 1100
      DO 1110 IR=1,NRMAX,INTGWF
      RRR= DR*(IR-1)
      XX = (RRR-RRLD)/ARLD
      IF(XX.GT.XMAX) XX=XMAX
      EE = DEXP(XX )
      EE1 = 1.0D0/(1.0D0 + EE)
      EE2 = (EE*EE1) *EE1
C
      DO 1120 N=1,NN
      K=KKPOT(N)
      GO TO (1101,1102,1103),K
 1101 VPDER(IR,27)= PDFACT(27) *EE2
      GO TO 1120
 1102 VPDER(IR,28)= PDFACT(28) *EE2 *((1.0D0-EE)*EE1)
      GO TO 1120
 1103 VPDER(IR,29)= PDFACT(29) *EE2 *((1.0D0-EE)*EE1) *XX
 1120 CONTINUE
 1110 CONTINUE
      IF(NPARMX.LE.29) GO TO 8900
C --- IMAG.- L-DEP. (WSD) -----
 1100 NN= 0
      DO 1020 NSP=1,NSPMAX
      DO 1021 NPR= 30,32
      IF(KTPARA(NSP,NPR).LE.0) GO TO 1021
      NN= NN +1
      KKPOT(NN)= NPR -29
 1021 CONTINUE
 1020 CONTINUE
C
      IF(NN.LE.0) GO TO 1200
      DO 1210 IR=1,NRMAX,INTGWF
      RRR= DR*(IR-1)
      XX = (RRR-RILD)/AILD
      IF(XX.GT.XMAX) XX=XMAX
      EE = DEXP(XX )
      EE1 = 1.0D0/(1.0D0 + EE)
      EE2 = (EE*EE1) *EE1
C
      DO 1220 N=1,NN
      K=KKPOT(N)
      GO TO (1201,1202,1203),K
 1201 VPDER(IR,30)= PDFACT(30) *EE2
      GO TO 1220
 1202 VPDER(IR,31)= PDFACT(31) *EE2 *((1.0D0-EE)*EE1)
      GO TO 1220
 1203 VPDER(IR,32)= PDFACT(32) *EE2 *((1.0D0-EE)*EE1) *XX
 1220 CONTINUE
 1210 CONTINUE
      IF(NPARMX.LE.32) GO TO 8900
C
C --- FOLDING POT. (L*S) -----
 1200 NN= 0
      DO 1030 NSP=1,NSPMAX
      DO 1031 NPR= 33,34
      IF(KTPARA(NSP,NPR).LE.0) GO TO 1031
      NN= NN +1
 1031 CONTINUE
 1030 CONTINUE
C
      IF(NN.LE.0) GO TO 1300
      DO 1310 IR=1,NRMAX,INTGWF
      VPDER(IR,33)= VSFOLD(IR)
      VPDER(IR,34)= WSFOLD(IR)
 1310 CONTINUE
      IF(NPARMX.LE.34) GO TO 8900
C
C --- RENORMALIZATION OF EXPERIMENTAL CROSS SECTION -----
 1300 NN= 0
      DO 1040 NSP=1,NSPMAX
      DO 1041 NPR= 35,35
      IF(KTPARA(NSP,NPR).LE.0) GO TO 1041
      NN= NN +1
 1041 CONTINUE
 1040 CONTINUE
C
      IF(NN.LE.0) GO TO 1400
      DO 1410 IR=1,NRMAX,INTGWF
      VPDER(IR,35)= 0.0
 1410 CONTINUE
      IF(NPARMX.LE.35) GO TO 8900
CCC
C --- REAL-CENTRAL (second WS) -----
 1400 NN= 0
      DO 1050 NSP=1,NSPMAX
      DO 1051 NPR= 36,38
      IF(KTPARA(NSP,NPR).LE.0) GO TO 1051
      NN= NN +1
      KKPOT(NN)= NPR-35
 1051 CONTINUE
 1050 CONTINUE
C
      IF(NN.LE.0) GO TO 1500
      DO 1510 IR=1,NRMAX,INTGWF
      RRR= DR*(IR-1)
      XX = (RRR-RR02)/AR02
      IF(XX.GT.XMAX) XX=XMAX
      EE = DEXP(XX )
      EE1 = 1.0D0/(1.0D0 + EE)
C
      DO 1520 N=1,NN
      K=KKPOT(N)
      GO TO (1501,1502,1503),K
 1501 VPDER(IR,36)= PDFACT(36) *EE1
      GO TO 1520
 1502 VPDER(IR,37)= PDFACT(37) *(EE*EE1) *EE1
      GO TO 1520
 1503 VPDER(IR,38)= PDFACT(38) *(EE*EE1) *EE1 *XX
 1520 CONTINUE
 1510 CONTINUE
      IF(NPARMX.LE.38) GO TO 8900
C --- IMAGINARY-CENTRAL (second WS) -----
 1500 NN= 0
      DO 1060 NSP=1,NSPMAX
      DO 1061 NPR= 39,41
      IF(KTPARA(NSP,NPR).LE.0) GO TO 1061
      NN= NN +1
      KKPOT(NN)= NPR -38
 1061 CONTINUE
 1060 CONTINUE
C
      IF(NN.LE.0) GO TO 1600
      DO 1610 IR=1,NRMAX,INTGWF
      RRR= DR*(IR-1)
      XX = (RRR-RI02)/AI02
      IF(XX.GT.XMAX) XX=XMAX
      EE = DEXP(XX )
      EE1 = 1.0D0/(1.0D0 + EE)
C
      DO 1620 N=1,NN
      K=KKPOT(N)
      GO TO (1601,1602,1603),K
 1601 VPDER(IR,39)= PDFACT(39) *EE1
      GO TO 1620
 1602 VPDER(IR,40)= PDFACT(40) *(EE*EE1) *EE1
      GO TO 1620
 1603 VPDER(IR,41)= PDFACT(41) *(EE*EE1) *EE1 *XX
 1620 CONTINUE
 1610 CONTINUE
      IF(NPARMX.LE.41) GO TO 8900
C
 1600 CONTINUE
C --- SUMMED POTENTIAL (L,J INDEPENDENT) -----
 8900 CONTINUE
      DO 8000  NS=1,NSPMAX
      IF(KSPLJD(NS).GT.0) GO TO 8000
C
      DO 8100 IR=1,NRMAX,INTGWF
      UPDER(IR,NS)= 0.0D0
 8100 CONTINUE
C
      DO 8200 NP=1,NPARMX
      IF(KTPARA(NS,NP).LE.0) GO TO 8200
      KK= KPREIM(NP)
      GO TO (8200,8210,8220),KK+1
 8210 DO 8211 IR=1,NRMAX,INTGWF
      UPDER(IR,NS)= UPDER(IR,NS) + VPDER(IR,NP)
 8211 CONTINUE
      GO TO 8200
 8220 DO 8221 IR=1,NRMAX,INTGWF
      UPDER(IR,NS)= UPDER(IR,NS) + DCMPLX( 0.0D0, VPDER(IR,NP))
 8221 CONTINUE
 8200 CONTINUE
 8000 CONTINUE
C
C --------
      IF(KAKDPO.LE.0) GO TO 9000
      KAKIN= KAKDPO*INTGWF
      WRITE(6,6000) KAKDPO,DR
 6000 FORMAT(///1H ,10X,'===== DERIVATIVE OF POTENTIAL ====='
     1                ,'  KAKPOT,DR=',I4,F10.4)
      DO 6100 NP=1,NPARMX
      DO 6110 NS=1,NSPMAX
      IF(KTPARA(NS,NP).LE.0) GO TO 6100
      IF(NP.GE.25.AND.NP.LE.26) GO TO 6110
 6120 WRITE(6,6200) NP
 6200 FORMAT(/1H ,5X,'**** NP=',I3,' ****')
      WRITE(6,6210) (VPDER(IR,NP),IR=1,NRMAX,KAKIN)
 6210 FORMAT(1H ,3X,1P10D13.5)
 6110 CONTINUE
 6100 CONTINUE
C
 9000 RETURN
      END
CCC
CCC        ****** POTGLJ ******
CCC
      SUBROUTINE POTGLJ(KXPDER,FSS,FLL,FJJ,NSPMAX,NPARMX,NRMAX,INTGWF
     1             ,KTPARA,PARM,PDFACT,KSPLJD,KPREIM,VPDER,ULJ,FLJFAC
     2             ,NRDIM,NSPDIM,NPARDM,LDIM, FACTLS,FACTLJ,UPDER)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION KTPARA(NSPDIM,NPARDM),KSPLJD(NSPDIM),KPREIM(NPARDM)
      DIMENSION PDFACT(NPARDM),PARM(NPARDM),VPDER(NRDIM,NPARDM)
      DIMENSION FLJFAC(LDIM)
      COMPLEX*16 UPDER(NRDIM,NSPDIM),ULJ(NRDIM)
      DATA XMAX /170.0D0/
CCC =========================
C
      FACTLS= FJJ*(FJJ+1.0D0) -FLL*(FLL+1.0D0) -FSS*(FSS+1.0D0)
      L1= FLL +1.01
      FACTLJ= FLJFAC(L1)
C
      IF(KXPDER.LE.0) GO TO 9000
C --- DERIVATIVE OF POTENTIAL -----
      DO 1 I=1,NPARMX
      PDFACT(I)= 1.0D0
    1 CONTINUE
      DO 2 I=11,16
      PDFACT(I)= FACTLS
    2 CONTINUE
      PDFACT(33)= FACTLS
      PDFACT(34)= FACTLS
C
      IF(NPARMX.LE.24) GO TO 3
      CHK= PARM(27)**2 +PARM(30)**2
      IF(CHK.LE.1.0D-20) GO TO 3
      DO 4 I=27,32
      PDFACT(I)= FACTLJ
    4 CONTINUE
      FL0= PARM(25)
      AL = PARM(26)
      FL02= FL0**2
      FL2 = FLL**2
      AL2 = AL **2
      XX= (FL2-FL02)/AL2
      IF(XX.GT.XMAX) XX= XMAX
      EX= DEXP(XX)
      EX1= 1.0D0/(1.0D0+EX)
      EE= (EX*EX1) *EX1 *2
      PDFACT(25)= EE *FL0 /AL2
      PDFACT(26)= EE *XX  /AL
    3 CONTINUE
C
      DO 1000  NS=1,NSPMAX
      IF(KSPLJD(NS).LE.0) GO TO 1000
C
      DO 10 IR=1,NRMAX,INTGWF
      UPDER(IR,NS)= 0.0D0
   10 CONTINUE
C
      DO 2000 NP=1,NPARMX
      IF(KTPARA(NS,NP).LE.0) GO TO 2000
      PDF= PDFACT(NP)
      KK= KPREIM(NP)
      GO TO (2100,2200,2300),KK
 2100 DO 2110 IR=1,NRMAX,INTGWF
      UPDER(IR,NS)= UPDER(IR,NS) + PDF*VPDER(IR,NP)
 2110 CONTINUE
      GO TO 2000
 2200 DO 2210 IR=1,NRMAX,INTGWF
      UPDER(IR,NS)= UPDER(IR,NS) + DCMPLX( 0.0D0, PDF*VPDER(IR,NP))
 2210 CONTINUE
      GO TO 2000
 2300 DO 2310 IR=1,NRMAX,INTGWF
      UPDER(IR,NS)= UPDER(IR,NS) + PDF*ULJ(IR)
 2310 CONTINUE
 2000 CONTINUE
 1000 CONTINUE
C
 9000 RETURN
      END
CCC
CCC        ******** NARCS4 ********
CCC         << FOX-GOODWIN'S METHOD >>
CCC
      SUBROUTINE NARCS4(FM,ECM,FKAY,LL,FACTLS,FACTLJ,VDUCL
     1            ,UCE,USO,ULJ,VCL,NRMAX,DR,NRDIM ,KAKUWF
     2                        ,SMAT,SABS,UNORM,UWF)
C
C                    FM = 2*(REDUCED MASS)*C**2 / HC**2
C                    VDUCL --- 1 -- U(+)
C                              2 -- U(-)
C                              3 -- (D/DRHO) U(+)
C                              4 -- (D/DRHO) U(-)
C                    FACTLS --- L * 2S
      IMPLICIT REAL*8(A-H,O-Z)
C
      COMPLEX*16 UCE(NRDIM),USO(NRDIM),ULJ(NRDIM)
      COMPLEX*16 UWF(NRDIM),VDUCL(4)
      COMPLEX*16 SMAT,UNORM
      DIMENSION VCL(NRDIM)
C
      COMPLEX*16 UUU(3),A1,A2,A3
      COMPLEX*16 DUWF,VUWF
      DATA CINMAX,CINMIN/1.0D-01,1.0D-65/
C -- FOR OVERFLOW CHECK ----
      COMPLEX*16 CU
      DIMENSION DU(2)
      EQUIVALENCE (CU,DU)
      DATA EPSMAX,EPSMIN/1.0D+30,1.0D-40/,LOVRFL/51/
CCC =====================================
C
      MATCHR= NRMAX-3
      DRHO= DR*FKAY
      FLS= FACTLS
      FLJ= FACTLJ
C
CCC ----------- SOLVING UNNORMALIZED WAVE FUNCTION
CCC                               BY FOX - GOODWIN'S METHOD -------
C
      UWF(1)= 0.0D0
C
      CIN=DR**(LL+1)
      CIN=DMIN1(CIN,CINMAX)
      CIN=DMAX1(CIN,CINMIN)
      UWF(2)= CIN
C
      DR2=DR**2
      DR256=DR2*5.0D0/6.0D0
      DR212=DR2/12.0D0
      FLL1= LL*(LL+1)
C
      RR2= DR2
      UUU(2)=FM*( ECM-UCE( 2)-FLS*USO( 2)-FLJ*ULJ( 2)-VCL( 2) )
     1                       - FLL1/RR2
      RR2= DR2*4
      UUU(3)=FM*( ECM-UCE( 3)-FLS*USO( 3)-FLJ*ULJ( 3)-VCL( 3) )
     1                       - FLL1/RR2
C
      IF(LL.EQ.1) THEN
         A1=13.0D0/6.0D0-DR256*UUU(2)
      ELSE
         A1=2.0D0-DR256*UUU(2)
      END IF
      A3=1.0D0+DR212*UUU(3)
      UWF( 3)=A1*UWF( 2)/A3
      UUU(1)=UUU(2)
      UUU(2)=UUU(3)
C
      IF(LL.GE.LOVRFL) GO TO 25
C
C --- FOR SMALL L CASE ---
      DO 20 JR=4,NRMAX
      RR2= ( DR*(JR-1) )**2
      UUU(3)=FM*( ECM-UCE(JR)-FLS*USO(JR)-FLJ*ULJ(JR)-VCL(JR) )
     1                       - FLL1/RR2
      A1=2.0D0-DR256*UUU(2)
      A2=1.0D0+DR212*UUU(1)
      A3=1.0D0+DR212*UUU(3)
      UWF(JR)=(A1*UWF(JR-1)-A2*UWF(JR-2))/A3
      UUU(1)=UUU(2)
      UUU(2)=UUU(3)
   20 CONTINUE
      GO TO 29
C
   25 CONTINUE
C --- FOR LARGE L CASE ---
      DO 26 JR=4,NRMAX
      RR2= ( DR*(JR-1) )**2
      UUU(3)=FM*( ECM-UCE(JR)-FLS*USO(JR)-FLJ*ULJ(JR)-VCL(JR) )
     1                       - FLL1/RR2
      A1=2.0D0-DR256*UUU(2)
      A2=1.0D0+DR212*UUU(1)
      A3=1.0D0+DR212*UUU(3)
      UWF(JR)=(A1*UWF(JR-1)-A2*UWF(JR-2))/A3
      UUU(1)=UUU(2)
      UUU(2)=UUU(3)
      CU=UWF(JR)
      IF( DMAX1( DABS(DU(1)), DABS(DU(2)) )  .LE. EPSMAX) GO TO 26
CC    WRITE(6,121) LL,JR,UWF(JR)
CC121 FORMAT(1H ,'LL=',I3,'  JR=',I4,'  UWF=',1P2D15.7)
      DO 27 IR=1,JR
      UWF(IR)=UWF(IR)*EPSMIN
   27 CONTINUE
   26 CONTINUE
C
   29 CONTINUE
C
CCC ----------- MAKING S-MATRIX ---------------------------------
C
      A1= UWF(MATCHR+1)-UWF(MATCHR-1)
      A2= UWF(MATCHR+2)-UWF(MATCHR-2)
      A3= UWF(MATCHR+3)-UWF(MATCHR-3)
      VUWF= UWF(MATCHR)
C
      TT3=1.0D0/(60.0D0*DRHO)
      TT2=TT3*9.0D0
      TT1=TT2*5.0D0
      DUWF= TT1*A1 -TT2*A2 +TT3*A3
      A1=DUWF/VUWF
C
      A2= A1*VDUCL(2) -VDUCL(4)
      A3= A1*VDUCL(1) -VDUCL(3)
      SMAT= A2/A3
C
      SABS=CDABS(SMAT)
      UNORM= ( VDUCL(2) -SMAT*VDUCL(1) ) /VUWF
C
C ----------- WRITE WAVE FUNCTION -------------------------------
      IF(KAKUWF.LE.0) GO TO 9000
      DO 100 IR=1,NRMAX
      UWF(IR)= UWF(IR)*UNORM
  100 CONTINUE
      UNORM= 1.0D0
C
      WRITE(6,101) LL,FACTLS
  101 FORMAT(/1H ,'*** WAVE FUNCTION ***    LL=',I4,',   L*2S=',F7.2
     1      /1H ,3(1X,'   R  ',1X,'   |U(R)|  ',12X,'U(R)',11X))
      NRMK= (NRMAX-1)/KAKUWF +1
      NRM= NRMK/3
      IF(NRM*3 .NE. NRMK) NRM= NRM+1
      NRMW= NRM*KAKUWF
      DO 102 N=1,NRM
      N1= (N-1)*KAKUWF +1
      N2= N1 +NRMW
      N3= N2 +NRMW
      R1= DR*(N1-1)
      R2= DR*(N2-1)
      R3= DR*(N3-1)
      IF(N3.GT.NRMAX) THEN
       WRITE(6,103) R1,CDABS(UWF(N1)),UWF(N1),R2,CDABS(UWF(N2)),UWF(N2)
      ELSE
       WRITE(6,103) R1,CDABS(UWF(N1)),UWF(N1),R2,CDABS(UWF(N2)),UWF(N2)
     1             ,R3,CDABS(UWF(N3)),UWF(N3)
  103  FORMAT(1H ,3(1X,0PF6.2,1X,1PD11.4,' (',D11.4,',',D11.4,')'))
      END IF
  102 CONTINUE
C
 9000 RETURN
      END
CCC
CCC        ***** SLJDER *****
CCC
      SUBROUTINE SLJDER(FFMM,FKAY,DDRR,NRMAX,NSPMAX,INTGWF
     1                 ,UWF,UPDER,UNORM ,NRDIM,NSPDIM
     2                     ,DTEMP)
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 UWF(NRDIM),UPDER(NRDIM,NSPDIM)
      COMPLEX*16 DTEMP(NSPDIM)
      COMPLEX*16 CFACT1,CFACT2,UNORM,WI
      DATA WI/(0.0D0, 1.0D0)/
C ===================================
      FK2= FKAY*2
      FMKR= FFMM/FK2 *DDRR *INTGWF
      CFACT1= FMKR *WI *UNORM**2
C
      DO 10 NP=1,NSPMAX
      DTEMP(NP)= 0.0D0
   10 CONTINUE
C
      DO 20 IR=1,NRMAX,INTGWF
      CFACT2= UWF(IR)**2
      DO 20 NP=1,NSPMAX
      DTEMP(NP)= DTEMP(NP) +CFACT2*UPDER(IR,NP)
   20 CONTINUE
C
      DO 30 NP=1,NSPMAX
      DTEMP(NP)= DTEMP(NP)*CFACT1
   30 CONTINUE
C
      RETURN
      END
CCC
CCC        ****** SWRITE ******
CCC
      SUBROUTINE SWRITE(PSPIN,KAISUU,LMAX,NSPMAX,IDENT,FKAY,SMAT,DSMAT
     1                 ,LDIM,NJDIM,NSPDIM    ,KAKSMT,KAKDSM)
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 SMAT(LDIM,NJDIM),DSMAT(NSPDIM,LDIM,NJDIM)
      CHARACTER*2 JSN(2)/'  ','/2'/
      DATA PAI/3.141592653589793D0/
CCC ===================================
      NUE21= PSPIN*2 +1.01
      LDEL= 1
      IF(IDENT.GT.0) LDEL= 2
      FK2PAI= PAI/FKAY**2 *10.0D0 /NUE21
C
      IF(KAKSMT.LE.0) GO TO 1900
      IF(KAISUU.GE.0) THEN
         WRITE(6,100) KAISUU
  100    FORMAT(//1H ,15X,'====== S-MATRIX ======'
     1                   ,'   *** SEARCH NUMBER=',I3,' ***')
      ELSE
         WRITE(6,101)
  101    FORMAT(1H1//1H ,15X,'====== S-MATRIX ======')
      END IF
      IJ= 2 -NUE21 +NUE21/2*2
      XELT= 0.0D0
      XABT= 0.0D0
      DO 1000 NJ= 1,NUE21
      XELX= 0.0D0
      XABX= 0.0D0
      FSJ= NJ -PSPIN -1
      J2= FSJ*IJ *1.001
      IF(J2) 111,112,113
  111 WRITE(6,121) J2,JSN(IJ)
  121 FORMAT(/1H ,2X,'*** JJ= LL',I2,A2,' ***')
      GO TO 130
  112 WRITE(6,122)
  122 FORMAT(/1H ,2X,'*** JJ= LL',4X,' ***')
      GO TO 130
  113 WRITE(6,123) J2,JSN(IJ)
  123 FORMAT(/1H ,2X,'*** JJ= LL+',I1,A2,' ***')
  130 WRITE(6,131)
  131 FORMAT(1H ,5X,' LL  JJ',11X,'|S|',10X,'DELTA',18X,'S-MATRIX'
     1          ,17X,'X-EL(NUCL)',7X,'X-ABS',6X,'<MB>')
      DO 1100 L1=1,LMAX+1,LDEL
      LL= L1 -1
      FJ= LL -PSPIN +NJ -1
      IF(FJ.LT.DABS(LL-PSPIN)) GO TO 1100
      SRE= DREAL(SMAT(L1,NJ))
      SIM= DIMAG(SMAT(L1,NJ))
      SAB= CDABS(SMAT(L1,NJ))
      FK2PJ= FK2PAI*(2*FJ+1.0D0)
      XEL= FK2PJ *CDABS(1.0D0-SMAT(L1,NJ))**2
      XAB= FK2PJ *(1.0D0 -SAB**2)
      XELX= XELX +XEL
      XABX= XABX +XAB
      DEL= 0.0D0
      IF(SAB.GT.0.0D0) THEN
         IF(SRE.EQ.0.0D0) THEN
            DEL= 90.0D0 -DSIGN( 45.0D0, SIM)
         ELSE
            DEL= DATAN2( SIM, SRE) *90.0D0/PAI
         END IF
         IF(DEL.LT.0.0D0) DEL= DEL +180.0D0
      END IF
      WRITE(6,1200) LL,FJ,SAB,DEL,SMAT(L1,NJ),XEL,XAB
 1200 FORMAT(1H ,5X,I3,1X,F5.1,' : ',1PD15.7,2X,0PF9.4
     1          ,'   (',1PD15.7,',',D15.7,')',3X,D13.5,2X,D13.5)
 1100 CONTINUE
      WRITE(6,1210) XELX,XABX
 1210 FORMAT(1H ,72X,'<TOTAL> : ',1PD13.5,2X,D13.5)
      XELT= XELT +XELX
      XABT= XABT +XABX
 1000 CONTINUE
      WRITE(6,1220) XELT,XABT
 1220 FORMAT(/1H ,66X,'<TOTAL(FULL)> : ',1PD13.5,2X,D13.5)
 1900 CONTINUE
C
      IF(KAKDSM.LE.0) GO TO 2900
      WRITE(6,200) KAISUU
  200 FORMAT(1H1//1H ,15X,'====== DSMAT ======'
     1                ,'   *** SEARCH NUMBER=',I3,' ***')
C
      DO 2000 NP=1,NSPMAX
      WRITE(6,201) NP
  201 FORMAT(/1H ,2X,'*** PARAMETER NUMBER =',I3,' ***')
      GO TO (210,220,230,240),NUE21
  210 WRITE(6,211)
  211 FORMAT(/1H ,3X,'  LL',9X,'JJ = LL')
      GO TO 290
  220 WRITE(6,221)
  221 FORMAT(/1H ,3X,'  LL',11X,'JJ = LL - 1/2',17X,'JJ = LL + 1/2')
      GO TO 290
  230 WRITE(6,231)
  231 FORMAT(/1H ,3X,'  LL',12X,'JJ = LL - 1',21X,'JJ = LL',21X
     1             ,'JJ = LL + 1')
      GO TO 290
  240 WRITE(6,241)
  241 FORMAT(/1H ,3X,'  LL',11X,'JJ = LL - 3/2',17X,'JJ = LL - 1/2'
     1             ,11X,'JJ = LL + 1/2',11X,'JJ = LL + 3/2')
  290 CONTINUE
      DO 2000 L1=1,LMAX+1,LDEL
      LL= L1 -1
      WRITE(6,2100) LL,(DSMAT(NP,L1,NJ),NJ=1,NUE21)
 2100 FORMAT(1H ,3X,I4,' :',4(:' (',1PD13.6,',',D13.6,')'))
 2000 CONTINUE
 2900 CONTINUE
C
      RETURN
      END
CCCCC
CCCCC          ***** SCTAMP *****
CCCCC
      SUBROUTINE SCTAMP(FKAY,PSPIN,LMAX,NTHMAX,NSPMAX,IDENT,KAISUU
     1             ,KXPDER,KAKFNC,KAKDFN
     2             ,SMAT,DSMAT,SABS,EXSIG2,PLM,FCL,THETAD
     3             ,LDIM,NJDIM,MDIM,NTHDIM,NTHDMP,NUEDM1,NUEDM2,NSPDIM
     4                      ,REACX,FNC,DFNC,DTEMP)
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 SMAT(LDIM,NJDIM),DSMAT(NSPDIM,LDIM,NJDIM)
      DIMENSION SABS(LDIM,NJDIM)
C
      COMPLEX*16 EXSIG2(LDIM),FCL(NTHDMP)
      DIMENSION PLM(NTHDMP,LDIM,MDIM),THETAD(NTHDMP)
C
      COMPLEX*16 FNC(NTHDMP,NUEDM1,NUEDM2)
      COMPLEX*16 DFNC(NSPDIM,NTHDIM,NUEDM1,NUEDM2),DTEMP(NSPDIM)
C
      COMPLEX*16 CFACT1,WI,CCFACT
      DIMENSION NN2(5)
      CHARACTER*2 JSN(2)/'  ','/2'/
      PARAMETER (ZERO= 0.0D0)
      PARAMETER (PAI=3.141592653589793D0, WI=(0.0D0,1.0D0) )
CCC =================================
C
      FACTF= -0.5D0/FKAY
      NUEMX2=PSPIN*2 +0.01
      NUE21=NUEMX2 +1
      NUENUM= NUEMX2/2 +1
      LDEL= 1
C --- IDENTICAL PARTICLE CASE ---
      IF(IDENT.LE.0) GO TO 1
      FACTF=FACTF*2
      LDEL= 2
    1 CONTINUE
C ------
C
      FSS=PSPIN
      FSS1=FSS+1.0D0
C
      REACX= 0.0D0
      DO 10 N1=1,NUENUM
      DO 10 N2=1,NUE21
      DO 10 IT=1,NTHMAX
      FNC(IT,N2,N1)= 0.0D0
   10 CONTINUE
      IF(NSPMAX.LE.0) GO TO 11
      DO 12 N1=1,NUENUM
      DO 12 N2=1,NUE21
      DO 12 IT=1,NTHMAX
      DO 12 NS=1,NSPMAX
      DFNC(NS,IT,N2,N1)= 0.0D0
   12 CONTINUE
   11 CONTINUE
C -----------------------------------------
C
      DO 1000 LL1=1,LMAX+1,LDEL
      LL= LL1 -1
      FLL= LL
      FJMN= DABS(FLL-FSS) -0.01
      FACT1= FACTF *(2*FLL+1.0D0)
      CCFACT= EXSIG2(LL1) *WI *FACT1
C
      DO 2000 NJ=1,NUE21
      FJJ= FLL +NJ -FSS1
      IF(FJJ.LE.FJMN) GO TO 2000
      CFACT1= (SMAT(LL1,NJ)-1.0D0) *CCFACT
      REACX= REACX + (2*FJJ+1.0D0)*(1.0D0-SABS(LL1,NJ)**2)
C
      IF(KXPDER) 21,21,20
   20 DO 2100 NP=1,NSPMAX
      DTEMP(NP)= DSMAT(NP,LL1,NJ) *CCFACT
 2100 CONTINUE
   21 CONTINUE
C
      DO 3000 NUEIX=1,NUENUM
      FNUEI= NUEIX -FSS1
      CLEB= CLEBSH(FLL,ZERO,FSS,FNUEI,FJJ,FNUEI)
C
      DO 4000 NUEFX=1,NUE21
      FNUEF= NUEFX -FSS1
      FMM= FNUEI -FNUEF
      MM=1.001*FMM
      MMABS=IABS(MM)
      MMABS1=MMABS +1
C
      SIGN1= 1.0D0
      IF(MM.GT.0) SIGN1= (-1.0D0)**MMABS
      FACT2=SIGN1*ELEMFC(LL,MMABS) *CLEB
     1           *CLEBSH(FLL,FMM,FSS,FNUEF,FJJ,FNUEI)
C
      DO 5000 IT=1,NTHMAX
      FACT3= FACT2*PLM(IT,LL1,MMABS1)
      FNC(IT,NUEFX,NUEIX)= FNC(IT,NUEFX,NUEIX)
     1                        + FACT3 *CFACT1
      IF(KXPDER) 5000,5000,50
   50 DO 5100 NP=1,NSPMAX
      DFNC(NP,IT,NUEFX,NUEIX)= DFNC(NP,IT,NUEFX,NUEIX)
     1                             + FACT3 *DTEMP(NP)
 5100 CONTINUE
 5000 CONTINUE
C
 4000 CONTINUE
C
 3000 CONTINUE
C
 2000 CONTINUE
C
 1000 CONTINUE
C
C --- ADD COULOMB SCATTERING AMPLITUDE -----
      DO 7000 NUEX=1,NUENUM
      DO 7000 IT=1,NTHMAX
      FNC(IT,NUEX,NUEX)=FNC(IT,NUEX,NUEX) +FCL(IT)
 7000 CONTINUE
C ----------------------------------------
      REACX= REACX *PAI/FKAY**2 *10.0D0 /NUE21
C
      IF(KAKFNC.LE.0) GO TO 8300
      JS= NUEMX2 -NUEMX2/2*2 +1
      WRITE(6,8000) KAISUU
 8000 FORMAT(1H1//1H ,5X,'====== SCATTERING AMPLITUDE (FNC) ======'
     1               ,'   *** SEARCH NUMBER=',I3,' ***')
      N1MAX= NUENUM
      DO 8100 N1=1,N1MAX
      FNUEI= N1 -FSS1
      NI= 1.001*FNUEI
      IF(JS.EQ.2) NI= 2.001*FNUEI
      DO 8010 N2=1,NUE21
      FNUEF= N2 -FSS1
      NF= 1.001*FNUEF
      IF(JS.EQ.2) NF= 2.001*FNUEF
      NN2(N2)= NF
 8010 CONTINUE
      WRITE(6,8020) (NN2(N2),JSN(JS),NI,JSN(JS),N2=1,NUE21)
 8020 FORMAT(/1H ,' THETA',5(:,8X,'( ',I2,A2,', ',I2,A2,')',5X))
      DO 8200 IT=1,NTHMAX,KAKFNC
      WRITE(6,8210) THETAD(IT),(FNC(IT,N2,N1),N2=1,NUE21)
 8210 FORMAT(1H ,F6.2,5(:,' (',1PD11.4,',',D11.4,')'))
 8200 CONTINUE
 8100 CONTINUE
 8300 CONTINUE
C
      IF(KAKDFN.LE.0) GO TO 8400
      JS= NUEMX2 -NUEMX2/2*2 +1
      WRITE(6,8500) KAISUU
 8500 FORMAT(1H1//1H ,5X,'====== DERIVATIVE OF SCATTERING AMPLITUDE'
     1               ,' (DFNC) ======   *** SEARCH NUMBER=',I3,' ***')
      DO 8600 NS=1,NSPMAX
      WRITE(6,8610) NS
 8610 FORMAT(/1H ,'*** NPARM=',I3,' ***')
      N1MAX= NUENUM
      DO 8700 N1=1,N1MAX
      FNUEI= N1 -FSS1
      NI= 1.001*FNUEI
      IF(JS.EQ.2) NI= 2.001*FNUEI
      DO 8710 N2=1,NUE21
      FNUEF= N2 -FSS1
      NF= 1.001*FNUEF
      IF(JS.EQ.2) NF= 2.001*FNUEF
      NN2(N2)= NF
 8710 CONTINUE
      WRITE(6,8020) (NN2(N2),JSN(JS),NI,JSN(JS),N2=1,NUE21)
      DO 8730 IT=1,NTHMAX,KAKDFN
      WRITE(6,8210) THETAD(IT),(DFNC(NS,IT,N2,N1),N2=1,NUE21)
 8730 CONTINUE
 8700 CONTINUE
 8600 CONTINUE
 8400 CONTINUE
C
      RETURN
      END
CCC
CCC        ******** XSCPOL *******
CCC
      SUBROUTINE XSCPOL(PSPIN,NTHMAX,NSPMAX,REACX
     1       ,KXPDER,KCHISQ,KRUTAB,KTXNOR,KAISUU,KAKXPL,KAKDXP,KAKCXP
     2       ,FNC,DFNC,THETAD,NTHDIM,NTHDMP,NUEDM1,NUEDM2,NSPDIM,NSPDM1
     3       ,XSEX,DXEX,POLEX,DPEX,FACNXS,KNXTYP
     4                      ,AXTH,RXTH,RUTX,POLTH,DXTH,DPTH
     5                      ,XCHIT,PCHIT,XCHI,PCHI,CXP)
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 FNC(NTHDMP,NUEDM1,NUEDM2)
      COMPLEX*16 DFNC(NSPDIM,NTHDIM,NUEDM1,NUEDM2)
      DIMENSION THETAD(NTHDMP)
      DIMENSION XSEX(NTHDIM),DXEX(NTHDIM),POLEX(NTHDIM),DPEX(NTHDIM)
C
      DIMENSION AXTH(NTHDMP),RXTH(NTHDMP),RUTX(NTHDMP)
      DIMENSION POLTH(NTHDMP),DXTH(NSPDIM,NTHDIM),DPTH(NSPDIM,NTHDIM)
      DIMENSION XCHI(NTHDIM),PCHI(NTHDIM),CXP(NSPDIM,NSPDM1)
C
      COMPLEX*16 FTEMP1,FTEMP2
      PARAMETER (SQ2=1.41421356237309515D0,SQ3=1.73205080756887719D0)
      DIMENSION FACSPN(4,3)
      DATA FACSPN/ 0.0D0, 1.0D0, SQ2  , SQ3
     1            ,0.0D0, 0.0D0, SQ2  , 2.0D0
     2            ,0.0D0, 0.0D0, 0.0D0, SQ3  /
CCC ===========
      FSS=PSPIN
      NUEMX2= FSS*2 +0.01
      NUE21= NUEMX2 +1
      NUENUM= NUEMX2/2 +1
      NPMX1= NSPMAX +1
C
      IF(KXPDER.LE.0) GO TO 1
      DO 2 N1=1,NPMX1
      DO 2 N2=1,NSPMAX
      CXP(N2,N1)= 0.0D0
    2 CONTINUE
    1 CONTINUE
C
C --- X-SECTION -----
      XFACT=10.0D0/NUE21
      KSX= 1
      IF(KXPDER.LE.0) KSX=-1
      IF(KXPDER.EQ.2) KSX= 0
      KCX= 1
      IF(KCHISQ.LE.0.OR.KCHISQ.EQ.2) KCX= 0
C
      XCHIT= 0.0D0
      DO 10 IT=1,NTHMAX
      AXTH(IT)=0.0D0
   10 CONTINUE
C
      IF(KCX.LE.0) GO TO 11
      DO 12 IT=1,NTHMAX
      XCHI(IT)=0.0D0
   12 CONTINUE
C
   11 IF(KSX.LT.0) GO TO 13
      DO 14 IT=1,NTHMAX
      DO 14 NP=1,NSPMAX
      DXTH(NP,IT)= 0.0D0
   14 CONTINUE
C
   13 IEO= NUEMX2 -NUEMX2/2*2
      DO 1000 NUEIX=1,NUENUM
      IFAC= 2
      IF(IEO.EQ.0 .AND. NUEIX.EQ.NUENUM) IFAC= 1
      JFAC= IFAC*2
      DO 1000 NUEFX=1,NUE21
      DO 1000 IT=1,NTHMAX
      FTEMP1= FNC(IT,NUEFX,NUEIX)
      FTEMP2= DCONJG(FTEMP1)
      XX= FTEMP1*FTEMP2
      AXTH(IT)= AXTH(IT) +IFAC*XX
      IF(KSX) 1000,100,100
  100 DO 1100 NP=1,NSPMAX
      XX= DFNC(NP,IT,NUEFX,NUEIX) *FTEMP2
      DXTH(NP,IT)= DXTH(NP,IT) +JFAC*XX
 1100 CONTINUE
 1000 CONTINUE
C
      DO 1200 IT=1,NTHMAX
      AXTH(IT)=AXTH(IT)*XFACT
      RXTH(IT)=AXTH(IT)
      IF(RUTX(IT).LE.1.0D-30) GO TO 1200
      RXTH(IT)=AXTH(IT)/RUTX(IT)
 1200 CONTINUE
C
      IF(KSX.LT.0) GO TO 1300
      XX= XFACT
      DO 1310 IT=1,NTHMAX
      IF(KRUTAB.EQ.1) XX= XFACT/RUTX(IT)
      DO 1310 NP=1,NSPMAX
      DXTH(NP,IT)= DXTH(NP,IT)*XX
 1310 CONTINUE
 1300 CONTINUE
C
      IF(KTXNOR.LE.0) GO TO 1490
      IF(KNXTYP.EQ.0) THEN
        IF(KRUTAB.EQ.1) THEN
          DO 1401 IT=1,NTHMAX
            DXTH(KTXNOR,IT)= -RXTH(IT)/FACNXS
 1401     CONTINUE
        ELSE
          DO 1402 IT=1,NTHMAX
            DXTH(KTXNOR,IT)= -AXTH(IT)/FACNXS
 1402     CONTINUE
        END IF
      ELSE
        DO 1410 IT=1,NTHMAX
          DXTH(KTXNOR,IT)= -XSEX(IT)
 1410   CONTINUE
      END IF
 1490 CONTINUE
C
C --- X-SECTION CHI-SQUARE -----
      IF(KCX.LE.0) GO TO 2900
C
      KNX1=KNXTYP+1
      DO 2100 IT=1,NTHMAX
      GO TO (2110,2120),KRUTAB
 2110 XX1= RXTH(IT)
      GO TO 2130
 2120 XX1= AXTH(IT)
 2130 GO TO (2140,2150),KNX1
 2140 XX= ( (XX1-FACNXS*XSEX(IT)) / (FACNXS*DXEX(IT)) )**2
      GO TO 2160
 2150 XX= ( (XX1-FACNXS*XSEX(IT)) / DXEX(IT) )**2
 2160 XCHI(IT)= XX
      XCHIT= XCHIT +XX
 2100 CONTINUE
C
      IF(KSX.LE.0) GO TO 2900
      DFNX2=2.0D0
      IF(KNXTYP.EQ.0) DFNX2=DFNX2/FACNXS**2
      DO 2200 IT=1,NTHMAX
      GO TO (2210,2220),KRUTAB
 2210 XX1= RXTH(IT)
      GO TO 2230
 2220 XX1= AXTH(IT)
 2230 DX2= DFNX2/DXEX(IT)**2
      DO 2200 N1=1,NSPMAX
      XX= (XX1-FACNXS*XSEX(IT)) *DXTH(N1,IT)
      CXP(N1,NPMX1)= CXP(N1,NPMX1) +XX*DX2
      DO 2200 N2=1,NSPMAX
      XX= DXTH(N1,IT)*DXTH(N2,IT)
      CXP(N1,N2)= CXP(N1,N2) +XX*DX2
 2200 CONTINUE
C
 2900 CONTINUE
C
C --- POLARIZATION ------
      KSP= KXPDER -2
      KCP= KCHISQ -1
C
      PCHIT= 0.0D0
      DO 30 IT=1,NTHMAX
      POLTH(IT)=0.0D0
   30 CONTINUE
C
      IF(KCP.LE.0) GO TO 31
      DO 32 IT=1,NTHMAX
      PCHI(IT)=0.0D0
   32 CONTINUE
C
   31 IF(KSP.LT.0) GO TO 33
      DO 34 IT=1,NTHMAX
      DO 34 NP=1,NSPMAX
      DPTH(NP,IT)= 0.0D0
   34 CONTINUE
C
   33 IF(FSS.LE.0.1) GO TO 3900
      PFACT=XFACT/FSS *100.0D0 *2
C
      DO 3000 NUEFX=1,NUE21-1
      DO 3100 NUEIX=1,NUE21-1
      NIF= NUEIX+NUEFX
      IF(NIF.GT.NUE21) GO TO 3100
      NIX= NUEIX
      NFX= NUEFX
      NFX1= NFX +1
      FACSN= FACSPN(NUE21,NUEFX)
      IF(NIX.GT.NUENUM) THEN
         NIX= NUE21-NIX+1
         NFX= NUE21-NFX+1
         NFX1= NUE21-NFX1+1
         FACSN= -FACSN
      END IF
      DO 3200 IT=1,NTHMAX
      FTEMP1= FNC(IT, NFX , NIX)
      FTEMP2= DCONJG( FNC(IT, NFX1, NIX) )
      POLTH(IT)= POLTH(IT) +DIMAG( FTEMP1*FTEMP2 )*FACSN
      IF(KSP) 3200,300,300
  300 DO 310 NP=1,NSPMAX
      PP= DIMAG( DFNC(NP,IT,NFX,NIX)*FTEMP2
     1                  +FTEMP1*DCONJG(DFNC(NP,IT,NFX1,NIX)) )
      DPTH(NP,IT)= DPTH(NP,IT) +PP*FACSN
  310 CONTINUE
 3200 CONTINUE
 3100 CONTINUE
 3000 CONTINUE
C
      DO 3400 IT=1,NTHMAX
      PP= POLTH(IT) /AXTH(IT) *PFACT
      POLTH(IT)= PP
      IF(KSP) 3400,340,340
  340 XX = PFACT /AXTH(IT)
      XX1= RXTH(IT)
      IF(KRUTAB.EQ.2) XX1= AXTH(IT)
      XX1= PP/XX1
      DO 3500 NP=1,NSPMAX
      PP1= DPTH(NP,IT)
      DPTH(NP,IT)= PP1*XX  -XX1*DXTH(NP,IT)
 3500 CONTINUE
 3400 CONTINUE
C
C --- POLARIZATION CHI-SQUARE ---
      IF(KCP.LE.0) GO TO 3900
C
      DO 4000 IT=1,NTHMAX
      PP= ( (POLTH(IT)-POLEX(IT))/DPEX(IT) )**2
      PCHI(IT)= PP
      PCHIT= PCHIT +PP
 4000 CONTINUE
C
      IF(KSP.LT.0) GO TO 3900
      DO 4100 IT=1,NTHMAX
      DP2= 2.0D0/ (DPEX(IT))**2
      DO 4100 N1=1,NSPMAX
      PP= (POLTH(IT)-POLEX(IT)) *DPTH(N1,IT)
      CXP(N1,NPMX1)= CXP(N1,NPMX1) +PP*DP2
      DO 4100 N2=1,NSPMAX
      PP= DPTH(N1,IT)*DPTH(N2,IT)
      CXP(N1,N2)= CXP(N1,N2) +PP*DP2
 4100 CONTINUE
C
 3900 CONTINUE
C
C --- WRITE X-SECTION & POLARIZATION ---
C
      IF(KAKXPL.LE.0) GO TO 620
      WRITE(6,611) KAISUU,FACNXS
  611 FORMAT(/1H ,8X,'===== X-SECTION & POLARIZATION (IN XSCPOL) ====='
     1     ,2X,'*** SEARCH NUMBER =',I3,' ***',5X,'FACNXS=',F12.6
     2     //1H ,'  THETA',2X,'   XSEC (TH)  ','   XS/RX (TH) '
     3       ,'   XSEC (EX)  ','    X-CHI2  ',' DEL-X (EX) '
     4       ,'     RUTX   ','   POL (TH) ','   POL (EX) '
     5       ,'    P-CHI2  ','  DEL-P (EX)')
      WRITE(6,612) (THETAD(IT),AXTH(IT),RXTH(IT),XSEX(IT)
     1     ,XCHI(IT),DXEX(IT),RUTX(IT)
     2     ,POLTH(IT),POLEX(IT),PCHI(IT),DPEX(IT),IT=1,NTHMAX,KAKXPL)
  612 FORMAT(1H ,F7.2,2X,1P3D14.6,3D12.3,0P2F12.6,1PD12.3,0PF11.6)
      WRITE(6,613) XCHIT,PCHIT,REACX
  613 FORMAT(/1H ,' TOTAL : ',42X,1PD14.6,46X,D14.6
     1      //1H ,' REACX = ',1PD14.6)
C
  620 IF(KAKDXP.LE.0) GO TO 630
      WRITE(6,621) KAISUU,KAKDXP
  621 FORMAT(/1H ,8X,'===== DXTH, DPTH ====='
     1          ,2X,'*** SEARCH NUMBER =',I3,' ***    KAKDXP=',I4)
      DO 622 NP=1,NSPMAX
      IF(KSX.GE.0)
     1   WRITE(6,625) NP,(DXTH(NP,I),I=1,NTHMAX,KAKDXP)
  625 FORMAT(/1H ,2X,'*** DXTH ***  NP=',I3,/(1H ,5X,1P10D12.4))
      IF(KSP.GE.0)
     1   WRITE(6,626) NP,(DPTH(NP,I),I=1,NTHMAX,KAKDXP)
  626 FORMAT(/1H ,2X,'*** DPTH ***  NP=',I3,/(1H ,5X,1P10D12.4))
  622 CONTINUE
C
  630 IF(KAKCXP.LE.0) GO TO 640
      IF(KSX.LT.0 .AND. KSP.LT.0) GO TO 640
      WRITE(6,631) KAISUU
  631 FORMAT(/1H ,8X,'===== CXP(N1,N2)  (IN XSCPOL) ====='
     1          ,2X,'*** SEARCH NUMBER =',I3,' ***')
      DO 632 N2MN=1,NPMX1,10
      N2MX= MIN0(N2MN+9,NPMX1)
      WRITE(6,633) (I,I=N2MN,N2MX)
  633 FORMAT(/1H ,2X,' N1  N2=',10(4X,I3,5X))
      DO 632 N1=1,NSPMAX
      WRITE(6,634) N1,(CXP(N1,NN),NN=N2MN,N2MX)
  634 FORMAT(1H ,2X,I3,5X,1P10D12.4)
  632 CONTINUE
  640 CONTINUE
C
      RETURN
      END
CCC
CCC        ***** PWRITE *****
CCC
      SUBROUTINE PWRITE(PMASS,TMASS,ZZHCAL,DDRR,NRMAX,LMAX,KAKPIN,KAKPFI
     1     ,NRDIM,NPARDM,LDIM
     2     ,PARM,VFOLD,WFOLD,VSFOLD,WSFOLD,UCE,USO,ULJ,VCL,FLJFAC
     3     ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     4     ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2 ,KSOTYP)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION PARM(NPARDM)
      DIMENSION VFOLD(NRDIM),WFOLD(NRDIM),VSFOLD(NRDIM),WSFOLD(NRDIM)
      COMPLEX*16 UCE(NRDIM),USO(NRDIM),ULJ(NRDIM)
      DIMENSION VCL(NRDIM),FLJFAC(LDIM)
      DIMENSION V0R0A(3,2),W0R0A(3,2),WDR0A(3,2),R0COUL(2)
      DIMENSION VSR0A(3,2),WSR0A(3,2),FNRNI(2,2),V2R0A(3,2),VDR0A(3,2)
      DIMENSION FL0AL(2,2),VLDR0A(3,2),WLDR0A(3,2),FSNRNI(2,2),KSOTYP(2)
      DIMENSION FNXSEX(2)
      DIMENSION V0R0A2(3,2),W0R0A2(3,2)
CCC ===================================
C
      DR= DDRR
C
      IF(KAKPIN.LE.0) GO TO 1000
C --- WRITE INITIAL POTENTIAL ---
      KNTLPV= 1
      IIFF= 1
      KAKPOT=KAKPIN
C ------
      CALL PVCHNG(KNTLPV,IIFF,PARM,NPARDM
     1    ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     2    ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2)
C ------
      WRITE(6,100)
  100 FORMAT(1H1///1H ,15X,'====== INITIAL POTENTIAL ======')
C ------
      CALL POTGEN(PMASS,TMASS,ZZHCAL,DR,NRMAX,LMAX,KAKPOT,KSOTYP
     1           ,PARM,VFOLD,WFOLD,VSFOLD,WSFOLD, NRDIM,NPARDM,LDIM
     2                                  ,UCE,USO,ULJ,VCL,FLJFAC)
C ------
C
 1000 IF(KAKPFI.LE.0) GO TO 2000
C --- WRITE FINAL POTENTIAL ---
      KNTLPV= 1
      IIFF= 2
      KAKPOT=KAKPFI
C ------
      CALL PVCHNG(KNTLPV,IIFF,PARM,NPARDM
     1    ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     2    ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2)
C ------
      WRITE(6,200)
  200 FORMAT(1H1///1H ,15X,'====== FINAL POTENTIAL ======')
C ------
      CALL POTGEN(PMASS,TMASS,ZZHCAL,DR,NRMAX,LMAX,KAKPOT,KSOTYP
     1           ,PARM,VFOLD,WFOLD,VSFOLD,WSFOLD, NRDIM,NPARDM,LDIM
     2                                  ,UCE,USO,ULJ,VCL,FLJFAC)
C ------
C
 2000 RETURN
      END
CCC
CCC        ***** PVCHNG *****
CCC
      SUBROUTINE PVCHNG(KNTLPV,IIFF,PARM,NPARDM
     1   ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     2   ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION PARM(NPARDM)
C
      DIMENSION V0R0A(3,2),W0R0A(3,2),WDR0A(3,2),R0COUL(2)
      DIMENSION VSR0A(3,2),WSR0A(3,2),FNRNI(2,2),V2R0A(3,2),VDR0A(3,2)
      DIMENSION FL0AL(2,2),VLDR0A(3,2),WLDR0A(3,2),FSNRNI(2,2),FNXSEX(2)
      DIMENSION V0R0A2(3,2),W0R0A2(3,2)
CCC ===========================
C
      I= IIFF
      GO TO (10,10),I
      WRITE(6,60) I
   60 FORMAT(/1H ,'***** ERROR IN "PVCHNG" --- IIFF=',I5)
      STOP
   10 GO TO (1000,2000),KNTLPV
      WRITE(6,600) KNTLPV
  600 FORMAT(/1H ,'**** ERROR IN "PVCHNG" --- KNTLPV=',I5)
      STOP
C
 1000 PARM( 1)= V0R0A( 1, I)
      PARM( 2)= V0R0A( 2, I)
      PARM( 3)= V0R0A( 3, I)
      PARM( 4)= W0R0A( 1, I)
      PARM( 5)= W0R0A( 2, I)
      PARM( 6)= W0R0A( 3, I)
      PARM( 7)= WDR0A( 1, I)
      PARM( 8)= WDR0A( 2, I)
      PARM( 9)= WDR0A( 3, I)
      PARM(10)= R0COUL(   I)
      PARM(11)= VSR0A( 1, I)
      PARM(12)= VSR0A( 2, I)
      PARM(13)= VSR0A( 3, I)
      PARM(14)= WSR0A( 1, I)
      PARM(15)= WSR0A( 2, I)
      PARM(16)= WSR0A( 3, I)
      PARM(17)= FNRNI( 1, I)
      PARM(18)= FNRNI( 2, I)
      PARM(19)= V2R0A( 1, I)
      PARM(20)= V2R0A( 2, I)
      PARM(21)= V2R0A( 3, I)
      PARM(22)= VDR0A( 1, I)
      PARM(23)= VDR0A( 2, I)
      PARM(24)= VDR0A( 3, I)
      PARM(25)= FL0AL( 1, I)
      PARM(26)= FL0AL( 2, I)
      PARM(27)= VLDR0A( 1, I)
      PARM(28)= VLDR0A( 2, I)
      PARM(29)= VLDR0A( 3, I)
      PARM(30)= WLDR0A( 1, I)
      PARM(31)= WLDR0A( 2, I)
      PARM(32)= WLDR0A( 3, I)
      PARM(33)= FSNRNI( 1, I)
      PARM(34)= FSNRNI( 2, I)
      PARM(35)= FNXSEX(    I)
      PARM(36)= V0R0A2( 1, I)
      PARM(37)= V0R0A2( 2, I)
      PARM(38)= V0R0A2( 3, I)
      PARM(39)= W0R0A2( 1, I)
      PARM(40)= W0R0A2( 2, I)
      PARM(41)= W0R0A2( 3, I)
      GO TO 9000
C
 2000 V0R0A( 1, I)= PARM( 1)
      V0R0A( 2, I)= PARM( 2)
      V0R0A( 3, I)= PARM( 3)
      W0R0A( 1, I)= PARM( 4)
      W0R0A( 2, I)= PARM( 5)
      W0R0A( 3, I)= PARM( 6)
      WDR0A( 1, I)= PARM( 7)
      WDR0A( 2, I)= PARM( 8)
      WDR0A( 3, I)= PARM( 9)
      R0COUL(   I)= PARM(10)
      VSR0A( 1, I)= PARM(11)
      VSR0A( 2, I)= PARM(12)
      VSR0A( 3, I)= PARM(13)
      WSR0A( 1, I)= PARM(14)
      WSR0A( 2, I)= PARM(15)
      WSR0A( 3, I)= PARM(16)
      FNRNI( 1, I)= PARM(17)
      FNRNI( 2, I)= PARM(18)
      V2R0A( 1, I)= PARM(19)
      V2R0A( 2, I)= PARM(20)
      V2R0A( 3, I)= PARM(21)
      VDR0A( 1, I)= PARM(22)
      VDR0A( 2, I)= PARM(23)
      VDR0A( 3, I)= PARM(24)
      FL0AL( 1, I)= PARM(25)
      FL0AL( 2, I)= PARM(26)
      VLDR0A( 1, I)= PARM(27)
      VLDR0A( 2, I)= PARM(28)
      VLDR0A( 3, I)= PARM(29)
      WLDR0A( 1, I)= PARM(30)
      WLDR0A( 2, I)= PARM(31)
      WLDR0A( 3, I)= PARM(32)
      FSNRNI( 1, I)= PARM(33)
      FSNRNI( 2, I)= PARM(34)
      FNXSEX(    I)= PARM(35)
      V0R0A2( 1, I)= PARM(36)
      V0R0A2( 2, I)= PARM(37)
      V0R0A2( 3, I)= PARM(38)
      W0R0A2( 1, I)= PARM(39)
      W0R0A2( 2, I)= PARM(40)
      W0R0A2( 3, I)= PARM(41)
C
 9000 RETURN
      END
CCCCC
CCCCC      ***** ELEMNT *****
CCCCC
      SUBROUTINE ELEMNT(PMASS,TMASS,ZP,ZT,   MP,MT,NAMEP,NAMET)
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (MMAX=109)
      CHARACTER*2 NAMEP,NAMET
      CHARACTER*2 NAT(MMAX),NAP(3),NAA(2),NEU,NON
      DATA  NEU,NAT / ' n',
     1      ' H','He','Li','Be',' B',' C',' N',' O',' F','Ne','Na',
     2      'Mg','Al','Si',' P',' S','Cl','Ar',' K','Ca','Sc','Ti',
     3      ' V','Cr','Mn','Fe','Co','Ni','Cu','Zn','Ga','Ge','As',
     4      'Se','Br','Kr','Rb','Sr',' Y','Zr','Nb','Mo','Tc','Ru',
     5      'Rh','Pd','Ag','Cd','In','Sn','Sb','Te',' I','Xe','Cs',
     6      'Ba','La','Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb','Dy',
     7      'Ho','Er','Tm','Yb','Lu','Hf','Ta',' W','Re','Os','Ir',
     8      'Pt','Au','Hg','Tl','Pb','Bi','Po','At','Rn','Fr','Ra',
     9      'Ac','Th','Pa',' U','Np','Pu','Am','Cm','Bk','Cf','Es',
     A      'Fm','Md','No','Lr','Rf','Db','Sg','Bh','Hs','Mt'/
      DATA NAP /' p',' d',' t'/,  NAA/'-p','-n'/, NON/'??'/
CCC ============================================================
      MP= nint(PMASS)
      MT= nint(TMASS)
      IZP=nint(ZP)
      IZT=nint(ZT)
C
      IF(IZP.EQ.-1) THEN
         NAMEP= NAA(1)
      ELSE IF(IZP.EQ. 0) THEN
         NAMEP= NEU
      ELSE IF(IZP.EQ. 1 .AND. MP.LE.3) THEN
         NAMEP= NAP(MP)
      ELSE IF(IZP.GE.1 .AND. IZP.LE.MMAX) THEN
         NAMEP= NAT(IZP)
      ELSE
         NAMEP= NON
      END IF
C
      IF(IZT.EQ.-1) THEN
         NAMET= NAA(1)
      ELSE IF(IZT.EQ. 0) THEN
         NAMET= NEU
      ELSE IF(IZT.EQ. 1 .AND. MT.LE.3) THEN
         NAMET= NAP(MT)
      ELSE IF(IZT.GE.1 .AND. IZT.LE.MMAX) THEN
         NAMET= NAT(IZT)
      ELSE
         NAMET= NON
      END IF
C
      RETURN
      END
CCC
CCC            ***** PLMFUN *****
CCC    the associated Legendre function P(L,M)
CCC                     2002/09/05  revised
CCC                     2002/09/20  revised
CCC
C      NOTE! : declaration of array PLM is
C                      PLM( NTHDIM, 0:LDIM, 0:MDIM)
C
      SUBROUTINE PLMFUN(LDIM,MDIM,NTHDIM,LMAX,MMAX,NTHMAX,THETAD, PLM)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION PLM(NTHDIM,0:LDIM,0:MDIM),THETAD(NTHDIM)
      parameter (DEGRAD=3.141592653589793D0/180.0d0)
CCCCC ==============================================================
      IF(LMAX.gt.LDIM .or. MMAX.gt.MDIM .or. NTHMAX.gt.NTHDIM) then
        WRITE(6,9000) LMAX,LDIM,MMAX,MDIM,NTHMAX,NTHDIM
 9000   FORMAT(10X,'*** ERROR *** dimension over in PLMFUN'
     1        /20X,'LMAX,   LDIM=',2I5 /20X,'MMAX,   MDIM=',2I5
     2        /20X,'NTHMAX, NTHDIM=',2I5)
        stop
      ENDIF
C
      DO 1 IT= 1, NTHMAX

      DO 2 LL=0,LMAX
      DO 2 MM=0,MMAX
      PLM(IT,LL,MM)=0.0
    2 CONTINUE

      theta= THETAD(IT)*DEGRAD
      X= COS(theta)
      SQX= abs(SIN(theta))
c     SQX= SQRT(1.0D0-X**2)
      DFACT= 1.0D0
      SQXM= 1.0d0

      MMAX1= MIN0(MMAX,LMAX)
      DO 3 MM= 0, MMAX1
      if(MM.gt.0) then
        DFACT=DFACT*(2*MM-1)
        SQXM= SQXM *SQX
      endif
c            P(L,M) for L = M
      PLM(IT,MM,MM)= DFACT *SQXM

      if(LMAX.le.MM) goto 3
c            P(L,M) for L = M+1
      PLM(IT,MM+1,MM)= X*(2*MM+1)*PLM(IT,MM,MM)
c            P(L,M)  for L > M+1
      DO  LL=MM+2,LMAX
        PLM(IT,LL,MM)=
     1     ((2*LL-1)*X*PLM(IT,LL-1,MM)-(LL+MM-1)*PLM(IT,LL-2,MM))
     2               / (LL-MM)
      END DO

    3 CONTINUE

    1 CONTINUE
c
      RETURN
      END
CCCCC
CCCCC          ***** SIGMAL *****
CCCCC
      SUBROUTINE SIGMAL(ETA,LMAX,LDIM,    SIGMA0,EXSIG)
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 EXSIG(LDIM)
CCC                        ------> SIGMA(0),EXP(WI*SIGMA(L+1))
CCCCC ===============================================
      IF(ETA.GE.10.0)  GO TO 10
      ETA2=ETA*ETA
      ETA2A=2.0*ETA
      ETA6=ETA2+16.0
      SIGMA0=-(ETA/(12.0*ETA6))*(1.0+(ETA2-48.0)/(30.0*(ETA6**2))
     1       +((ETA2-160.0)*ETA2+1280.0)/(105.0*(ETA6**4)))
     2       -ETA+(ETA/2.0)*DLOG(ETA6)+3.5*DATAN(0.25*ETA)
     4       -(DATAN(ETA)+DATAN(0.5*ETA)+DATAN(ETA/3.0))
      GO TO 11
   10 EINV1=1.0/ETA
      EINV2=EINV1*EINV1
      EINV3=EINV1*EINV2
      EINV5=EINV3*EINV2
      EINV7=EINV5*EINV2
      EINV9=EINV7*EINV2
      SIGMA0=0.7853981634D0+ETA*DLOG(ETA)-ETA
     1      -(0.08333333333D0*EINV1+0.00277777777D0*EINV3
     2      +0.00079365079D0*EINV5+0.00059523810D0*EINV7
     3      +0.00084175084D0*EINV9)
   11 MODTPI=SIGMA0/6.2831853071796D0
      SIGMAZ=SIGMA0-6.2831853071796D0*MODTPI
      EXSIG(1)=DCMPLX(DCOS(SIGMAZ),DSIN(SIGMAZ))
      IF(LMAX.LE.0) RETURN
      IF(LMAX+1.GT.LDIM) GO TO 60
      SIGML= SIGMA0
      DO 1 LL=1,LMAX
      LL1=LL+1
      SIGML= SIGML +DATAN(ETA/LL)
      MODTPI=SIGML/6.2831853071796D0
      SIGMAZ=SIGML-6.2831853071796D0*MODTPI
      EXSIG(LL1)=DCMPLX(DCOS(SIGMAZ),DSIN(SIGMAZ))
    1 CONTINUE
      RETURN
   60 WRITE(6,100) LMAX,LDIM
  100 FORMAT(/1H ,'****** DIMENSION OVER IN "SIGMAL" LMAX=',I4,' LDIM='
     1          ,I4)
      STOP
      END
CCCCC
CCCCC      ***** FCOUL *****
CCCCC                         IDENT = 0
CCCCC                               = 1 --- FCL(TH) + FCL(PAI-TH)
CCCCC                               = 2 --- FCL(TH) - FCL(PAI-TH)
CCCCC
      SUBROUTINE FCOUL(ETA,FKAY,SIGMA0,IDENT,NTHMAX,THETAD,NTHDIM, FCL)
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 FCL(NTHDIM)
      DIMENSION THETAD(NTHDIM)
      DATA PAI/3.141592653589793D0/
CCC ======================================================
      PAI2=PAI+PAI
      DR=PAI/180.0D0
      FDR=DR/2.0D0
      IDENT1= IDENT +1
C
      DO 1 IT=1,NTHMAX
      TH= THETAD(IT)
      SINE=DSIN(TH*FDR)
      SINE2=SINE*SINE  +1.0D-30
      FACT=-ETA/(2.0D0*FKAY*SINE2)
      ARG=-ETA*DLOG(SINE2)+2.0D0*SIGMA0
      MOD2PI=ARG/PAI2
      ARG=ARG-PAI2*MOD2PI
      FCL(IT)=FACT*DCMPLX(DCOS(ARG),DSIN(ARG))
      GO TO (1,2,2),IDENT1
    2 TH1= 180.0D0 -TH
      SINE=DSIN(TH1*FDR)
      SINE2=SINE*SINE  +1.0D-30
      FACT=-ETA/(2.0D0*FKAY*SINE2)
      ARG=-ETA*DLOG(SINE2)+2.0D0*SIGMA0
      MOD2PI=ARG/PAI2
      ARG=ARG-PAI2*MOD2PI
      GO TO (1,12,13),IDENT1
   12 FCL(IT)= FCL(IT) + FACT*DCMPLX(DCOS(ARG),DSIN(ARG))
      GO TO 1
   13 FCL(IT)= FCL(IT) - FACT*DCMPLX(DCOS(ARG),DSIN(ARG))
    1 CONTINUE
C
      RETURN
      END
CCCCC
CCCCC      ****** COULFG ******
CCCCC
C***   NEW  COULFG   ***
      SUBROUTINE COULFG(L,ETA,RHO1,RHO2,DRHO,F1,G1,F2,G2,FP1,GP1)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION  F(210),G(210),FP(211),GP(211)
C
      LL=L+1 +1
      E=ETA
      H=DRHO
      R=RHO1
      RP=RHO2
      TE=E+E
      TF=E**2
      IF(LL-50)20,35,35
   20 ELP=50.
      J=50
      GO TO 45
   35 ELP=LL
      J=LL
   45 A=DATAN(E/ELP)
      B=DSQRT(TF+ELP**2)
      Y=A*(ELP-0.5)+E*(DLOG(B)-1.0)-DSIN(A)/(12.0*B)
     1  +DSIN(3.*A)/(360.*B**3)-DSIN(5.*A)/(1260.*B**5)
     2  +DSIN(7.*A)/(1680.*B**7)-DSIN(9.*A)/(1188.*B**9)
      K=J-1
      IF(J-LL)65,65,70
   65 S1=Y
   70 DO 100 I=1,K
      ELP=ELP-1.
      J=J-1
      Y=Y-DATAN(E/ELP)
  100 CONTINUE
      S1=Y
      DEL1=R-TE
      RMAX=DMAX1(10.0D0,(TF+3.0+4.0*E)*5.0/12.0)
      DEL=R-RMAX
      IF(E-5.)280,130,130
  130 IF(DABS(DEL1)-DABS(DEL))140,140,280
  140 DEL=DEL1
      IF(DEL)147,145,147
  145 I=2
      GO TO 150
  147 I=1
  150 X=TE
      T1=TF
      T2=T1**2
C**   T3=E** .666666667
C**   T9=E** .166666667
      T9=E**(1.0/6.0)
      T3=T9**4
      T4=T3**2
      T5=T4**2
      T6=T3*T5
      T7=T4*T6
      T8=T3*T7
      Y=1.22340402D0*T9*(1.+.495957017D-1/T4-.888888889D-2/T1+.245519918
     1D-2/T6-.910895806D-3/T2+.253468412D-3/T8)
      Z=-.707881773D0/T9*(1.-.172826039D0/T3+.317460317D-3/T1-.358121485
     1D-2/T5+.311782468D-3/T2-.907396643D-3/T7)
      GO TO 665
  280 IF(E)285,290,285
  285 IF(DEL)310,290,290
  290 X=R
      I=2
      GO TO 320
  310 X=RMAX
      I=1
  320 T1=TF
      T2=X+X
      T3=X-E*DLOG(T2)+S1
      T4=E/T2
      SS=1.
      TS=0.
      SL=0.
      TL=1.-E/X
      SSS=1.
      STS=0.
      SSL=0.
      STL=TL
      EN=0.
      DO 620 K=1,25
      T5=EN+1.
      T6=T5+EN
      T7=EN*T5
      T8=T6*T4/T5
      T9=(T1-T7)/(T2*T5)
      T5=T8*SS-T9*TS
      TS=T8*TS+T9*SS
      SS=T5
      IF(DABS(SS/SSS)-1.0D-10) 630,630,540
  540 T5=T8*SL-T9*TL-SS/X
      TL=T8*TL+T9*SL-TS/X
      SL=T5
      SSS=SSS+SS
      STS=STS+TS
      SSL=SSL+SL
      STL=STL+TL
      EN=EN+1.
  620 CONTINUE
  630 T8=DSIN(T3)
      T9=DCOS(T3)
      Y=SSS*T9-STS*T8
      Z=SSL*T9-STL*T8
  665 GO TO (670,810),I
  670 M=1
  671 N=DABS(DEL/H)
      IF(N)675,675,680
  675 DX=DEL
      GO TO 700
  680 EN=N
      DX=DEL/EN
  700 T1=0.5*DX
      T2=0.25*T1
      T3=TE
      DO 805 I=1,N
      T4=DX*(T3/X-1.)*Y
      X=X+T1
      T5=DX*(T3/X-1.)*(Y+T1*Z+T2*T4)
      X=X+T1
      T6=DX*(T3/X-1.)*(Y+DX*Z+T1*T5)
      Y=Y+DX*(Z+(T4+T5+T5)/6.0)
      Z=Z+(T4+4.*T5+T6)/6.
  805 CONTINUE
      GO TO (810,828),M
  810 G(1)=Y
      M=2
      DEL=RP-R
      W=Z
      GO TO 671
  828 GP(1)=Y
      T1=TF
      T8=DSQRT(1.+T1)
      G(2)=((1./R+E)*G(1)-W)/T8
      GP(2)=((1./RP+E)*Y-Z)/T8
      T2=1.
      T3=2.
      DO 910 I=3,LL
      T4=T2+T3
      T5=T2*T3
      T6=T3*DSQRT(T2**2+T1)
      T7=T2*DSQRT(T3**2+T1)
      G (I)=(T4*(E+T5/R )*G (I-1)-T6*G (I-2))/T7
      GP(I)=(T4*(E+T5/RP)*GP(I-1)-T6*GP(I-2))/T7
      T2=T2+1.
      T3=T3+1.
  910 CONTINUE
C**   I=L+11
      I=LL+11
      N=R+R+11.0
      IF(I-N)960,960,950
  950 N=I
  960 Y=1.0E-20
      YP=Y
      X=Y
      XP=X
      Z=0.
      ZP=Z
      T2=N
 1000 T3=T2+1.
      T4=T2+T3
      T5=T2*T3
      T6=T2*DSQRT(T3**2+T1)
      T7=T3*DSQRT(T2**2+T1)
      Y =(T4*(E+T5/R )*Y -T6*Z )/T7
      YP=(T4*(E+T5/RP)*YP-T6*ZP)/T7
      IF(N-LL)1060,1060,1080
 1060 F(N)=Y
      FP(N)=YP
      GO TO 1120
 1080 IF(1.-DABS(Y))1090,1090,1120
 1090 Y=Y*1.0E-20
      YP=YP*1.0E-20
      X=X*1.0E-20
      XP=XP*1.0E-20
 1120 N=N-1
      Z=X
      ZP=XP
      X=Y
      XP=YP
      T2=T2-1.
      IF(N)1150,1150,1000
 1150 Y=F(1)*G(2)-F(2)*G(1)
      YP=FP(1)*GP(2)-FP(2)*GP(1)
      Z=1./(Y*T8)
      ZP=1./(YP*T8)
      DO 1180 I=1,LL
      FP(I)=FP(I)*ZP
 1180 F(I)=F(I)*Z
      F1=F(L+1)
      F2=FP(L+1)
      G1=G(L+1)
      G2=GP(L+1)
      AL1=L+1
      A=AL1**2/RHO1+ETA
      B=AL1**2+ETA**2
      B=DSQRT(B)
      FP1=(A*F1-B*F(L+2))/AL1
      GP1=(A*G1-B*G(L+2))/AL1
      RETURN
      END
CCC
CCC       ******** ELEMFC ********
CCC             ELEMFC= DSQRT( (L-M)!/(L+M)! )
CCC
      FUNCTION ELEMFC(L,M)
      IMPLICIT  REAL*8(A-H,O-Z)
      COMMON /ANGMOM/FACLOG(650),NFLMAX,MEMOAM
CCC ===================================================
      IF(MEMOAM.EQ.8206) GO TO 2
      MEMOAM=8206
      FACLOG(1)=0.0D0
      FACLOG(2)=0.0D0
      DO 1 I=3,NFLMAX
      FI=I-1
      FACLOG(I)=FACLOG(I-1)+DLOG(FI)
    1 CONTINUE
C
    2 CONTINUE
      ELEMFC=0.0D0
      K1=L-M
      K2=L+M
      IF(K1.LT.0) RETURN
      A=(FACLOG(K1+1)-FACLOG(K2+1)) /2.0D0
      ELEMFC=DEXP(A)
      RETURN
      END
CCC       ******** CLEB0 ********
CCC               CLEB0 (A1,A2,A)  FOR TALMI
CCC
      FUNCTION CLEB0(A1,A2,A3)
      IMPLICIT  REAL*8(A-H,O-Z)
      COMMON /ANGMOM/FACLOG(650),NFLMAX,MEMOAM
CCC ====================================================
      IF(MEMOAM.EQ.8206) GO TO 100
      MEMOAM=8206
      FACLOG(1)=0.0D0
      FACLOG(2)=0.0D0
      FN=1.0D0
      DO 10 I=3,NFLMAX
      FN=FN+1.0D0
      FACLOG(I)=FACLOG(I-1)+DLOG(FN)
   10 CONTINUE
  100 CONTINUE
      CLEB0=0.0D0
      J1=A1+.1
      J2=A2+.1
      J=A3+.1
      IG=J1+J2+J
      IF(IG.NE.IG/2*2) RETURN
      KG=IG/2
      IF(J.GT.J1+J2) RETURN
      IF(J.LT.IABS(J1-J2)) RETURN
      YJ=2*J+1
      S=DLOG(YJ)+FACLOG(J1+J2-J+1)+FACLOG(J1+J-J2+1)+FACLOG(J2+J-J1+1)
     1  -FACLOG(J1+J2+J+2)
      G=FACLOG(KG+1)-FACLOG(KG-J1+1)-FACLOG(KG-J2+1)-FACLOG(KG-J+1)
      C=0.5D0*S+G
      CLEB0=(-1.0D0)**(KG-J)*DEXP(C)
      RETURN
      END
CCC
CCC       ******** CLEBSH ********
CCC
      FUNCTION CLEBSH(FJ1,FM1,FJ2,FM2,FJ3,FM3)
      IMPLICIT  REAL*8(A-H,O-Z)
C**
C**   A FUNCTION FOR CLEBSCH-GORDAN COEFFICIENTS WITH ARBITRARY
C**  1ARGUMENTS
C**   A ORIGINAL FORTRAN PROGRAM CODE OF FUNCTION TYPE WITH INTEGER
C**   ARGUMENTS BY T.TAMURA IS REVISED AS FUNCTION TYPE WITH FLOATING
C**   POINT ARGUMENTS BY M.SAKAKURA
C**   INPUT IS (J1,M1,J2,M2/J,M) FLOATING POINT ARGUMENTS
C**
      COMMON /ANGMOM/FACLOG(650),NFLMAX,MEMOAM
CCC ====================================================
      IF(MEMOAM.EQ.8206) GO TO 2
      MEMOAM=8206
      FACLOG(1)=0.0D0
      FACLOG(2)=0.0D0
      FN=1.0D0
      DO 10 I=3,NFLMAX
      FN=FN+1.0D0
   10 FACLOG(I)=FACLOG(I-1)+DLOG(FN)
    2 CLEBSH=0.0D0
      IF(FJ1) 506,30,30
   30 IF(FJ2) 506,31,31
   31 IF(FJ3) 506,32,32
   32 IA = 2.0*FJ1+0.01
      IB = 2.0*FJ2+0.01
      IC = 2.0*FJ3+0.01
      IF (FM1) 41,42,43
   41 ID = 2.0*FM1 -0.01
      GO TO 50
   42 ID = 0
      GO TO 50
   43 ID=2.0*FM1+ 0.01
   50 IF (FM2) 51,52,53
   51 IE = 2.0*FM2- 0.01
      GO TO 60
   52 IE = 0
      GO TO 60
   53 IE = 2.0*FM2 + 0.01
   60 IF (FM3) 61,62,63
   61 IF = 2.0*FM3 - 0.01
      GO TO 70
   62 IF = 0
      GO TO 70
   63 IF = 2.0*FM3 + 0.01
   70 IF(ID+IE-IF) 500,105,500
  105 K1=IA+IB+IC
      IF(K1-2*(K1/2)) 501,110,501
  110 K1=IA+IB-IC
      K2=IC-IABS (IB-IA)
      K3= MIN0 (K1,K2)
      IF(K3) 502,130,130
  130 IF((-1)**(IB+IE)) 503,503,140
  140 IF((-1)**(IC+IF)) 503,503,150
  150 IF(IA-IABS (ID)) 505,152,152
  152 IF(IB-IABS (IE)) 505,154,154
  154 IF(IC-IABS (IF)) 505,160,160
  160 IF(IA) 506,175,165
  165 IF(IB) 506,175,170
  170 IF(IC) 506,180,250
  175 CLEBSH=1.0
      RETURN
  180 FB=IB+1
      CLEBSH=((-1.0)**((IA-ID)/2))/DSQRT(FB)
      GO TO 1000
  250 FC2=IC+1
      IABCP=(IA+IB+IC)/2+1
      IABC=IABCP-IC
      ICAB=IABCP-IB
      IBCA=IABCP-IA
      IAPD=(IA+ID)/2+1
      IAMD=IAPD-ID
      IBPE=(IB+IE)/2+1
      IBME=IBPE-IE
      ICPF=(IC+IF)/2+1
      ICMF=ICPF-IF
      SQFCLG=0.5*(DLOG(FC2)-FACLOG(IABCP+1)
     1       +FACLOG(IABC)+FACLOG(ICAB)+FACLOG(IBCA)
     2       +FACLOG(IAPD)+FACLOG(IAMD)+FACLOG(IBPE)
     3       +FACLOG(IBME)+FACLOG(ICPF)+FACLOG(ICMF))
      NZMIC2=(IB-IC-ID)/2
      NZMIC3=(IA-IC+IE)/2
      NZMI= MAX0 (0,NZMIC2,NZMIC3)+1
      NZMX= MIN0 (IABC,IAMD,IBPE)
      S1=(-1.0)**(NZMI-1)
      IF(NZMX.LT.NZMI) GO TO 1000
      DO 400 NZ=NZMI,NZMX
      NZM1=NZ-1
      NZT1=IABC-NZM1
      NZT2=IAMD-NZM1
      NZT3=IBPE-NZM1
      NZT4=NZ-NZMIC2
      NZT5=NZ-NZMIC3
      TERMLG=SQFCLG-FACLOG(NZ)-FACLOG(NZT1)-FACLOG(NZT2)
     1                 -FACLOG(NZT3)-FACLOG(NZT4)-FACLOG(NZT5)
      SSTERM=S1*DEXP(TERMLG)
      CLEBSH=CLEBSH+SSTERM
      S1=-S1
  400 CONTINUE
      RETURN
  500 CONTINUE
CC    WRITE(6,600) FM1,FM2,FM3
      RETURN
  501 CONTINUE
CC    WRITE(6,601) FJ1,FJ2,FJ3
      RETURN
  502 CONTINUE
CC    WRITE(6,602) FJ1,FJ2,FJ3
      RETURN
  503 CONTINUE
CC    WRITE(6,603) FJ1,FM1,FJ2,FM2,FJ3,FM3
      RETURN
  505 CONTINUE
CC    WRITE(6,605) FJ1,FM1,FJ2,FM2,FJ3,FM3
      RETURN
  506 CONTINUE
CC    WRITE(6,606) FJ1,FJ2,FJ3
      RETURN
  600 FORMAT(1H ,'***** ERROR * SUM OF MAGNETIC QUANTUM NUMBER IS NOT'
     1 ,' ZERO IN CLEB * M1 =',F6.1,2X,'M2 =',F6.1,2X,'M3 =',F6.1
     2 ,' *****')
  601 FORMAT(1H ,'***** ERROR * SUM OF ANGULAR MOMENTUM IS NOT INTEGER'
     1 ,' IN CLEB * J1 =',F6.1,2X,'J2 =',F6.1,2X,'J3 =',F6.1,' *****')
  602 FORMAT(1H ,'***** ERROR * TRIANGULAR CONDITION IS VIOLATED IN'
     1 ,' CLEB * J1 =',F6.1,2X,'J2 =',F6.1,2X,'J3 =',F6.1,' *****')
  603 FORMAT(1H ,'***** ERROR * (J,M) PAIRS INVALID IN CLEB * J1 =',F5.1
     1 ,2X,'M1 =',F6.1,2X,'J2 =',F6.1,2X,'M2 =',F6.1,2X,'J3 =',F6.1
     2 ,2X,'M3 =',F6.1,' *****')
  605 FORMAT(1H ,'***** ERROR * ABS(M.Q.N.) .GT. A.M. IN CLEB * J1='
     1 ,' M1 =',F6.1,' J2 =',F6.1,' M2 =',F6.1,' J3 =',F6.1,' M3 =',F6.1
     2 ,' *****')
  606 FORMAT(1H ,'***** ERROR * THERE ARE SOME NEGATIVE A.M. IN CLEB'
     1 ,'* J1 =',F6.1,2X,'J2 =',F6.1,2X,'J3 =',F6.1,' *****')
 1000 RETURN
      END
CCC
CCC        ***** SUPHOD *****
CCC
C    THIS PROGRAM IS O.K. ONLY WHEN JISU=3.    ------ CARE ----
C    THIS PROGRAM IS O.K. ONLY WHEN DX=CONST   ------ CARE ----
C
      FUNCTION SUPHOD(XIN,X,Y,NRMAX,NRDIM)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION  X(NRDIM),Y(NRDIM)
CCC ===================================================
      JISU=3
      IZISU=JISU+1
C
CC    IF(NRMAX.GE.IZISU) GO TO 4000
CC    WRITE(6,400) NRMAX,JISU
CC400 FORMAT(/1H ,' NRMAX,JISU=',2I5,10X,'STOP IN SUPHOD')
CC    STOP
C4000 CONTINUE
C
      NNR=(XIN-X(1))/(X(2)-X(1)) +1.0001
C
CC    IF(NNR.GE.1.AND.NNR.LE.NRMAX) GO TO 5000
CC    WRITE(6,500) NNR
CC500 FORMAT(/1H ,' NNR=',I5,10X,'STOP IN HOKAN --- XIN < X(1) ---'
CC   1        ,1X,' OR  --- XIN > X(NRMAX) ---')
CC    STOP
C5000 CONTINUE
C
      JMIN=NNR-2
      JMAX=NNR+1
      IF(JMIN.LE.1) JMIN=1
      IF(JMAX.GE.NRMAX) JMIN=NRMAX-3
C
C
      X0=X(JMIN)
      X1=X(JMIN+1)
      X2=X(JMIN+2)
      X3=X(JMIN+3)
C
      Y0=Y(JMIN)
      Y1=Y(JMIN+1)
      Y2=Y(JMIN+2)
      Y3=Y(JMIN+3)
C
      XIN0=XIN-X0
      XIN1=XIN-X1
      XIN2=XIN-X2
      XIN3=XIN-X3
C
      X01=X0-X1
      X02=X0-X2
      X03=X0-X3
C
      X10=X1-X0
      X12=X1-X2
      X13=X1-X3
C
      X20=X2-X0
      X21=X2-X1
      X23=X2-X3
C
      X30=X3-X0
      X31=X3-X1
      X32=X3-X2
C
      XX0= (XIN1*XIN2*XIN3) / (X01*X02*X03)
      XX1= (XIN0*XIN2*XIN3) / (X10*X12*X13)
      XX2= (XIN0*XIN1*XIN3) / (X20*X21*X23)
      XX3= (XIN0*XIN1*XIN2) / (X30*X31*X32)
C
      SUPHOD=XX0*Y0
     1      +XX1*Y1
     2      +XX2*Y2
     3      +XX3*Y3
C
      RETURN
      END
CCC
CCC        ******** FIGLIN ********
CCC
CCC        ***** F(X)=FACT*G(X)+CONST *****
CCC                         -1.0.GE.G(X).GE.+1.0
      SUBROUTINE FIGLIN(XX,NX,NDIM,NXDEL,FUNC,FACT,CONST,LCOND)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION FUNC(NDIM),VN(5),XX(NDIM)
      CHARACTER*1 MAP(101)
CCC
CCC   LCOND>0---BOTH FACT AND CONST ARE GIVEN VALUES.
CCC   LCOND=0---BOTH FACT AND CONST ARE SERCHED AUTOMATICALY.
CCC   LCOND<0---FACT IS SERCHED AUTOMATICALY,CONST IS A GIVEN VALUES.
CCC    FACT=  0.0---ONE LINE BECOMES ZERO (OPTIMIZED).
CCC    FACT> 10.0---LEFT LINE BECOMES ZERO (FIXED).
CCC    FACT<-10.0---RIGHT LINE BECOMES ZERO (FIXED).
CCC =============================================
      N=NX
      NDELT=NXDEL
      FACTX=FACT
      CONSTX=CONST
CC    WRITE(6,600) NX,NXDEL,FACT,CONST,LCOND
CC600 FORMAT(1H ,90X,'NX=',I3,' NXDEL=',I2
CC   1      /1H ,90X,'FACT=',1PD10.3,' CONST='D10.3,' LCOND=',I4)
      IF(LCOND.GT.0) GO TO 99
  800 COEF=0.8
CC800 COEF=1.0
      DM1=FUNC(1)
      IF(DABS(FACT).LT.1.0D-5) DM1=0.0
      DM2=DM1
      MDELT=3*NDELT
      DO 801 MD=1,N,MDELT
      DM1=DMAX1(DM1,FUNC(MD))
      DM2=DMIN1(DM2,FUNC(MD))
  801 CONTINUE
      IF(FACT.GT.10.0) GO TO 841
      IF(FACT.LT.-10.0) GO TO 840
      IF(DM1*DM2.LE.0.0) GO TO 810
      IF(LCOND.EQ.0) GO TO 820
      DMF1=DABS(DM1-CONSTX)
      DMF2=DABS(DM2-CONSTX)
      FACTX=DMAX1(DMF1,DMF2)/COEF
      GO TO 99
  810 IF(DABS(DM1).LT.1.0D-20) GO TO 840
      IF(DABS(DM2).LT.1.0D-20) GO TO 841
      DMR=-DM1/DM2
      IF(DMR.GE.3.0) GO TO 850
      IF(DMR.GE.2.0) GO TO 851
      IF(DMR.GE.0.5) GO TO 852
      IF(DMR.GE.(1.0/3.0)) GO TO 853
      FACTX=-DM2*2.0/(3.0*COEF)
      CONSTX=-FACTX/2.0
      GO TO 99
  850 FACTX=DM1*2.0/(3.0*COEF)
      CONSTX=FACTX/2.0
      GO TO 99
  851 CONSTX=-DM2/COEF
      FACTX=-DM2*2/COEF
      GO TO 99
  852 CONSTX=0.0
      FACTX=DMAX1(DM1,-DM2)/COEF
      GO TO 99
  853 CONSTX=-DM1/COEF
      FACTX=DM1*2/COEF
      GO TO 99
  820 CONSTX=(DM1+DM2)/2.0
      FACTX=(DM1-CONSTX)/COEF
      GO TO 99
  840 CONSTX=DM2/(2*COEF)
      FACTX=-CONSTX
      GO TO 99
  841 CONSTX=DM1/(2*COEF)
      FACTX=CONSTX
      GO TO 99
CCC
   99 DO 100 M=1,5
      VN(M)=(0.5*M-1.5)*FACTX+CONSTX
  100 CONTINUE
      WRITE(6,1000) (VN(J),J=1,5)
      WRITE(6,3000)
CCCCCCC
      DO 200 I=1,N,NDELT
C
      AI=(FUNC(I)-CONSTX)/FACTX
      IF(AI.GE.0.0) THEN
         K0=AI/0.0200 +0.500 +51
      ELSE
         AB=DABS(AI)
         K1=AB/0.02 +0.500
         K0=51-K1
      END IF
C
      DO 10 J=1,101
   10 MAP(J)= ' '
      DO 11 J=1,101,25
   11 MAP(J)= '|'
      IF(K0.GE.1 .AND. K0.LE.101) MAP(K0)= '*'
C
      WRITE(6,2000) XX(I),FUNC(I),(MAP(J),J=1,101)
  200 CONTINUE
CCCC
      WRITE(6,3000)
      RETURN
 1000 FORMAT(/1H ,3X,'  THETA ',4X,'  PY (TH)'
     1       /1H ,3X,'  (DEG) ',4X,'    (%)  '
     2       ,1X,F7.2,17X,F7.2,3(18X,F7.2))
 2000 FORMAT(1H ,3X,F8.3,4X,F9.4,3X,101A1)
 3000 FORMAT(1H ,27X,1H+,4(24('-'),1H+))
      END
CCC
CCC        ******** NEW FIGLOG ********
CCC
      SUBROUTINE FIGLOG(XX,N,NDIM,NDELT,FUNC,NZYOIN,NHANI,LCOND)
CCC         10**NZYOIN.GE.FUNC(X).LE.10**(NZYOIN+NHANI)
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER*1 MAP(101)
      DIMENSION FUNC(NDIM),XX(NDIM),KOSU(6),IN(7)
      DATA KOSU/100,50,30,25,20,15/
CCC
CCC   LCOND>0---BOTH NZYOIN AND NHANI ARE GIVEN VALUES.
CCC   LCOND.LE.0---BOTH NZYOIN AND NHANI ARE SERCHED AUTOMATICALY.
CCC              NZYOIN.GE.0--UPPER LIMIT IS OPTIMIZED.
CCC              NZYOIN.LT.0--LOWER LIMIT IS OPTIMIZED.
CCC =====================================
      NZYOIX=NZYOIN
      NHANX=NHANI
C
      IF(LCOND.GT.0) GO TO 1111
      DM1=FUNC(1)
      DM2=FUNC(1)
      MDELT=3*NDELT
      DO 101 I=1,N,MDELT
      DM1=DMAX1(DM1,FUNC(I))
      DM2=DMIN1(DM2,FUNC(I))
  101 CONTINUE
      DM1= DLOG10(DABS(DM1) +1.0D-70)
      DM2= DLOG10(DABS(DM2) +1.0D-70)
      DD1=DABS(DM1)
      DD2=DABS(DM2)
      NDM1=DD1
      NDM2=DD2
      IF(DM1.GT.0.0) NDM1=NDM1+1
      IF(DM1.LE.0.0) NDM1=-NDM1
      IF(DM2.LT.0.0) NDM2=-NDM2-1
      MMDD=NDM1-NDM2
      NHANX= MMDD
      NHANX= MIN0( NHANX, 6)
      NHANX= MAX0( NHANX, 1)
      NZYOIX=NDM2
      IF(NZYOIN.GE.0) NZYOIX=NDM1-NHANX
CCCC
 1111 CONTINUE
      NH=NHANX
      DO 4 MM=1,NH+1
      IN(MM)=NZYOIX+MM-1
    4 CONTINUE
      IF(NH.LE.0)GO TO 2006
      IF(NH.GE.2)GO TO 5
      WRITE(6,2000) (IN(MM),MM=1,2)
 2000 FORMAT(  /1H ,8X,'THETA',6X,' XS (TH)',1X,'10**',I3
     1             ,93X,'10**',I3)
      GO TO 2007
    5 IF(NH.GE.3)GO TO 6
      WRITE(6,2001) (IN(MM),MM=1,3)
 2001 FORMAT(  /1H ,7X,'THETA',6X,' XS (TH)',1X,'10**',I3
     1             ,2(43X,'10**',I3))
      GO TO 2007
    6 IF(NH.GE.4)GO TO 7
      WRITE(6,2002) (IN(MM),MM=1,4)
 2002 FORMAT(  /1H ,8X,'THETA',6X,' XS (TH)',2X,'10**',I3
     1             ,3(23X,'10**',I3))
      GO TO 2007
    7 IF(NH.GE.5)GO TO 8
      WRITE(6,2003) (IN(MM),MM=1,5)
 2003 FORMAT(  /1H ,7X,'THETA',6X,' XS (TH)',1X,'10**',I3
     1             ,4(18X,'10**',I3))
      GO TO 2007
    8 IF(NH.GE.6)GO TO 9
      WRITE(6,2004) (IN(MM),MM=1,6)
 2004 FORMAT(  /1H ,7X,'THETA',6X,' XS (TH)',1X,'10**',I3
     1             ,5(13X,'10**',I3))
      GO TO 2007
    9 IF(NH.GE.7)GO TO 2006
      WRITE(6,2005) (IN(MM),MM=1,7)
 2005 FORMAT(  /1H ,6X,'THETA',6X,' XS (TH)',2X,'10**',I3
     1             ,6(8X,'10**',I3))
      GO TO 2007
 2006 WRITE(6,2008) NH
 2008 FORMAT(  /1H ,'******* ERROR IN NEW FIGLOG ---- NHANI > 6.OR <= 0'
     1                      /1H ,33X,'NHANI=',I3)
      RETURN
CCCCCC
 2007 WRITE(6,3000)
      KB2=DLOG10(2.0D0)*KOSU(NH)+1.5000
      KB4=DLOG10(4.0D0)*KOSU(NH)+1.5000
      KB8=DLOG10(8.0D0)*KOSU(NH)+1.5000
      JMAX=101
CCC
      DO 1000 IX=1,N,NDELT
      DO 10 J=1,JMAX
   10 MAP(J)= ' '
      DO 11 J=1,JMAX,KOSU(NH)
   11 MAP(J)= '|'
      IF(NH.LE.2) THEN
         DO 12 MM=1,NH
         KK= KOSU(NH)*(MM-1)
         MAP(KB2+KK)= ':'
         MAP(KB4+KK)= ':'
   12    MAP(KB8+KK)= ':'
      END IF
C
      FF= FUNC(IX)
      IF(FF.LE.0.0D0) GO TO 400
      GG=DLOG10(FF) -NZYOIX
      K1=GG*KOSU(NH)+1.500
      IF(K1.GE.1 .AND. K1.LE.JMAX) MAP(K1)= '*'
C
  400 WRITE(6,2500) XX(IX),FUNC(IX),(MAP(J),J=1,101)
 1000 CONTINUE
CCC
      WRITE(6,3000)
      RETURN
 2500 FORMAT(1H ,4X,F8.4,3X,1PD11.4,4X,101A1)
 3000 FORMAT(1H ,30X,1H+,99('-'),1H+)
      END
CCC
CCC        ******** FIGLG2 ********
CCC
      SUBROUTINE FIGLG2(XX,N,NDIM,NDELT,FUNC1,NJOIN1,NHANI1,LCOND1,
     1                                  FUNC2,NJOIN2,NHANI2,LCOND2)
CCCCC         10**NJOIN.GE.FUNC(X).LE.10**(NJOIN+NHANI)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION XX(NDIM),FUNC1(NDIM),FUNC2(NDIM)
      DIMENSION KOSU(6),IN1(7),IN2(7)
      CHARACTER*1 MAP(101)
      DATA KOSU/100,50,30,25,20,15/
CCCCC
CCCCC LCOND>0---BOTH NJOIN AND NHANI ARE GIVEN VALUES.
CCCCC LCOND.LE.0---BOTH NJOIN AND NHANI ARE SERCHED AUTOMATICALY.
CCCCC LCOND1(2)=-888--- ONLY NHANI1(2)=NHANI2(1)
CCCCC LCOND1(2)=-999---NJOIN1(2)=NJOIN2(1),AND NHANI1(2)=NHANI2(1)
CCCCC             NJOIN.GE.0---UPPER LIMIT IS OPTIMIZED.
CCCCC             NJOIN.LT.0---LOWER LIMIT IS OPTIMIZED.
CCCCC
      NHANX1=NHANI1
      NHANX2=NHANI2
      NJOIX1=NJOIN1
      NJOIX2=NJOIN2
CCCCC ------------------
      IF(LCOND1.GT.0) GO TO 1111
      IF(LCOND1.EQ.-999) GO TO 1112
 1113 DM1=FUNC1(1)
      DM2=FUNC1(1)
      MDELT=3*NDELT
      DO 101 I=1,N,MDELT
      DM1=DMAX1(DM1,FUNC1(I))
      DM2=DMIN1(DM2,FUNC1(I))
  101 CONTINUE
      DM1= DLOG10(DABS(DM1) +1.0D-70)
      DM2= DLOG10(DABS(DM2) +1.0D-70)
      DM11=DM1
      DM12=DM2
      IF(LCOND1.EQ.-999.AND.LCOND2.EQ.-999) GO TO 1114
 1116 DD1=DABS(DM1)
      DD2=DABS(DM2)
      NDM1=DD1
      NDM2=DD2
      IF(DM1.GT.0.0) NDM1=NDM1+1
      IF(DM1.LE.0.0) NDM1=-NDM1
      IF(DM2.LT.0.0) NDM2=-NDM2-1
      MMDD=NDM1-NDM2
      NHANX1=MMDD
      NHANX1= MIN0( NHANX1, 6)
      NHANX2= MAX0( NHANX1, 1)
      NJOIX1=NDM2
      IF(NJOIN1.GE.0) NJOIX1=NDM1-NHANX1
 1111 CONTINUE
      IF(LCOND2.GT.0) GO TO 2222
      IF(LCOND2.EQ.-999) GO TO 2999
 1112 IF(LCOND2.EQ.-999) GO TO 1113
 1114 DM1=FUNC2(1)
      DM2=FUNC2(1)
      DO 201 I=1,N,MDELT
      DM1=DMAX1(DM1,FUNC2(I))
      DM2=DMIN1(DM2,FUNC2(I))
  201 CONTINUE
      DM1= DLOG10(DABS(DM1) +1.0D-70)
      DM2= DLOG10(DABS(DM2) +1.0D-70)
      DM21=DM1
      DM22=DM2
      IF(LCOND1.EQ.-999.AND.LCOND2.EQ.-999) GO TO 1115
      DD1=DABS(DM1)
      DD2=DABS(DM2)
      NDM1=DD1
      NDM2=DD2
      IF(DM1.GT.0.0) NDM1=NDM1+1
      IF(DM1.LE.0.0) NDM1=-NDM1
      IF(DM2.LT.0.0) NDM2=-NDM2-1
      MMDD=NDM1-NDM2
      NHANX2=MMDD
      NHANX2= MIN0( NHANX2, 6)
      NHANX2= MAX0( NHANX2, 1)
      NJOIX2=NDM2
      IF(NJOIN2.GE.0) NJOIX2=NDM1-NHANX2
      IF(LCOND1.NE.-999) GO TO 2222
      NJOIX1=NJOIX2
      NHANX1=NHANX2
      GO TO 2223
 1115 DM1=DMAX1(DM11,DM21)
      DM2=DMIN1(DM12,DM22)
      GO TO 1116
 2999 CONTINUE
      NJOIX2=NJOIX1
      NHANX2=NHANX1
      GO TO 2223
 2222 CONTINUE
      IF(LCOND1.NE.-888) GO TO 2888
      IF(LCOND2.NE.-888) GO TO 2889
      NHANX1=MAX0(NHANX1,NHANX2)
      NHANX2=NHANX1
      GO TO 2223
 2889 NHANX1=NHANX2
      GO TO 2223
 2888 IF(LCOND2.NE.-888) GO TO 2223
      NHANX2=NHANX1
      GO TO 2223
CCCCC ------------------
 2223 CONTINUE
      NH1=NHANX1
      NH2=NHANX2
      DO 4 MM=1,NH1+1
      IN1(MM)=NJOIX1+MM-1
    4 CONTINUE
      DO 24 MM=1,NH2+1
      IN2(MM)=NJOIX2+MM-1
   24 CONTINUE
C
      IF(NH1.LE.0)GO TO 2006
      IF(NH1.GE.2)GO TO 5
      WRITE(6,2000) (IN1(MM),MM=1,2)
 2000 FORMAT(1H /3X,'THETA',3X,'  TH ',6X,' EX  ',1X,'10**',I3
     1             ,93X,'10**',I3)
      GO TO 2007
    5 IF(NH1.GE.3)GO TO 6
      WRITE(6,2001) (IN1(MM),MM=1,3)
 2001 FORMAT(1H /3X,'THETA',3X,' TH  ',6X,' EX   10**',I3
     1             ,2(43X,'10**',I3))
      GO TO 2007
    6 IF(NH1.GE.4)GO TO 7
      WRITE(6,2002) (IN1(MM),MM=1,4)
 2002 FORMAT(1H /3X,'THETA',3X,' TH  ',6X,' EX    10**',I3
     1             ,3(23X,'10**',I3))
      GO TO 2007
    7 IF(NH1.GE.5)GO TO 8
      WRITE(6,2003) (IN1(MM),MM=1,5)
 2003 FORMAT(1H /3X,'THETA',3X,'  TH ',6X,'  EX  10**',I3
     1             ,4(18X,'10**',I3))
      GO TO 2007
    8 IF(NH1.GE.6)GO TO 9
      WRITE(6,2004) (IN1(MM),MM=1,6)
 2004 FORMAT(1H /3X,'THETA',3X,'  TH ',6X,' EX   10**',I3
     1             ,5(13X,'10**',I3))
      GO TO 2007
    9 IF(NH1.GE.7)GO TO 2006
      WRITE(6,2005) (IN1(MM),MM=1,7)
 2005 FORMAT(1H /2X,'THETA',3X,'  TH ',6X,' EX    10**',I3
     1             ,6(8X,'10**',I3))
      GO TO 2007
 2006 WRITE(6,2008) NH1
 2008 FORMAT(///1H ,'******* ERROR IN FIGLG2 ---- NHANI1 > 6 OR <= 0'
     1                      /1H ,33X,'NHANI1=',I3)
      RETURN
 2007 CONTINUE
C
      IF(NH2.LE.0)GO TO 2206
      IF(NH2.GE.2)GO TO 25
      WRITE(6,2200) (IN2(MM),MM=1,2)
 2200 FORMAT(1H ,2X,'     ',3X,'< * >',6X,'< + >',1X,'10**',I3
     1          ,93X,'10**',I3)
      GO TO 2207
   25 IF(NH2.GE.3)GO TO 26
      WRITE(6,2201) (IN2(MM),MM=1,3)
 2201 FORMAT(1H ,2X,'     ',3X,'< * >',6X,'< + > 10**',I3
     1          ,2(43X,'10**',I3))
      GO TO 2207
   26 IF(NH2.GE.4)GO TO 27
      WRITE(6,2202) (IN2(MM),MM=1,4)
 2202 FORMAT(1H ,2X,'     ',3X,'< * >',6X,'< + >  10**',I3
     1          ,3(23X,'10**',I3))
      GO TO 2207
   27 IF(NH2.GE.5)GO TO 28
      WRITE(6,2203) (IN2(MM),MM=1,5)
 2203 FORMAT(1H ,2X,'     ',3X,'< * >',6X,'< + > 10**',I3
     1          ,4(18X,'10**',I3))
      GO TO 2207
   28 IF(NH2.GE.6)GO TO 29
      WRITE(6,2204) (IN2(MM),MM=1,6)
 2204 FORMAT(1H ,2X,'     ',3X,'< * >',6X,'< + > 10**',I3
     1          ,5(13X,'10**',I3))
      GO TO 2207
   29 IF(NH2.GE.7)GO TO 2206
      WRITE(6,2205) (IN2(MM),MM=1,7)
 2205 FORMAT(1H ,1X,'     ',3X,'< * >',6X,'< + >  10**',I3
     1          ,6(8X,'10**',I3))
      GO TO 2207
 2206 WRITE(6,2208) NH2
 2208 FORMAT(///1H ,'******* ERROR IN FIGLG2 ---- NHANI2 > 6 OR <= 0'
     1                      /1H ,33X,'NHANI2=',I5)
      RETURN
CCCCCC
 2207 WRITE(6,3000)
      DL2= DLOG10(2.0D0)
      DL4= DLOG10(4.0D0)
      DL8= DLOG10(8.0D0)
      KB2=DL2*KOSU(NH1)+1.5000
      KB4=DL4*KOSU(NH1)+1.5000
      KB8=DL8*KOSU(NH1)+1.5000
      JMAX=101
CC
      DO 1000 IX=1,N,NDELT
      FF1= FUNC1(IX)
      FF2= FUNC2(IX)
      GG1=-100.0
      GG2=-100.0
      IF(FF1.GT.0.0D0) GG1=DLOG10(FF1)-NJOIX1
      IF(FF2.GT.0.0D0) GG2=DLOG10(FF2)-NJOIX2
      K1=GG1*KOSU(NH1)+1.5000
      K2=GG2*KOSU(NH2)+1.5000
      DO 10 J=1,JMAX
   10 MAP(J)= ' '
      DO 11 J=1,JMAX,KOSU(NH2)
   11 MAP(J)= ':'
      DO 12 J=1,JMAX,KOSU(NH1)
   12 MAP(J)= '|'
      IF(NH1.LE.2 .AND. NH1.EQ.NH2) THEN
         DO 13 MM=1,NH1
         MAP(KB2+KOSU(NH1)*(MM-1))= ':'
         MAP(KB4+KOSU(NH1)*(MM-1))= ':'
   13    MAP(KB8+KOSU(NH1)*(MM-1))= ':'
      END IF
      IF(K2.GE.1 .AND. K2.LE.101) MAP(K2)= '+'
      IF(K1.GE.1 .AND. K1.LE.101) MAP(K1)= '*'
C
      WRITE(6,2500) XX(IX),FUNC1(IX),FUNC2(IX),(MAP(J),J=1,101)
 1000 CONTINUE
CCC
      WRITE(6,3000)
      RETURN
 2500 FORMAT(1H ,F8.3,1PD11.4,D11.4,101A1)
 3000 FORMAT(1H ,30X,1H+,99('-'),1H+)
      END
CCC
CCC        ******** FIGLN2 ********
CCC
CCCCC      ***** F(X)=FACT*G(X)+CONST *****
CCCCC                       -1.0.GE.G(X).GE.+1.0
      SUBROUTINE FIGLN2(XX,NX,NDIM,NDELT,FUNC1,FACT1,CONST1,LCOND1,
     1                                   FUNC2,FACT2,CONST2,LCOND2)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION FUNC1(NDIM),FUNC2(NDIM),V1(5),V2(5),XX(NDIM)
      CHARACTER*1 MAP(101)
CCCCC
CCCCC LCOND>0---BOTH FACT AND CONST ARE GIVEN VALUES.
CCCCC LCOND=0---BOTH FACT AND CONST ARE SERCHED AUTOMATICALY.
CCCCC LCOND<0---FACT IS SERCHED AUTOMATICALY,CONST IS A GIVEN VALUES.
CCCCC LCOND1(2)=-999---CONST1(2)=CONST2(1),FACT1(2)=FACT2(1)
CCCCC  FACT=  0.0---ONE LINE BECOMES ZERO (OPTIMIZED).
CCCCC  FACT> 10.0---LEFT LINE BECOMES ZERO (FIXED).
CCCCC  FACT<-10.0---RIGHT LINE BECOMES ZERO (FIXED).
CCCCC
      N=NX
      FACX1=FACT1
      CONSX1=CONST1
      FACX2=FACT2
      CONSX2=CONST2
      IF(LCOND1.GT.0) GO TO 99
      IF(LCOND1.EQ.-999.AND.LCOND2.NE.-999) GO TO 299
  800 COEF1=0.8
CC800 COEF1=1.0
      DM1=FUNC1(1)
      IF(DABS(FACT1).LT.1.0D-5) DM1=0.0
      DM2=DM1
      MDELT=3*NDELT
      DO 801 MD=1,N,MDELT
      DM1=DMAX1(DM1,FUNC1(MD))
      DM2=DMIN1(DM2,FUNC1(MD))
  801 CONTINUE
      DM11=DM1
      DM12=DM2
      IF(LCOND1.EQ.-999.AND.LCOND2.EQ.-999) GO TO 900
  802 CONTINUE
      IF(FACT1.GT.10.0) GO TO 841
      IF(FACT1.LT.-10.0) GO TO 840
      IF(DM1*DM2.LE.0.0) GO TO 810
      IF(LCOND1.EQ.0.OR.LCOND1.EQ.-999) GO TO 820
      DMF1=DABS(DM1-CONSX1)
      DMF2=DABS(DM2-CONSX1)
      FACX1=DMAX1(DMF1,DMF2)/COEF1
      GO TO 99
  810 IF(DABS(DM1).LT.1.0D-20) GO TO 840
      IF(DABS(DM2).LT.1.0D-20) GO TO 841
      DMR=-DM1/DM2
      IF(DMR.GE.3.0) GO TO 850
      IF(DMR.GE.2.0) GO TO 851
      IF(DMR.GE.0.5) GO TO 852
      IF(DMR.GE.(1.0/3.0)) GO TO 853
      FACX1=-DM2*2.0/(3.0*COEF1)
      CONSX1=-FACX1/2.0
      GO TO 99
  850 FACX1=DM1*2.0/(3.0*COEF1)
      CONSX1=FACX1/2.0
      GO TO 99
  851 CONSX1=-DM2/COEF1
      FACX1=-DM2*2/COEF1
      GO TO 99
  852 CONSX1=0.0
      FACX1=DMAX1(DM1,-DM2)/COEF1
      GO TO 99
  853 CONSX1=-DM1/COEF1
      FACX1=DM1*2/COEF1
      GO TO 99
  820 CONSX1=(DM1+DM2)/2.0
      FACX1=(DM1-CONSX1)/COEF1
      GO TO 99
  840 CONSX1=DM2/(2*COEF1)
      FACX1=-CONSX1
      GO TO 99
  841 CONSX1=DM1/(2*COEF1)
      FACX1=CONSX1
      GO TO 99
CCC
   99 CONTINUE
      IF(LCOND2.EQ.-999) GO TO 222
  299 IF(LCOND2.GT.0) GO TO 999
  900 COEF2=0.8
CC900 COEF2=1.0
      DM1=FUNC2(1)
      IF(DABS(FACT2).LT.1.0D-5) DM1=0.0
      DM2=DM1
      DO 901 MD=1,N,MDELT
      DM1=DMAX1(DM1,FUNC2(MD))
      DM2=DMIN1(DM2,FUNC2(MD))
  901 CONTINUE
      DM21=DM1
      DM22=DM2
      IF(LCOND1.EQ.-999.AND.LCOND2.EQ.-999) GO TO 9999
      IF(FACT2.GT.10.0) GO TO 941
      IF(FACT2.LT.-10.0) GO TO 940
      IF(DM1*DM2.LE.0.0) GO TO 910
      IF(LCOND2.EQ.0.OR.LCOND2.EQ.-999) GO TO 920
      DMF1=DABS(DM1-CONSX2)
      DMF2=DABS(DM2-CONSX2)
      FACX2=DMAX1(DMF1,DMF2)/COEF2
      GO TO 999
  910 IF(DABS(DM1).LT.1.0D-20) GO TO 940
      IF(DABS(DM2).LT.1.0D-20) GO TO 941
      DMR=-DM1/DM2
      IF(DMR.GE.3.0) GO TO 950
      IF(DMR.GE.2.0) GO TO 951
      IF(DMR.GE.0.5) GO TO 952
      IF(DMR.GE.(1.0/3.0)) GO TO 953
      FACX2=-DM2*2.0/(3.0*COEF2)
      CONSX2=-FACX2/2.0
      GO TO 999
  950 FACX2=DM1*2.0/(3.0*COEF2)
      CONSX2=FACX2/2.0
      GO TO 999
  951 CONSX2=-DM2/COEF2
      FACX2=-DM2*2/COEF2
      GO TO 999
  952 CONSX2=0.0
      FACX2=DMAX1(DM1,-DM2)/COEF2
      GO TO 999
  953 CONSX2=-DM1/COEF2
      FACX2=DM1*2/COEF2
      GO TO 999
  920 CONSX2=(DM1+DM2)/2.0
      FACX2=(DM1-CONSX2)/COEF2
      GO TO 999
  940 CONSX2=DM2/(2*COEF2)
      FACX2=-CONSX2
      GO TO 999
  941 CONSX2=DM1/(2*COEF2)
      FACX2=CONSX2
      GO TO 999
 9999 DM1=DMAX1(DM11,DM21)
      DM2=DMIN1(DM12,DM22)
      GO TO 802
CCCCC
  999 CONTINUE
      IF(LCOND1.NE.999) GO TO 111
      FACX1=FACX2
      CONSX1=CONSX2
      GO TO 111
CCCCC
  222 CONSX2=CONSX1
      FACX2=FACX1
      GO TO 111
CCCCC
  111 CONTINUE
      DO 100 M=1,5
      V1(M)=(0.5*M-1.5)*FACX1+CONSX1
      V2(M)=(0.5*M-1.5)*FACX2+CONSX2
  100 CONTINUE
      WRITE(6,1000) (V1(J),J=1,5),(V2(L),L=1,5)
      WRITE(6,3000)
CCCCCCC
  205 DO 200 I=1,N,NDELT
      AI=(FUNC1(I)-CONSX1)/FACX1
      IF(AI.GE.0.000) THEN
         K1=AI/0.02 +0.5000 +51
      ELSE
         K1=DABS(AI)/0.02 +0.5000
         K1=51-K1
      END IF
C
      AIP=(FUNC2(I)-CONSX2)/FACX2
      IF(AIP.GE.0.000) THEN
         K2=AIP/0.02 +0.5000 +51
      ELSE
         K2=DABS(AIP)/0.02 +0.5000
         K2=51-K2
      END IF
C
      DO 30 J=1,101
   30 MAP(J)= ' '
      DO 31 J=1,101,25
   31 MAP(J)= '|'
      IF(K2.GE.1 .AND. K2.LE.101) MAP(K2)= '+'
      IF(K1.GE.1 .AND. K1.LE.101) MAP(K1)= '*'
C
      WRITE(6,2000) XX(I),FUNC1(I),FUNC2(I),(MAP(J),J=1,101)
  200 CONTINUE
CCC
      WRITE(6,3000)
 1000 FORMAT(1H /1H ,1X,'THETA',3X,'< TH >',3X,'< EX >'
     1              ,2X,F9.3,15X,F9.3,3(16X,F9.3)
     2 /3X,'   ',4X,'< ** >',3X,'< ++ >',2X,F9.3,15X,F9.3,3(16X,F9.3))
 2000 FORMAT(1H ,1X,F7.3,1X,1PD10.3,1X,D10.3,2X,101A1)
 3000 FORMAT(1H ,32X,1H+,4(24('-'),1H+))
      RETURN
      END
CCC
CCC        ***** FOPEN *****
CCC
      SUBROUTINE FOPEN
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER FNAME*50,STA*8,COMM*60,OFF*1
C ==========================================
C --- UNIT-5 ---
C     WRITE(*,100)
C 100 FORMAT(//1H ,'>>> Input File-Name of Unit 5 ==> ',$)
C     READ(*,'(A)') FNAME

C     OPEN(5,FILE=FNAME,STATUS='OLD')

C --- OTHER UNITS ---
      READ(5,'(A)') COMM
      WRITE(*,200) COMM
  200 FORMAT(/1H ,'---- (Comment in File) ----'
     1       /1H ,' << ',A,' >>'
     2      //1H ,'---- (  Open  Files  ) ----'
     3      //1H ,'  Unit  Status      File-Name')

    1 READ(5,300) OFF,IUNIT,STA,FNAME
  300 FORMAT(A1,I3,1X,A8,2X,A50)
       IF(OFF.NE.' ') GO TO 1
       IF(IUNIT.GE.100 .OR. IUNIT.LT.0) GO TO 900
       WRITE(*,310) IUNIT,STA,FNAME
  310  FORMAT(1H ,3X,I2,3X,A,3X,A)
       OPEN(IUNIT,FILE=FNAME,STATUS=STA)
      GO TO 1

C --- ONE MORE LINE FOR DISCRIMINATION ---
  900 READ(5,'(A)') COMM
      RETURN
      END
CCC
CCC        ***** FOPEN2 *****
CCC
      SUBROUTINE FOPEN2
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER FNAME*50,STA*8,COMM*65
C ==========================================
      LINE=0
      KSWFIL=0

 1111 READ(5,'(A)') COMM
      LINE=LINE+1

      IF(COMM(1:1).EQ.'-') GOTO 900

      IF(COMM(1:1).NE.' ') THEN
         IF(LINE.EQ.1) WRITE(*,200)
  200      FORMAT(/1X,'---- (Comment in File) ----')
         WRITE(*,201) COMM
  201      FORMAT(5X,A)
      ELSE
         IF(KSWFIL.EQ.0) WRITE(*,210)
  210      FORMAT(/1X,'---- (  Open  Files  ) ----'
     1            /1X,'  Unit  Status      File-Name')
         KSWFIL=KSWFIL+1
         READ(COMM,300) IUNIT,STA,FNAME
  300      FORMAT(1X,I3,1X,A8,2X,A50)
         IF(IUNIT.GE.100 .OR. IUNIT.LT.0) GO TO 1111
         WRITE(*,310) IUNIT,STA,FNAME
  310      FORMAT(1X,3X,I2,3X,A,3X,A)
         OPEN(IUNIT,FILE=FNAME,STATUS=STA)
      ENDIF

      GO TO 1111

  900 CONTINUE
      RETURN
      END
CCC
CCC        ***** CLOCKM *****
CCC            CPU TIMER FOR EPCF77 (SUN)
CCC
      SUBROUTINE CLOCKM(ITIME)
      DIMENSION TIME(2)
      T=ETIME(TIME)
      ITIME=TIME(1)*1000 +0.5
      RETURN
      END
CCC
CCC        ***** FILOUT *****
CCC
      SUBROUTINE FILOUT(CMREAD)
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER CMREAD*40

      COMMON /CONTRL/ KSERCH,KAISMX,DCHIMN,INTGWF,KRUTAB,KCHISQ,KTXNOR
     1               ,KTLOUT,KFLOUT
      COMMON /BASIC/ PMASS,TMASS,PZZ,TZZ,PSPIN,TSPIN
     1              ,ELAB,ECM,FKAY,ETA,ZZHCAL,FFMM,DDRR,NRMAX
     2              ,LMAX,NTHMAX,IDENT
      COMMON /PARA/ PARM,PARMNX,NSPMAX,NPARMX,KTPARA,KPREIM,KSPLJD
      COMMON /XSPL/ THETAD,AXTH,RXTH,XSEX,DXEX,POLTH,POLEX,DPEX,REACX
      COMMON /CHIXP/ XCHI,PCHI,XCHIT,PCHIT,CHISQT
      COMMON /POTPAR/ V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI
     1               ,V2R0A,VDR0A,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX
     2               ,V0R0A2,W0R0A2,KSOTYP,KNXTYP
      COMMON /POTEN/ UCE,USO,ULJ,VCL,FLJFAC
      COMMON /POTFLD/ VFOLD,WFOLD,VSFOLD,WSFOLD
      COMMON /TENSOR/TPOL,TANL
      COMMON /DIMNSN/ NPARDM,NRDIM,NTHDIM,NTHDMP
     1               ,LDIM,MDIM,NUEDM1,NUEDM2,NJDIM
C
      DIMENSION KTLOUT(18),KFLOUT(12)
      DIMENSION PARM(50),PARMNX(50,3)
     1         ,KTPARA(20,50),KPREIM(50),KSPLJD(20)
      DIMENSION THETAD(245),AXTH(245),RXTH(245),XSEX(241),DXEX(241)
     1         ,POLTH(245),POLEX(241),DPEX(241)
      DIMENSION XCHI(241),PCHI(241),CHISQT(2)
      DIMENSION V0R0A(3,2),W0R0A(3,2),WDR0A(3,2),R0COUL(2)
     1         ,VSR0A(3,2),WSR0A(3,2),FNRNI(2,2),V2R0A(3,2),VDR0A(3,2)
     2         ,FL0AL(2,2),VLDR0A(3,2),WLDR0A(3,2),FSNRNI(2,2),FNXSEX(2)
     3         ,V0R0A2(3,2),W0R0A2(3,2),KSOTYP(2)
      COMPLEX*16 UCE(504),USO(504),ULJ(504)
      DIMENSION VCL(504),FLJFAC(206)
      DIMENSION VFOLD(504),WFOLD(504),VSFOLD(504),WSFOLD(504)
      DIMENSION TPOL(245, 4),TANL(245, 4)
CCC ================================================================

C --- write cross section  & polarization -----
      IF(KFLOUT(1).LE.0) GOTO 2000
      KOUT=KFLOUT(1)
      KPOT=1

      CALL PROOUT(KOUT,CMREAD,KPOT)

 1000 IF(KCHISQ.LE.0) GO TO 1200
      WRITE(KOUT,100)
  100 FORMAT(8X,'===== X-section (mb/sr) & Poralization (%) ====='
     1     /'   Theta',2X,'  abs-XS (TH) ','  XS/RutX (TH)'
     2     ,'   Xsec (EX)  ','  del-X (EX)'
     3     ,'   Pol (TH) ','   Pol (EX) ','  d-Pol (EX)')
      WRITE(KOUT,110) (THETAD(IT),AXTH(IT),RXTH(IT),XSEX(IT),DXEX(IT)
     1     ,POLTH(IT),POLEX(IT),DPEX(IT),IT=1,NTHMAX)
  110 FORMAT(1X,F8.3,1X,1P3D14.6,D12.4,0P3F12.6)
      GO TO 2000
C
 1200 CONTINUE
      WRITE(KOUT,130)
  130 FORMAT(3X,'===== X-section (mb/sr) & Poralization (%) ====='
     1     /'   Theta',2X,'  abs-XS (TH) ','  XS/RutX (TH)'
     2     ,'   Pol (TH) ')
      WRITE(KOUT,140) (THETAD(IT),AXTH(IT),RXTH(IT)
     1                ,POLTH(IT),IT=1,NTHMAX)
  140 FORMAT(1X,F8.3,1X,1P2D14.6,0PF12.6)
C
 2000 CONTINUE
C
C --- write tensor polarization & analyzing powers ---
      IF(KFLOUT(2).LE.0) GO TO 3000
      IF(DABS(PSPIN).LE.0.1) GO TO 3000
C
      KOUT=KFLOUT(2)
      KPOT=1

      IF(KOUT.NE.KFLOUT(1)) CALL PROOUT(KOUT,CMREAD,KPOT)

      FACT= DSQRT( 2*(PSPIN+1.0D0) /(3*PSPIN) )
      D2= DSQRT(2.0D0)
      D3= DSQRT(3.0D0)

      WRITE(KOUT,210)
  210 FORMAT(8X,'=====  Tensor Polarization ====='
     1     /2X,'  Theta ' ,2X,'  it11P  ',1X,'   t20P  '
     2         ,1X,'   t21P  ',1X,'   t22P  ')
      DO 211 IT=1,NTHMAX
      WRITE(KOUT,212) THETAD(IT),(TPOL(IT,K),K=1,4)
  212 FORMAT(2X,F8.3,2X,4(F9.6,1X),1X,5(F9.6,1X))
  211 CONTINUE
C
      WRITE(KOUT,220)
  220 FORMAT(8X,'=====  Tensor Analayzing Power  ====='
     1     /2X,'  Theta ' ,2X,'  iT11A  ',1X,'   T20A  '
     2         ,1X,'   T21A  ',1X,'   T22A  '
     3         ,2X,'   Ay    ',1X,'   Ayy   '
     4         ,1X,'   Axx   ',1X,'   Axz   ',1X,'   X2    ')
      DO 221 IT=1,NTHMAX
      AY= TANL(IT,1)*FACT
      AYY= -TANL(IT,4)*D3 -TANL(IT,2)/D2
      AXX=  TANL(IT,4)*D3 -TANL(IT,2)/D2
      AXZ= -TANL(IT,3)*D3
      AX2= (2*AXX+AYY)/D3
      WRITE(KOUT,212) THETAD(IT),(TANL(IT,K),K=1,4)
     1            ,AY,AYY,AXX,AXZ,AX2
  221 CONTINUE
C
 3000 CONTINUE
C
C --- write potential parameters---
      IF(KFLOUT(3).LE.0) GO TO 4000
C
      KOUT=KFLOUT(3)
      KPOT=1

      IF(KOUT.NE.KFLOUT(1) .AND. KOUT.NE.KFLOUT(2)) 
     1         CALL PROOUT(KOUT,CMREAD,KPOT)

C --- write final potential ---
      DR=DDRR
      KNTLPV= 1
      IIFF= 2
      KAKPOT=0
C
      CALL PVCHNG(KNTLPV,IIFF,PARM,NPARDM
     1    ,V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI,V2R0A,VDR0A
     2    ,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX,V0R0A2,W0R0A2)
C
      CALL POTGEN(PMASS,TMASS,ZZHCAL,DR,NRMAX,LMAX,KAKPOT,KSOTYP
     1           ,PARM,VFOLD,WFOLD,VSFOLD,WSFOLD, NRDIM,NPARDM,LDIM
     2                                  ,UCE,USO,ULJ,VCL,FLJFAC)
C
      WRITE(KOUT,350)
  350 FORMAT(10X,'--- Potential ( Nuclear & Coulomb ) ---'
     1      /'    RR  ',2X,'   VCE       ','   WCE       '
     2        ,'   VSO       ','   WSO       ','   VCL       ')
      DO 351 IR=1,NRMAX
       RRR= DR*(IR-1)
       WRITE(KOUT,352) RRR,UCE(IR),USO(IR),VCL(IR)
  352  FORMAT(F8.3,2X,1P5D13.5)
  351 CONTINUE

 4000 CONTINUE
      RETURN
      END
CCC
CCC        ***** PROOUT *****
CCC
      SUBROUTINE PROOUT(KOUT,CMREAD,KPOT)
      IMPLICIT REAL*8(A-H,O-Z)
      CHARACTER CMREAD*40

      COMMON /BASIC/ PMASS,TMASS,PZZ,TZZ,PSPIN,TSPIN
     1              ,ELAB,ECM,FKAY,ETA,ZZHCAL,FFMM,DDRR,NRMAX
     2              ,LMAX,NTHMAX,IDENT
      COMMON /POTPAR/ V0R0A,W0R0A,WDR0A,R0COUL,VSR0A,WSR0A,FNRNI
     1               ,V2R0A,VDR0A,FL0AL,VLDR0A,WLDR0A,FSNRNI,FNXSEX
     2               ,V0R0A2,W0R0A2,KSOTYP,KNXTYP
      DIMENSION V0R0A(3,2),W0R0A(3,2),WDR0A(3,2),R0COUL(2)
     1         ,VSR0A(3,2),WSR0A(3,2),FNRNI(2,2),V2R0A(3,2),VDR0A(3,2)
     2         ,FL0AL(2,2),VLDR0A(3,2),WLDR0A(3,2),FSNRNI(2,2),FNXSEX(2)
     3         ,V0R0A2(3,2),W0R0A2(3,2),KSOTYP(2)
C
      CHARACTER*2 NAMEP,NAMET
      CHARACTER*6 SOTYP(2)/'Thomas','WS-der'/
CCCCC ===================================================

C --- write profile -----
      CALL ELEMNT(PMASS,TMASS,PZZ,TZZ,   MP,MT,NAMEP,NAMET)

      WRITE(KOUT,10) CMREAD,PMASS,PZZ,TMASS,TZZ,ELAB
     1              ,NAMEP,MP,NAMET,MT
   10 FORMAT(2X,'<< Output from ALPS >>',A
     1      /5X,'PMASS, PZZ=',F7.2,F6.2,'  TMASS, TZZ=',F7.2,F6.2
     2      /5X,'ELAB=',F10.3,' --- ',A2,'(',I3,') + ',A2,'(',I3,')')

C --- write potential parameters ------
      IF(KPOT.LE.0) GOTO 900

      WRITE(KOUT,300)
  300 FORMAT(5X,'=====  Final Potential Parameters =====')
      VWCHK= V0R0A(1,1)**2 +W0R0A(1,1)**2 +WDR0A(1,1)**2
      IF(VWCHK.GT.1.0D-20) THEN
        WRITE(KOUT,301) (V0R0A(I,2),I=1,3)
     1                 ,(W0R0A(I,2),I=1,3),(WDR0A(I,2),I=1,3)
  301   FORMAT('   V0 ,r0V ,aV =',3F12.6
     1        /'   W0 ,r0W0,aW0=',3F12.6
     2        /'   WD ,r0WD,aWD=',3F12.6)
      ENDIF

      WRITE(KOUT,302) R0COUL( 2)
  302 FORMAT('       r0CL    =',F12.6)

      VWCHK= VSR0A(1,1)**2 +WSR0A(1,1)**2
      IF(VWCHK.GT.1.0D-20) THEN
        WRITE(KOUT,303) (VSR0A(I,2),I=1,3),SOTYP(KSOTYP(1)+1)
     1                 ,(WSR0A(I,2),I=1,3),SOTYP(KSOTYP(2)+1)
  303   FORMAT('   VLS,r0RS,aRS=',3F12.6,'  -- ',A6,' form'
     1        /'   WLS,r0IS,aIS=',3F12.6,'  -- ',A6,' form')
      ENDIF

      VWCHK= FNRNI(1,1)**2 +FNRNI(1,2)**2
      IF(VWCHK.GT.1.0D-20) THEN
        WRITE(KOUT,304) (FNRNI( I, 2),I=1,2)
  304   FORMAT('   NR ,NI      =',2F14.8)
      ENDIF

      VWCHK= V2R0A(1,1)**2
      IF(VWCHK.GT.1.0D-20) THEN
        WRITE(KOUT,305) (V2R0A(I,2),I=1,3)
  305   FORMAT('   V2,r0R2,aR2=',3F12.6)
      ENDIF

      VWCHK= VDR0A(1,1)**2
      IF(VWCHK.GT.1.0D-20) THEN
        WRITE(KOUT,306) (VDR0A(I,2),I=1,3)
  306   FORMAT('   VD,r0RD,aRD=',3F12.6)
      ENDIF

      VWCHK= VLDR0A(1,1)**2 +WLDR0A(1,1)**2
      IF(VWCHK.GT.1.0D-20) THEN
        WRITE(KOUT,307) (FL0AL(I,2),I=1,2)
     1            ,(VLDR0A(I,2),I=1,3),(WLDR0A(I,2),I=1,3)
  307   FORMAT('       FL0,  aL  =',3F12.6
     1        /'   VLD,r0RLD,aRLD=',3F12.6
     2        /'   WLD,r0ILD,aILD=',3F12.6)
      ENDIF

      VWCHK= FSNRNI(1,1)**2 +FSNRNI(1,2)**2
      IF(VWCHK.GT.1.0D-20) THEN
        WRITE(KOUT,308) (FSNRNI( I, 2),I=1,2)
  308   FORMAT('   NRS,NIS     =',2F14.8)
      ENDIF

      VWCHK= V0R0A2(1,1)**2 +W0R0A2(1,1)**2
      IF(VWCHK.GT.1.0D-20) THEN
        WRITE(KOUT,309) (V0R0A2(I,2),I=1,3),(W0R0A2(I,2),I=1,3)
  309   FORMAT('   V02,r0V02,aV02=',3F12.6
     1        /'   W02,r0W02,aW02=',3F12.6)
      ENDIF

  900 RETURN
      END
